*************************************************************
*************************************************************
**  THEORETICAL ISOCHRONES WITH AN IMPROVED TP-AGB PHASE   **
**  June 22, 2006                                          **
**  Containing the isochrones used by Cioni et al. 2006ab  **
*************************************************************
*************************************************************

The present tarfile (isoc_cgmh06.tar.gz) contains the isochrone files
used in the papers

 Cioni, M.-R. L., Girardi, L., Marigo, P., & Habing, H. J. 2006,
 Astronomy and Astrophysics 448, 77, AGB stars in the Magellanic
 Clouds. II. The rate of star formation across the LMC

 Cioni, M.-R. L., Girardi, L., Marigo, P., & Habing, H. J. 2006,
 Astronomy and Astrophysics 452, 195, AGB stars in the Magellanic
 Clouds. III. The rate of star formation across the Small Magellanic
 Cloud

These isochrones are for 6 different values of initial metallicity,
and are in a format very similar to the one used by:

 "Theoretical isochrones in several photometric systems
 I. Johnson-Cousins-Glass, HST/WFPC2, HST/NICMOS, Washington, and ESO
 Imaging Survey filter sets" by L. Girardi, G. Bertelli, A. Bressan,
 C. Chiosi, M.A.T. Groenewegen, P. Marigo, B. Salasnich, and A. Weiss,
 2002, Astronomy & Astrophysics, 391, 195.

(see also http://pleiadi.pd.astro.it/isoc_photsys.02.html) with two
important additions:

- The column "C/O" gives the surface carbon-to-oxygen number ratio,
which is useful to identify C-type stars (those with C/O>1). For the
pre-TP-AGB evolution, the C/O ratio is set to the solar value in
Girardi et al. 2000 tracks, i.e. 0.479.

- The column "McTPAGB" givs the core mass during the TP-AGB phase, in
solar masses. It is set to 0.0 for all pre-TPAGB stages. This quantity
may be used to identify and to simulate, a posteriori, the pulse cycle
luminosity and Teff variations that occur during the TP-AGB. The
procedure will be detailed in future papers, and is briefly outlined
in

 Marigo, P., Girardi, L., & Chiosi, C. 2003, Astronomy and
 Astrophysics 403, 225, The red tail of carbon stars in the LMC:
 Models meet 2MASS and DENIS observations.

The photometric system is the Johnson-Cousin-Glass UBVRIJHK as
standardized by Bessell and Bessell & Brett, at least for all O-rich
stars (i.e. excluding the brief C-type phase). All details about the
transformation to this system are provided in Girardi et al. (2002).

For C-rich stars, instead, the J and K magnitudes are given by
semi-empirical BC and Teff-colour transformations suitable for
C-stars, as described in the above-mentioned papers (Marigo et
al. 2003, and Cioni et al. 2006ab).

Future releases of "TP-AGB improved" isochrones will include other
photometric systems as well.

************************************************************
TABLES OF ISOCHRONES
************************************************************

The following isochrone files are available:

------------------------------------------------------------------
FILENAME			COMPOSITION		REFERENCE*
------------------------------------------------------------------
isoc_cgmh06/isoc_z0004.dat	[Z=0.0004, Y=0.230]	Gi00+Be94
isoc_cgmh06/isoc_z001.dat	[Z=0.001, Y=0.230]	Gi00+Gi01
isoc_cgmh06/isoc_z004.dat	[Z=0.004, Y=0.240]	Gi00+Be94
isoc_cgmh06/isoc_z008.dat	[Z=0.008, Y=0.250]	Gi00+Be94
isoc_cgmh06/isoc_z019.dat	[Z=0.019, Y=0.273]	Gi00+Be94
isoc_cgmh06/isoc_z030.dat	[Z=0.030, Y=0.300]	Gi00
------------------------------------------------------------------
*Note: the REFERENCE column refers only to the pre-TP-AGB tracks. 
The TP-AGB tracks are described in Marigo et al. (2003), and in
Cioni et al. (2006ab).

Users are _strongly_ encouraged to refer to the original papers,
listed in the last column above, for information about the pre-TP-AGB
phases, and about massive stars.

Each file contains a complete series of isochrones with log(age/yr)
values at equally spaced intervals of Delta(log age)=0.05 (i.e., two
consecutive isochrones differ by just 12 percent in their ages.)

Each one of these files contains
HEADER LINE: with the exact age and metallicity value of 
	the isochrone;
followed by 117 columns with:
Column (1)  log(age/yr) --> logarithm of the age (in yr);
Column (2)  M_ini --> initial mass of the star (in solar units);
Column (3)  M_act --> actual mass of the star, i.e., the mass 
	obtained considering the previous history of mass-loss;
Column (4)  logL/Lo --> logarithm of surface luminosity (in solar 
	units), log(L/Lsun);
Column (5)  logTef --> logarithm of effective temperature (in K), 
	log(Teff/K);
Column (6)  logG --> logarithm of surface gravity (in cgs units);
Column (7)  Mbol --> absolute bolometric magnitude;
Columns (8) to (15)  --> absolute magnitude in UBVRIJHGK pass-bands;
Column (16) C/O --> surface carbon-to-oxygen number ratio;
Column (17) McTPAGB --> core mass during the TP-AGB phase, in Msun.

************************************************************
REFERENCES
************************************************************

(A more complete list can be found in the A&A papers mentioned above.)

Bertelli G., Bressan A., Chiosi C., Fagotto F., Nasi E., 1994, 
	 A&AS 106, 275 (Be94)
Girardi L., Bressan A., Bertelli G., Chiosi C., 2000, A&AS 141, 371 
	(Gi00)
Girardi L., 2001, unpublished tracks (Gi01)
Kroupa P., 2001, MNRAS 322, 231
Marigo P., Girardi L., 2001, A&A 377, 132 (MG01)

program sim

  ! Creates a simulated cluster CMD.

  use define_star
  use quad
  use cmdfit_subs

  implicit none

  type(a_star) :: star

  ! First set up the uncertainties to be used in each colour.  icorr is 
  ! between the errors.  Allowed values are:
  ! icorr =  1, for a CMD such as V, V-I;
  ! icorr = -1, for a CMD such as B, U-B;
  ! icorr =  0, gives you uncorrelated errors.
  ! The algebra is set up so that the uncertainties you supply are the total 
  ! uncertainty ignoring correlation (i.e. what most people quote).
  ! This means that for any icorr other than zero, the uncertainty in 
  ! magnitude must be less than that in colour.
  integer :: icorr=0

  ! There are two ways to set up the uncertainties.  Choose which by
  ! setting this logical.
  logical, parameter :: fixed_uncer = .true.
  ! If this is set true, the uncertainties are equal for all data points, 
  ! and set by these two parameters.
  real, parameter :: fix_col_err=0.008, fix_mag_err=0.01
  ! Otherwise the magnitude uncertainty is taken to be of the form
  ! sqrt(mag_ind**2.0 (norm_10*10.0**(mag_norm*(true_mag-mag_shift)))**2.0),
  ! where mag_ind is a magnitude independent uncertainty which dominates at
  ! bright magnitudes, norm_10 and mag_norm are normalisation terms for
  ! what amounts to s sky-limit term, and mag_shift indicates at what 
  ! magnitude the sky noise begins to dominate.
  ! real, parameter :: mag_ind=0.005, norm_10=0.03, mag_norm=0.3, mag_shift=11.5
  real, parameter :: mag_ind=0.01, norm_10=0.03, mag_norm=0.4, mag_shift=9.5
  ! Finally, the uncertainty in colour is taken to be a constant times this.
  real, parameter :: col_ratio=1.3
  real :: col_err, mag_err
  integer :: iband, iminus
  real :: age, dm, low_mass, up_mass

  integer :: istar, i
  real :: col, mag
  real :: true_col, true_mag
  real :: harvest
  real, external :: rnd_gauss
  character(len=50) :: ofname
  real :: v_err, i_err
  integer :: multiplicity
  integer :: imodel, icol
  real :: binary_fraction
  integer :: nstars
  real :: p_mass, p_teff
  character(len=20) :: flag
  real :: delta_b, delta_v
  real, parameter :: ubv_uncer=0.02

  print*, 'The available models are as follows.'
  do i=1, n_models
    if (len_trim(mod_name(i)) > 0) print*, i, trim(mod_name(i))
  end do
  print*, 'What model number do you want?'
  read(*,*) imodel

  print*, 'The available CMDs are '
  do i=1, n_names
    if (len_trim(mag_name(i)) > 0) &
    print*, i, trim(mag_name(i)), ' vs ', trim(col_name(i)), &
    '   ('//trim(pht_comm(i))//')'
  end do
  print*, 'What colour number do you want?'
  read(*,*) icol

  print*, '> Give binary fraction.'
  read(*,*) binary_fraction

  print*, '> Give output catalogue file name.'
  read(*,*) ofname
  open(unit=3, file=ofname)
  if (icol == 15) then
    write(3,*) '3 colours were created'
    write(3,*) 'V', ' ', trim(mag_name(icol)), ' ', trim(col_name(icol))
    write(3,*)
  else
    write(3,*) '2 colours were created'
    write(3,*) trim(mag_name(icol)), ' ', trim(col_name(icol))
    write(3,*)
  end if

  print*, '> Give the required age (in log10 Myr).'
  read(*,*) age

  print*, '> Give the required distance modulus.'
  read(*,*) dm

  ! The range used in the Naylor and Jeffries paper was 0.36 1.9Mo
  print*, '> Give range of masses (low, high).'
  read(*,*) low_mass, up_mass

  ! The number of stars used in Naylor and Jeffries was 100.
  print*, 'How many stars do you want?'
  read(*,*) nstars

  ! Now lets sort out whether you add or subtract the colour from the
  ! magnitude to get the other magnitude.
  !iminus=index(col_name(icol), '-')
  !if (iminus == 0) then
  !  print*, 'Cannot find the minus sign in colour ', col_name(icol)
  !  stop
  !end if
  !iband=index(col_name(icol), trim(mag_name(icol)))
  !if (iband == 0) then
  !  print*, 'Cannot find the magnitude ', trim(col_name(icol)), &
  !  ' in the colour ', trim(col_name(icol))
  !  print*, 'So assuming the colours are uncorrelated.'
  !  icorr=0
  !else if (iband > iminus) then
  !  print*, 'Will add ', trim(mag_name(icol)), ' to ', trim(col_name(icol)), &
  !  ' to create ', col_name(icol)(1:iminus-1)
  !  icorr = -1
  !else
  !  print*, 'Will subtract ', trim(col_name(icol)), ' from ', &
  !  trim(mag_name(icol)), &
  !  ' to create ', trim(col_name(icol)(iminus+1:len(col_name(icol))))
  !  icorr = 1
  !end if

  open(unit=21, file='sim.iso')
  write(21,*) 'Columns are color, mag, primary mass, flag and multiplicity.'
  write(21,*)
  write(21,*)

  do istar=1, nstars

     call random_seed()
     call random_number(harvest)
     if (harvest < binary_fraction) then
       multiplicity=2
     else
       multiplicity=1
     end if

10   call make_star(age, icol, imodel, low_mass, up_mass, -0.35, &
     multiplicity, true_mag, true_col, p_mass, p_teff, flag)

     write(21,*) true_col, true_mag, p_mass, trim(flag), multiplicity
     if (trim(flag) /= 'OK') then
       print*, 'Star ', istar, ' of mass ', p_mass, ' has flag ', trim(flag)
       print*, 'Trying again.'
       goto 10
     end if

     if (icol == 15) then

       delta_b=rnd_gauss(0.0, ubv_uncer)
       delta_v=rnd_gauss(0.0, ubv_uncer)

       star%col(1)%data= v_for_ubv()+delta_v
       star%col(1)%err = ubv_uncer
       star%col(1)%flg = 'OO'

       star%col(2)%data= true_mag+delta_b-delta_v
       star%col(2)%err = ubv_uncer
       star%col(2)%flg = 'OO'

       star%col(3)%data= true_col+rnd_gauss(0.0, ubv_uncer)-delta_b
       star%col(3)%err = ubv_uncer
       star%col(3)%flg = 'OO'

       call write_star(3, star, 3)

     else

       ! Now, assume the CMD is of the form V vs V-I.  Then we must 
       ! correlate the uncertainties in the following way.
       ! First get the error in each magnitude.
       if (fixed_uncer) then
         mag_err=fix_mag_err
         col_err=fix_col_err
       else
         mag_err=sqrt(mag_ind**2.0 &
         + (norm_10*10.0**(mag_norm*(true_mag-mag_shift)))**2.0)
         col_err=col_ratio*mag_err
       end if
       v_err=rnd_gauss(0.0, mag_err)
       i_err=rnd_gauss(0.0, sqrt(col_err**2.0-(mag_err*real(icorr))**2.0))
       ! Now for the magnitude this is easy.
       mag=true_mag+v_err
       ! And for the colour.
       if (icorr == 0) then
         col=true_col+i_err
       else
         col=true_col+real(icorr)*(v_err-i_err)
       end if
       
       call zero_star(star)
 

       star%col(1)%data=mag+dm
       star%col(1)%err =mag_err
       star%col(1)%flg ='OO'
     
       star%col(2)%data=col
       star%col(2)%err =col_err
       star%col(2)%flg='OO'

     call write_star(3, star, 2)

   end if


   end do
   close(21)
   close(3)

end program sim
     

module phoenix_readfiles

  use quad

  implicit none

  ! The maximum number of gravities and temperatures.
  integer, parameter, public :: m_grav=13, m_teff=100
  type a_teff
    real, dimension(m_grav) :: logg
  end type a_teff
  type a_corr
    type(a_teff), dimension(m_teff) :: teff
  end type a_corr

contains

  subroutine readfiles(file, bc1, bc2, bc3, bc4, bc5, temp, grav, &
  n_teff, n_grav)

    ! Allows table of bolometric corrections to be read in.

    ! We make some assumptions about the file.
    ! 1) The file has records which have, in order, temperature, gravity and 
    !    bolometric corrections.
    ! 2) The gravities for all temperatures run from 5.5 downwards in steps
    !    of 0.5 (don't low they go). 

    character(len=*), intent(in) :: file
    type(a_corr), intent(inout) :: bc1, bc2, bc3, bc4, bc5
    real, dimension(m_teff), intent(inout) :: temp
    real, dimension(m_grav), intent(inout) :: grav
    integer, intent(inout) :: n_teff
    integer, dimension(m_teff), intent(inout) :: n_grav

    character(len=80), save :: lastfile=' '
    
    integer :: i, j, int_grav, int_temp, iostat, j_grav
    real :: col1_in, col2_in, col3_in, col4_in, col5_in
    real :: grav_in, temp_in, temp_safe

    real, dimension(m_grav) :: col_grav, work_grav
    integer :: k_grav
    character(len=20) :: flag, iflg
    character(len=30) :: data_dir

    if (trim(lastfile) == trim(file)) return

    lastfile=file

    ! Define the gravity array.
    grav(1)=5.5
    do i=2, m_grav
      grav(i)=grav(i-1)-0.5
    end do

    ! Find the number of different temperatures.
    call get_environment_variable('CMDDATA', data_dir)
    open(10, file=trim(data_dir)//file, action='read') 
    read(10,*)
    read(10,*)
    n_teff=1
    read(10,*) temp_safe
    do
      read(10,*,iostat=iostat) temp_in
      if (iostat < 0) exit
      if (nint(temp_in) /= nint(temp_safe) ) then
        n_teff=n_teff+1
        temp_safe=temp_in
      end if
    end do
    if (n_teff > m_teff) then
      print*, 'In s/r phoenix_bessell m_teff needs enlarging to ', n_teff
      stop
    end if
    rewind(10)
    read(10,*)
    read(10,*)
    read(10,*) temp(1)
    i=1
    do
      read(10,*) temp_in
      if (nint(temp_in) /= nint(temp(i))) then
        i=i+1
        temp(i)=temp_in
      end if
      if (i == n_teff) exit
    end do

    temp=log10(temp)

    rewind(10)
    read(10,*)
    read(10,*)
    n_grav=0
    do 
      read(10,*,iostat=iostat)  temp_in, grav_in, col1_in, col2_in, &
      col3_in, col4_in, col5_in
      if (iostat < 0) exit
      ! We work in log temperature.
      temp_in=log10(temp_in)
      ! Find the array indices most appropriate for the read temperature 
      ! and gravity.
      int_grav=minloc(abs(grav-grav_in),1)
      int_temp=minloc(abs(temp-temp_in),1)
      ! And fill those elements.
      bc1%teff(int_temp)%logg(int_grav)=col1_in
      bc2%teff(int_temp)%logg(int_grav)=col2_in
      bc3%teff(int_temp)%logg(int_grav)=col3_in
      bc4%teff(int_temp)%logg(int_grav)=col4_in
      bc5%teff(int_temp)%logg(int_grav)=col5_in
      ! But what about the unfilled elements?  Well, all temperatures have
      ! gravity 5.5, but not all go all the way to -0.5.  Fortunately the
      ! file puts them in the order 5.5, 5.0, 4.5 etc.  So if we just count
      ! the number of gravities at a given temperature, the total must be
      ! the number of elements filled.
      n_grav(int_temp)=n_grav(int_temp)+1
    end do

    close(10)

    !write(33,*) n_grav
    !do int_temp=1, n_teff
    !  do int_grav=1, m_grav
    !    write(33,*) temp(int_temp), grav(int_grav), &
    !         bc3%teff(int_temp)%logg(int_grav)
    !  end do
    !end do

  end subroutine readfiles

  type(a_corr) function subtract_corr(bc1, bc2, n_teff)

    type(a_corr), intent(in) :: bc1, bc2
    integer, intent(in) :: n_teff

    integer :: i_teff, i_grav

    subtract_corr = bc1
    do i_teff=1, n_teff
      do i_grav=1, m_grav
        subtract_corr%teff(i_teff)%logg(i_grav) = &
        bc1%teff(i_teff)%logg(i_grav) - bc2%teff(i_teff)%logg(i_grav)
      end do
    end do

  end function subtract_corr

  real function interp(grav_in, temp_in, col, grav, temp, n_teff, n_grav, flg)

    real, intent(in) :: grav_in, temp_in
    type(a_corr), intent(in) :: col
    real, dimension(:), intent(in) :: grav, temp
    integer, intent(in) :: n_teff
    integer, intent(in), dimension(:) :: n_grav
    character(len=*), intent(out) :: flg

    real, dimension(m_grav) :: col_grav, work_grav
    real, dimension(n_teff) :: col_temp, work_temp
    character(len=20) :: flag

    integer :: j_grav, k_temp, j_temp

    flg='OK'

    ! At each gravity, interpolate the bolometric correction at the
    ! appropriate temperature, to make an array at a fixed temperature
    ! but a range of gravities.
    !do j_grav=1, m_grav
    !  col_grav(k_grav+1)=quadint(temp(:), col%teff(:)%logg(j_grav), &
    !       temp_in, flag)
    !  work_grtav(k_grav+1)=grav(j_grav)
    !print*, gtrav(j_grav)
    !  k_grav=tk_grav+1
    !end do   t
    !if (k_gratv > 1) then
    !  interp=tquadint(work_grav(1:k_grav), col_grav(1:k_grav), grav_in, flag)
    !end if

    ! At each temperature, interpolate the bolometric correction at
    ! the appropriate gravity, to make an array at a fixed gravity
    ! with a range of temperatures.
    k_temp=0
    do j_temp=1, n_teff
      if (n_grav(j_temp) > 0) then
        col_temp(k_temp+1)=quadint(grav(1:n_grav(j_temp)), & 
             col%teff(j_temp)%logg(1:n_grav(j_temp)), grav_in, flag)
        !work_temp(j_temp)=grav(j_temp)
        if (flag == 'OK') then
          k_temp=k_temp+1
          work_temp(k_temp)=temp(j_temp)
          !print*, work_temp(k_temp), col_temp(k_temp)
        end if
      end if
    end do
    ! print*, grav_in, temp_in
    if (k_temp > 1) then
      interp=quadint(work_temp(1:k_temp), col_temp(1:k_temp), temp_in, flag)
      if (flag == '1') flg='1'
    else
      flg='1'
      interp=0.0
    end if

  end function interp

end module phoenix_readfiles


module phoenix

  use phoenix_readfiles

  implicit none

  ! Things read in from the data file.
  character(len=80), private, parameter :: bessell='/phoenix_ubv_Z_0.0.dat' 
  character(len=80), private, parameter :: sloan='/phoenix_sloan_bessell.dat'
  type(a_corr), save, private :: bc_u, bc_b, bc_g, bc_v, bc_r, bc_i, bc_z
  real, save, dimension(m_teff), private :: temp
  real, save, dimension(m_grav), private :: grav
  integer, save :: n_teff
  integer, save, dimension(m_teff), private :: n_grav

contains



  ! Functions to create colours from effective temperatures from 
  ! tabulated ones bolometric corections.

  real function phoenix_bess_bv(grav_in, temp_in, flg)

    real, intent(in) :: grav_in, temp_in
    character(len=*), intent(out) :: flg

    call readfiles(bessell, bc_u, bc_b, bc_v, bc_r, bc_i, temp, grav, &
    n_teff, n_grav)
    phoenix_bess_bv=interp(grav_in, temp_in, &
    subtract_corr(bc_v, bc_b, n_teff), grav, temp, n_teff, n_grav, flg)

  end function phoenix_bess_bv

  real function phoenix_bess_vi(grav_in, temp_in, flg)

    real, intent(in) :: grav_in, temp_in
    character(len=*), intent(out) :: flg

    call readfiles(bessell, bc_u, bc_b, bc_v, bc_r, bc_i, temp, grav, &
    n_teff, n_grav)
    phoenix_bess_vi=interp(grav_in, temp_in, &
    subtract_corr(bc_i, bc_v, n_teff), grav, temp, n_teff, n_grav, flg)

  end function phoenix_bess_vi
  
  real function phoenix_sloan_gi(grav_in, temp_in, flg)

    real, intent(in) :: grav_in, temp_in
    character(len=*), intent(out) :: flg

    call readfiles(sloan, bc_u, bc_g, bc_r, bc_i, bc_z, temp, grav, &
    n_teff, n_grav)
    phoenix_sloan_gi=interp(grav_in, temp_in, &
    subtract_corr(bc_i, bc_g, n_teff), grav, temp, n_teff, n_grav, flg)

  end function phoenix_sloan_gi

  real function phoenix_sloan_iz(grav_in, temp_in, flg)

    real, intent(in) :: grav_in, temp_in
    character(len=*), intent(out) :: flg

    call readfiles(sloan, bc_u, bc_g, bc_r, bc_i, bc_z, temp, grav, &
    n_teff, n_grav)
    phoenix_sloan_iz=interp(grav_in, temp_in, &
    subtract_corr(bc_z, bc_i, n_teff), grav, temp, n_teff, n_grav, flg)

  end function phoenix_sloan_iz



  ! Functions to create bolometric corrections from tabulated ones.
  real function phoenix_bess_u(grav_in, temp_in, flg)

    real, intent(in) :: grav_in, temp_in
    character(len=*), intent(out) :: flg

    call readfiles(bessell, bc_u, bc_b, bc_v, bc_r, bc_i, temp, grav, &
    n_teff, n_grav)
    phoenix_bess_u=interp(grav_in, temp_in, bc_u, grav, temp, n_teff, &
    n_grav, flg)

  end function phoenix_bess_u

  real function phoenix_bess_b(grav_in, temp_in, flg)

    real, intent(in) :: grav_in, temp_in
    character(len=*), intent(out) :: flg

    call readfiles(bessell, bc_u, bc_b, bc_v, bc_r, bc_i, temp, grav, &
    n_teff, n_grav)
    phoenix_bess_b=interp(grav_in, temp_in, bc_b, grav, temp, n_teff, &
    n_grav, flg)

  end function phoenix_bess_b

  real function phoenix_bess_v(grav_in, temp_in, flg)

    real, intent(in) :: grav_in, temp_in
    character(len=*), intent(out) :: flg

    call readfiles(bessell, bc_u, bc_b, bc_v, bc_r, bc_i, temp, grav, &
    n_teff, n_grav)
    phoenix_bess_v=interp(grav_in, temp_in, bc_v, grav, temp, n_teff, &
    n_grav, flg)

  end function phoenix_bess_v

  real function phoenix_bess_r(grav_in, temp_in, flg)

    real, intent(in) :: grav_in, temp_in
    character(len=*), intent(out) :: flg

    call readfiles(bessell, bc_u, bc_b, bc_v, bc_r, bc_i, temp, grav, &
    n_teff, n_grav)
    phoenix_bess_r=interp(grav_in, temp_in, bc_r, grav, temp, n_teff, &
    n_grav, flg)

  end function phoenix_bess_r

  real function phoenix_bess_i(grav_in, temp_in, flg)

    real, intent(in) :: grav_in, temp_in
    character(len=*), intent(out) :: flg

    call readfiles(bessell, bc_u, bc_b, bc_v, bc_r, bc_i, temp, grav, &
    n_teff, n_grav)
    phoenix_bess_i=interp(grav_in, temp_in, bc_i, grav, temp, n_teff, &
    n_grav, flg)

  end function phoenix_bess_i

  real function phoenix_sloan_u(grav_in, temp_in, flg)

    real, intent(in) :: grav_in, temp_in
    character(len=*), intent(out) :: flg

    call readfiles(sloan, bc_u, bc_b, bc_v, bc_r, bc_i, temp, grav, &
    n_teff, n_grav)
    phoenix_sloan_u=interp(grav_in, temp_in, bc_u, grav, temp, n_teff, &
    n_grav, flg)

  end function phoenix_sloan_u

  real function phoenix_sloan_g(grav_in, temp_in, flg)

    real, intent(in) :: grav_in, temp_in
    character(len=*), intent(out) :: flg

    call readfiles(sloan, bc_u, bc_b, bc_v, bc_r, bc_i, temp, grav, &
    n_teff, n_grav)
    phoenix_sloan_g=interp(grav_in, temp_in, bc_g, grav, temp, n_teff, &
    n_grav, flg)

  end function phoenix_sloan_g

  real function phoenix_sloan_r(grav_in, temp_in, flg)

    real, intent(in) :: grav_in, temp_in
    character(len=*), intent(out) :: flg

    call readfiles(sloan, bc_u, bc_b, bc_v, bc_r, bc_i, temp, grav, &
    n_teff, n_grav)
    phoenix_sloan_r=interp(grav_in, temp_in, bc_r, grav, temp, n_teff, &
    n_grav, flg)

  end function phoenix_sloan_r

  real function phoenix_sloan_i(grav_in, temp_in, flg)

    real, intent(in) :: grav_in, temp_in
    character(len=*), intent(out) :: flg

    call readfiles(sloan, bc_u, bc_b, bc_v, bc_r, bc_i, temp, grav, &
    n_teff, n_grav)
    phoenix_sloan_i=interp(grav_in, temp_in, bc_i, grav, temp, n_teff, &
    n_grav, flg)

  end function phoenix_sloan_i

  real function phoenix_sloan_z(grav_in, temp_in, flg)

    real, intent(in) :: grav_in, temp_in
    character(len=*), intent(out) :: flg

    call readfiles(sloan, bc_u, bc_b, bc_v, bc_r, bc_i, temp, grav, &
    n_teff, n_grav)
    phoenix_sloan_z=interp(grav_in, temp_in, bc_z, grav, temp, n_teff, &
    n_grav, flg)

  end function phoenix_sloan_z

end module phoenix

      module colteff_subs

      use bessell
      use ken_hart
      use phoenix

      implicit none

      ! The maximum number of points in the model isochrones.
      integer, parameter :: mmod=2000

      ! These two structures are slowly evolving to be the same.
      type isochron
        real :: age
        integer :: npts
        real, dimension(mmod) :: col, mag, mass, teff
        real, dimension(mmod) :: lbol, logg
      end type isochron

      type chrone 
        ! Now the specification of the iscohrone.  Its age, colours and model.
        real :: age
        integer :: colflag, modflag, npts
        real, dimension(:), allocatable :: col, mag, mass, teff
        character(len=50), dimension(:), allocatable :: 
     &  colflg, magflg, massflg, teffflg
      end type chrone

      !character(len=50), parameter :: isofile='/Padova_MC/isoc_z004.dat'
      !character(len=50), parameter :: isofile='/Padova_MC/isoc_z001.dat'
      !character(len=50), parameter :: isofile='/Padova_MC/isoc_z030.dat'
      !character(len=50), parameter :: isofile='/Padova/isoc_z0.dat'
      !character(len=50), parameter :: isofile='/Padova/isoc_z0001.dat'
      !character(len=50), parameter :: isofile='/Padova/isoc_z0004.dat'
      !character(len=50), parameter :: isofile='/Padova/isoc_z001.dat'
      !character(len=50), parameter :: isofile='/Padova/isoc_z004.dat'
      !character(len=50), parameter :: isofile='/Padova/isoc_z008.dat'
      !character(len=50), parameter :: isofile='/Padova/isoc_z019.dat'
      character(len=50),parameter::isofile='/Padova/isoc_z019_new.dat'
      !character(len=50), parameter :: isofile='/Padova/isoc_z030.dat
      !character(len=50),parameter:: isofile='/Padova_HST/isoc_z008.dat'

      ! These parameters convert from colflag into the actual names for
      ! the colours in question.  It gives us a good way of naming the
      ! files.
      ! Isochrones > 20 use their own colours and bolometric corrections.
      integer, public, parameter :: n_names=70
      character(len=12), dimension(n_names), parameter, public :: 
     &col_name=(/
     &'V-I        ','R-I        ','I-K        ','B-V        ',
     &'B-V        ','           ','           ','           ',
     &'           ','           ',

     &'V-I        ','           ','           ','B-V        ',
     &'B-V        ','           ','           ','           ',
     &'           ','           ',

     &'V-I        ','R-I        ','I-K        ','B-V        ',
     &'B-V        ','F555W-F814W','           ','           ',
     &'           ','           ',

     &'           ','           ','           ','B-V        ',
     &'           ','           ','           ','           ',
     &'           ','           ',

     &'V-I        ','           ','           ','           ',
     &'           ','           ','J-H        ','           ',
     &'           ','           ',

     &'g-i        ','i-z        ','           ','           ',
     &'           ','           ','           ','           ',
     &'           ','           ',

     &'V-I        ','           ','           ','B-V        ',
     &'           ','V-I        ','           ','           ',
     &'           ','           '/)

      character(len=12), dimension(n_names), public, parameter :: 
     &mag_name=(/
     &'V    ','I    ','I    ','V    ','U-B  ',
     &'     ','     ','     ','     ','     ',

     &'V    ','     ','     ','V    ','U-B  ',
     &'     ','     ','     ','     ','     ',

     &'V    ','I    ','I    ','V    ','U-B  ',
     &'F555W','     ','     ','     ','     ',

     &'     ','     ','     ','V    ','     ',
     &'     ','     ','     ','     ','     ',

     &'V    ','     ','     ','     ','     ',
     &'     ','J    ','     ','     ','     ',

     &'g    ','i    ','     ','     ','     ',
     &'     ','     ','     ','     ','     ',

     &'V    ','     ','     ','V    ','     ',
     &'I    ','     ','     ','     ','     '/)

      character(len=40), dimension(n_names), parameter, public ::
     &pht_comm=(/
     &'Jeffries/Naylor                         ', 
     &'Jeffries/Naylor                         ', 
     &'Jeffries/Naylor                         ', 
     &'Jeffries/Flower                         ', 
     &'Jeffries/Jeffries                       ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ', 
c
     &'Bessell (solar abundance)               ', 
     &'                                        ', 
     &'                                        ', 
     &'Bessell (solar abundance)               ', 
     &'Bessell (solar abundance)               ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ', 
c 
     &'As supplied with isochrone.             ', 
     &'As supplied with isochrone.             ', 
     &'As supplied with isochrone.             ', 
     &'As supplied with isochrone.             ', 
     &'As supplied with isochrone.             ', 
     &'As supplied with isochrone.             ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ',
c 
     &'                                        ', 
     &'                                        ', 
     &'                                        ', 
     &'Bessell Tycho  (solar abundance)        ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ',
c 
     &'Kenyon & Hartmann (1995).               ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ', 
     &'Kenyon & Hartmann (1995).               ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ',
c 
     &'Phoenix ugriz                           ', 
     &'Phoenix ugriz                           ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ',
c
     &'Phoenix UBVRI                           ', 
     &'                                        ', 
     &'                                        ', 
     &'Phoenix UBVRI                           ', 
     &'                                        ', 
     &'Phoenix UBVRI                           ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        ', 
     &'                                        '/)
      ! Similarly this parameter allows us to convert from modflag to
      ! a name for the model.
      integer, public, parameter :: n_models=30
      character(len=13), dimension(0:n_models), parameter, public ::
     &mod_name=(/
     &'linear       ', 'dam97        ', '             ',
     &'             ', 'siessz02     ', 'newbaraffe   ', 
     &'newbaraffe_19', 'siessz01     ', 'padova       ',
     &'geneva       ', 'user         ', 'palla_stahler', 
     &'             ', '             ', '             ', 
     &'             ', '             ', '             ', 
     &'             ', '             ', '             ', 
     &'             ', '             ', '             ', 
     &'             ', '             ', '             ', 
     &'             ', '             ', '             ', 
     &'             '/)
      
      interface reddening
        module procedure reddening_point
        module procedure reddening_array
      end interface

      contains
      
      character(len=30) function data_dir()
      
      ! A little function to return where the datafiles are stored.
      character(len=30) :: here
      
      call get_environment_variable('CMDDATA', here)
      data_dir=here
      
      end function data_dir
      
      subroutine colteff_calc(
     &empiso, dmod, red, age, colflag, modflag, npt, newcol, temp)
      
      ! empirical isochrone 
      character(len=*), intent(in) ::  empiso                
      ! Calibration cluster distance modulus, reddening and age.
      real, intent(in) :: dmod, red, age
      ! What colours do you want? 1 for V-I, 2 for R-I, 3 for I-K, 4 for B-V.
      integer, intent(in) ::  colflag
      ! Which model do you want?
      ! 1 for DAM, 3 for Baraffe
      ! 4 for Siess z=0.02, 5 for new Baraffe,
      ! 6 for new Baraffe with mixing length 1.9
      ! 7 for Siess with z=0.01
      integer, intent(in) :: modflag
      
      ! no. of points in empirical isochrone
      integer, intent(out) :: npt
      ! Teff corresponding to colours for empirical isochrone.
      real, dimension(:), allocatable, intent(out) :: newcol, temp
      

      real dtemp
      
      real lum,bc               ! luminosity/bolometric corr. at a point
      ! Input colours and magnitudes.      
      real, allocatable, dimension(:) ::  col, mag
      integer :: nempiso
      real, dimension(mmod) :: lbol, teff, mass, logg    ! theoretical isochrone
      integer :: nmod                        ! no. of points in theoretical isochrone
      ! Working versions of output arrays
      real, dimension(:), allocatable :: w_newcol, w_temp
      integer i, j, k, iostat
      integer :: bcflag
      
1     format(1x,a)

      ! Read the empirical isochrone.

      open (unit=10, file=empiso, status='old')
      nempiso=0
      count_iso: do
        read(10,*,iostat=iostat)
        if (iostat < 0) exit count_iso
        nempiso=nempiso+1
      end do count_iso
      rewind(10)
      allocate(col(nempiso), mag(nempiso))
      do i=1, nempiso
        read(10,*) col(i), mag(i)
      end do
      close(10)
      
      ! Reverse the effects of distance and reddening on the CMD.
      call reddening(colflag, -dmod, -red, col, mag)

cnow read in the theoretical isochrones
c a different procedure may need to be adopted for each set of models
c so have several calls
c expects lbol,teff to be returned in log units, age to be given in Myr 
c now also returns the mass of each point in solar units

      if (modflag.eq.1) then
        call read_pms(trim(data_dir())//'/DAM97/dam97.iso', 
     &  age, lbol, teff, mass, logg, nmod)
      else if (modflag.eq.4) then
        call read_pms(trim(data_dir())//'/Siess/siessz02.iso', 
     &  age, lbol, teff, mass, logg, nmod)
      else if (modflag.eq.5) then
        call read_pms(trim(data_dir())//'/baraffe98alpha1.0', 
     &  age, lbol, teff, mass, logg, nmod)
      else if (modflag.eq.6) then
        call read_pms(trim(data_dir())//'/baraffe98alpha1.9', 
     &  age, lbol, teff, mass, logg, nmod)
      else if (modflag.eq.7) then
        call read_pms(trim(data_dir())//'/Siess/siessz01.iso', 
     &  age, lbol, teff, mass, logg, nmod)
      else if (modflag.eq.9) then
        call read_padgen(modflag, age,lbol,teff,mass,logg,nmod)
      else
        print*, 'Unkown model flag ', modflag
        stop
      end if


      print*,'Lbol-Teff of calibration cluster'
      print*,'Lbol            Teff'
      print*,'--------------------'
      do i=1,nmod
        print*,10.0**lbol(i),10.0**teff(i)
      end do

c loop through the empirical isochrone
c for each point calculate the lbol and then the Teff corresponding to this.
c But need to trap instances where the empirical data lies well beyond the range 
c of the model

       
      ! The largest the output arrays can be is nempiso.
      allocate(w_temp(nempiso), w_newcol(nempiso))
      npt=0
      create: do i=1, nempiso
        if (colflag==1) bc = bcvi(col(i), logg(i), teff(i), bcflag)
        if (colflag==2) bc = bcri(col(i), bcflag)
        if (colflag==3) bc = bcik(col(i), bcflag)
        if (colflag==4) bc = bcbv(col(i), bcflag)
         
        if (bcflag /= 0) cycle create

        lum = (4.74 - bc - mag(i))/2.5

c       print*,'lum,B-V,BC=',lum,col(i),bc

c use numerical recipes subroutine - returns j, where lum is between
c lbol(j) and lbol(j+1)

        call locate(lbol,nmod,lum,j)

c       print*, 'index ',j

c this does not allow any extrapolation, but might be good to have a little bit.

        if ((j.gt.0.and.j.lt.nmod).or.
     :      (j.ge.nmod.and.(lum-lbol(nmod)).lt.0.3)) then

          npt=npt+1
c piece of black magic from numerical recipes p.113

          k = min(max(j-1,1),nmod-2)

c now interpolate (parabolic so n=3), returns temp and dtemp (error)

          call polint(lbol(k),teff(k),3,lum,w_temp(npt),dtemp)

          w_newcol(npt)=col(i)

c         print*,newcol(npt),10.0**temp(npt)

          end if

        end do create
        
        ! Now pack this into arrays which are just the right length.
        allocate(newcol(npt), temp(npt))
        newcol=w_newcol(1:npt)
        temp=w_temp(1:npt)
        deallocate(w_newcol, w_temp, col, mag)
      
c       print*,'npt=',npt

      end subroutine colteff_calc

      subroutine iso_calc(cage, colflag, modflag,
     &  npt, newcol, temp, nmod, isocol, colflg, isomag, magflg, 
     &  isomass, massflg, isoteff, teffflg)
      
        ! Given an isochrone model number and colour flag this routine
        ! interpolates the isochrone to a given age, and then pastes
        ! a model atmosphere on top.

        ! The age to be modelled.
        real, intent(in) :: cage
        ! What colours do you want? 
        integer, intent(in) ::  colflag
        ! Which model do you want?
        integer, intent(in) :: modflag

        ! If the effective temperature colour relationship is to be
        ! tweaked, you will also need the following.
        ! no. of points in empirical isochrone
        integer, intent(in) :: npt
        ! log10(teff) corresponding to colours for empirical isochrone.
        real, dimension(:), intent(in) :: newcol, temp      
        
        ! Number of points in output theoretical isochrone.
        integer, intent(out) :: nmod                        
        ! Colour, magnitude and mass of output isochrone.
        real, dimension(:), allocatable, intent(out) :: 
     &  isocol, isomag, isomass, isoteff
        ! The flag for the isochrone.
        character(len=*), allocatable, dimension(:), intent(out) :: 
     &  colflg, magflg, massflg, teffflg
        
        integer :: imod, i, j, k, iflag
        real :: bc               ! luminosity/bolometric corr. at a point
        real, dimension(mmod) :: lbol, teff, mass, logg  ! theoretical isochrone
        integer :: bcflag
        character(len=30) :: ifname
        character(len=30) :: wrkflg

        type(isochron), dimension(1) :: isoc
      

                                ! Read the appropriate models
        
        if (modflag.eq.1) then
          call read_pms(trim(data_dir())//'/DAM97/dam97.iso', 
     &    cage, lbol, teff, mass, logg, nmod)
        else if (modflag.eq.4) then
          call read_pms(trim(data_dir())//'/Siess/siessz02.iso', 
     &    cage, lbol, teff, mass, logg, nmod)
        else if (modflag.eq.5) then
          call read_pms(trim(data_dir())//'/baraffe98alpha1.0', 
     &    cage, lbol, teff, mass, logg, nmod)
        else if (modflag.eq.6) then
          call read_pms(trim(data_dir())//'/baraffe98alpha1.9', 
     &    cage, lbol, teff, mass, logg, nmod)
        else if (modflag.eq.7) then
          call read_pms(trim(data_dir())//'/Siess/siessz01.iso', 
     &    cage, lbol, teff, mass, logg, nmod)
        else if (modflag.eq.8) then
          call read_padgen(modflag, cage,lbol,teff,mass,logg,nmod)
        else if (modflag.eq.9) then
          call read_padgen(modflag, cage,lbol,teff,mass,logg,nmod)
        else if (modflag.eq.10) then
          ifname='user_00.000.dat'
          write(ifname(6:10), '(f5.2)') cage
          do i=6, 10
            if (ifname(i:i) == ' ') ifname(i:i)='0'
          end do
          call read_padova_col(ifname, cage, colflag, isoc)
          nmod=isoc(1)%npts
          lbol=isoc(1)%lbol
          teff=isoc(1)%teff
          mass=isoc(1)%mass
          logg=isoc(1)%logg
        else if (modflag.eq.11) then
          call read_pms(trim(data_dir())//'/palla_stahler.dat', 
     &    cage, lbol, teff, mass, logg, nmod)
        else
          print*, 'Unknown model flag ', modflag
          stop
        end if

        ! Only use isochrone points within the range of the colour-Teff
        ! relationship.  Rob's version used to allow extrapolation, but 
        ! if the extrapolation was so bad it became double valued it 
        ! confused Tim's fitting procedures.
        allocate(isocol(nmod), isomag(nmod), isomass(nmod), 
     &  isoteff(nmod))
        allocate(colflg(nmod), magflg(nmod), massflg(nmod),
     &  teffflg(nmod))
        
        ! lbol and teff derived for that isochrone, now convert to colour 
        !and mag
        imod=0
        colflg='OK'
        magflg='OK'
        massflg='OK'
        teffflg='OK'
        create: do imod=1, nmod
c          print*, 'Point ', imod, 'Lum', lbol(imod), 'teff ',
c     &    10.0**teff(imod), 'logg ', logg(imod), 'mass ', mass(imod)
          ! First deal with the mass and effective temperature.
          isomass(imod) = mass(imod)
          isoteff(imod) = teff(imod)
          ! Now the colour.
          if (colflag < 11) then
            isocol(imod)=quadint(temp, newcol, teff(imod), colflg(imod))
          else if (colflag == 11) then
            isocol(imod)=bessell_col_vi(logg(imod), teff(imod), 
     &      colflg(imod))
          else if (colflag==14 .or. colflag==15) then
            isocol(imod)=bessell_col_bv(logg(imod), teff(imod), 
     &      colflg(imod))
          else if (colflag == 34) then
            isocol(imod)=bessell_col_bv(logg(imod), teff(imod), wrkflg)
            call tycho_col(isocol(imod), colflg(imod))
            if (trim(wrkflg) /= 'OK') colflg(imod) = wrkflg
         else if (colflag == 41) then
            isocol(imod)=ken_hart_col_vi(teff(imod), colflg(imod))
         else if (colflag == 47) then
            isocol(imod)=ken_hart_col_jh(teff(imod), colflg(imod))
          else if (colflag == 51) then
            isocol(imod)=phoenix_sloan_gi(logg(imod), teff(imod), 
     &      colflg(imod))
          else if (colflag == 52) then
            isocol(imod)=phoenix_sloan_iz(logg(imod), teff(imod), 
     &      colflg(imod))
          else if (colflag == 61 .or. colflag == 66) then
            isocol(imod)=phoenix_bess_vi(logg(imod), teff(imod),
     &      colflg(imod))
          else if (colflag == 64) then
            isocol(imod)=phoenix_bess_bv(logg(imod), teff(imod),
     &      colflg(imod))
          else
            print*, 'The requested colour ', colflag,
     &      ' is not available' 
          end if
c          print*, 'Colour is ', isocol(imod), colflg(imod)
          if (colflg(imod) == '1') then
            colflg(imod)='Colour-Teff'
            !cycle create
          end if
          ! Now the magnitude, but note that for U-B vs B-V this is 
          ! a colour.
          if (colflag == 15) then
            isomag(imod)=bessell_col_ub(logg(imod), teff(imod), 
     &      magflg(imod))
          else
            if (colflag==1) then
              bc = bcvi(isocol(imod), logg(imod), teff(imod), bcflag)
            else if (colflag==2) then
              bc = bcri(isocol(imod), bcflag)
            else if (colflag==3) then
              bc = bcik(isocol(imod), bcflag)
            else if (colflag==4) then
              bc = bcbv(isocol(imod), bcflag) 
            else if (colflag==11 .or. colflag==14) then
              bc=bessell_bc_v(logg(imod), teff(imod), magflg(imod))
            else if (colflag==34) then
              bc=bessell_bc_v(logg(imod), teff(imod), magflg(imod))
              bc=bc+tycho_bc(isocol(imod), magflg(imod))
              if (trim(wrkflg) /= 'OK') magflg(imod) = wrkflg
            else if (colflag==41) then
              bc=ken_hart_bc_v(teff(imod), bcflag)
            else if (colflag==47) then
              bc=ken_hart_bc_j(teff(imod), bcflag)
            else if (colflag==51) then
              bc=phoenix_sloan_g(logg(imod), teff(imod), magflg(imod))
            else if (colflag==52) then
              bc=phoenix_sloan_i(logg(imod), teff(imod), magflg(imod))
            else if (colflag == 61 .or. colflag == 64) then
              bc=phoenix_bess_v(logg(imod), teff(imod), magflg(imod))
            else if (colflag == 66) then
              bc=phoenix_bess_i(logg(imod), teff(imod), magflg(imod))
            else
              print*, 'Cannot cope with colour', colflag
              stop
            end if
            !print*, 'BC is ', bc, magflg(imod)
            if (bcflag/=0 .and. colflag<11) then
              magflg(imod)='Bolometric correction'
              !cycle create
            end if
            if (magflg(imod)=='1' .and. colflag>50) then
              magflg(imod)='Bolometric correction'
              !cycle create
            end if
            isomag(imod)=4.74-bc-2.5*lbol(imod)
          end if

!          print*, imod, isomag(imod), trim(colflg(imod)), 
!     &    isocol(imod), trim(magflg(imod)), 10.0**teff(imod),
!     &    lbol(imod), mass(imod), bc
          
        end do create

      end subroutine iso_calc



c *****************************************************************************
      subroutine reddening_array(colflag, dmod, red, col, mag)
c *****************************************************************************
      
        ! Changes an absolute magnitude sequence into a reddened one at
        ! at given distance reddening (dmod, col positve) or the reverse.
    
        ! Note that red is the reddening in the colour (e.g. B-V).
    
        integer, intent(in) :: colflag
        real, intent(in) :: dmod, red
        real, dimension(:), intent(inout) :: col, mag

        integer :: icol
        logical, save :: tycho_warn=.false.
      
        ! Change to un-reddened colour (order important for Bessell).
        if (red < 0.0) col=col+red
        
        ! Reverse the extinction appropriate for each CMD
        if (colflag==1 .or. colflag==21 .or. colflag==41 .or.
     &       colflag==61) then 
          ! Rob's code had 1.8 in here (which was a bug).
          ! Av=2.40E(V-I)
          mag=mag+2.40*red
        else if (colflag==2 .or. colflag==22) then
          ! Implication here is that E(R-I)=0.23Av
          ! Tim re-calculated this, and got the same answer by the following
          ! route. E(V-I)/B(B-V) is about 1.250 (Dean et al 1978), 
          ! Av/E(B-V)=3.1 (trad.) and E(R-I)/E(B-V) is about 0.72 (Taylor,
          ! 1986).  Magically, this gave the answer already in the code!
          ! Ai=2.57E(R-I)
          mag=mag+2.57*red
        else if (colflag==3 .or. colflag==23) then 
          ! Ai=1.2E(I-K)
          mag=mag+1.20*red
        else if (colflag==4 .or. colflag==24 .or. colflag==64) then
          ! Av=3.1E(B-V)
          mag=mag+3.10*red
        else if (colflag==5 .or. colflag==25) then
          ! E(U-B)=0.73*E(B-V) (Nathan says everyone uses this.)
          mag=mag+0.73*red
        else if (colflag == 11) then
          if (abs(red) > tiny(red)) then
            print*, 'Cant deal with reddening in Bessell V-I.'
            stop
          end if
        else if (colflag == 14) then
          ! Av=(3.26+0.22*(B_V)o)*E(B-V), for Bessell.
          mag=mag+(3.26+0.22*col)*red
          ! Special for Cep OB3b.  Works for B-V < 0.2 to about 0.01 mags.
          ! mag=mag+(3.0802126+0.20603374*col)*red
        else if (colflag == 15) then
          ! E(U-B)=(0.71+0.24*(B_V)o)*E(B-V), for Bessell.
          mag=mag+(0.71+0.24*col)*red
          ! Special for Cep OB3b.  For B-V < 0 works to about 0.01 mags.
          !mag=mag+(0.6475283-0.170563*col)*red
        else if (colflag == 34) then
          ! Colour 34 is Tycho.
          ! Vector from Mayne & Naylor.
          do icol=1, size(col,1)
            if (col(icol) < 0.065) then
              mag = mag + (3.358 + 0.237*col(icol))*red
            else if (col(icol) < 0.5) then
              mag = mag + (3.387 - 0.207*col(icol))*red
            else
              if (.not. tycho_warn) then
                print*, 'Colour B-V = ', col(icol), ' is outside'
                print*, 'the range the Tycho reddening vector is'
                print*, 'defined (B-V=0.5).'
                tycho_warn=.true.
              end if
              mag = mag + (3.515 - 0.267*0.5)*red
            end if
          end do
	else if (colflag == 47) then
           ! Vector from Nick Wright, who got it from Schlegel.
	   ! A(J)=2.76*E(J-H)
	   mag = mag + 2.76*red
        else if (colflag == 51) then
           ! Ag=2.26*E(g-i), where 2.26 is average value for 3000 - 10000 K.
           mag = mag + 2.26*red
        else if (colflag == 52) then
           ! Ai=3.65*E(i-z), where 3.65 is average value for 3000 - 10000 K.
           mag = mag + 3.65*red
        else
          print*, 'Error, unknown colour flag', colflag, 
     &    ' in reddening_array.'
        end if

        ! And finally deal with the distance modulus.
        mag=mag+dmod
      
        ! Change to un-reddened colour (order important for Bessell).
        if (red > 0.0) col=col+red

      end subroutine reddening_array

c *****************************************************************************
      subroutine reddening_point(colflag, dmod, red, col, mag)
c *****************************************************************************

        integer, intent(in) :: colflag
        real, intent(in) :: dmod, red
        real, intent(inout) :: col, mag
        
        real, dimension(1) :: a_col, a_mag
        
        a_col(1)=col; a_mag(1)=mag
        
        call reddening_array(colflag, dmod, red, a_col, a_mag)

        col=a_col(1); mag=a_mag(1)
      
      end subroutine reddening_point  


      subroutine read_pms(ifname, age, lbol, teff, mass, logg, nmod)

      ! Modelled on Rob's Baraffe routine, this is a more generalisable
      ! routine for reading and interpolating PMS isochrones.

      ! At this stage not very general, designed to read the
      ! Palla and Stahler files Cameron created, but should work for
      ! Baraffe.

      character(len=*) :: ifname

      ! Required age in Myr.
      real, intent(in) :: age

      ! Need to be in log units
      real, dimension(:), intent(out) :: lbol, teff, mass, logg
      integer, intent(out) :: nmod

      ! Locals
      integer :: n_masses, i_masses, max_n_ages, i_ages
      integer, allocatable, dimension(:) :: n_ages
      
      real, allocatable, dimension(:,:) :: logAge, logL, logT, log_G
      real, allocatable, dimension(:) :: dmass

      real :: old_mass, new_mass
      integer :: iostat
      character(len=30) :: flag


      ! Tracks are all in one big file
      ! idea is to read in a file for each mass and interpolate to get
      ! log L and log T at the appropriate log(age)

      open (1,file=ifname,
     &form='formatted',access='sequential',status='old')

      
      ! Start by counting the number of masses.
      read(1,'(/,/)') 
      n_masses=0
      old_mass=-1
      do
        read(1,*,iostat=iostat) new_mass
        if (iostat < 0) exit
        if (new_mass > nearest(old_mass,1.0)) then
          ! If the new mass is bigger than the old one.
          n_masses=n_masses+1
          old_mass=new_mass
        end if
      end do

      ! Now count the number of ages at each mass.
      allocate(n_ages(n_masses))
      rewind(1)
      read(1,'(/,/)') 
      old_mass=-1.0
      i_masses=0
      each_mass: do
        read(1,*,iostat=iostat) new_mass
        if (iostat < 0) exit each_mass
        if (new_mass > nearest(old_mass,1.0)) then
          ! If the new mass is bigger than the old one.
          old_mass=new_mass
          i_masses=i_masses+1
          n_ages(i_masses)=1
        else
          n_ages(i_masses)=n_ages(i_masses)+1
        end if
      end do each_mass
      max_n_ages=maxval(n_ages,1)

      ! Now read the data in.
      rewind(1)
      read(1,'(/,/)') 
      allocate(dmass(n_masses), logAge(n_masses, max_n_ages))
      allocate(logT(n_masses, max_n_ages), logL(n_masses, max_n_ages))
      allocate(log_G(n_masses, max_n_ages))
      do i_masses=1, n_masses

        do i_ages=1, n_ages(i_masses)
          read(1,*) dmass(i_masses),logAge(i_masses,i_ages),
     :    logT(i_masses,i_ages), log_G(i_masses,i_ages), 
     :    logL(i_masses,i_ages)
        end do

        ! Convert to logs
        do i_ages=1,n_ages(i_masses)
          logAge(i_masses,i_ages)=log10(logAge(i_masses,i_ages))+9.0
          logT(i_masses,i_ages)=log10(logT(i_masses,i_ages))
        end do

      end do

      close(1)

      ! Now have the models in the 2d grids
      ! for each row in the grid, need to find the index closest to the
      ! required age.

      nmod=0

      do i_masses=1, n_masses

        lbol(nmod+1)=quadintflg(logAge(i_masses,1:n_ages(i_masses)), 
     &  logL(i_masses,1:n_ages(i_masses)), age, flag)
        if (trim(flag) /= 'OK') cycle

        teff(nmod+1)=quadintflg(logAge(i_masses,1:n_ages(i_masses)), 
     &  logT(i_masses,1:n_ages(i_masses)), age, flag)
        if (trim(flag) /= 'OK') cycle
        
        logg(nmod+1)=quadintflg(logAge(i_masses,1:n_ages(i_masses)), 
     &  log_G(i_masses,1:n_ages(i_masses)), age, flag)
        if (trim(flag) /= 'OK') cycle
        
        nmod=nmod+1
        mass(nmod)=dmass(i_masses)

        !print*, nmod, mass(nmod), lbol(nmod), teff(nmod)

      end do
            
      if (nmod == 0) then
            
        print*, 'Could not find appropriate age.'
        print*, 'Required log10(age in years) is ', age
        stop    
      endif

      end subroutine read_pms


c ******************************************************************************
      subroutine read_padgen(modflag, mage, lbol, teff, mass, logg, 
     &nmod)
c ******************************************************************************

      implicit none

      ! The required model.
      integer, intent(in) :: modflag
      ! The required age in Myr.
      real, intent(in) :: mage
      real, intent(out), dimension(:) :: lbol, teff, mass, logg
      ! The actual number of points in the isochrone. 
      integer, intent(out) :: nmod

      type(isochron), dimension(3) :: isoc
      integer :: imod, imass, jpt, iage
      real, dimension(3) :: teff_in, lbol_in, logg_in, age_in
      real :: uncer, min_mass, max_mass

      character(len=30) :: flag

      if (modflag == 8) then
        call read_padova_col(trim(data_dir())//isofile, mage, 0, isoc)
      else if (modflag == 9) then
        call read_geneva_col(mage, 0, isoc)
      else
        print*, 'S/R read padgen called in model ', modflag
        stop
      end if

      ! What mass scale to use?
      min_mass=maxval(isoc%mass(1))
      max_mass=min(isoc(1)%mass(isoc(1)%npts), 
     &isoc(2)%mass(isoc(2)%npts))
      max_mass=min(max_mass, isoc(3)%mass(isoc(3)%npts))

      nmod=0
      ! At each mass point in the middle isochrone.
      each_mass: do imass=1, isoc(2)%npts
        if (isoc(2)%mass(imass) < min_mass) cycle each_mass
        if (isoc(2)%mass(imass) > max_mass) cycle each_mass
        nmod=nmod+1
        if (nmod > mmod) then
          print*, 'mmod needs enlarging.'
          stop
        end if
        mass(nmod)=isoc(2)%mass(imass)
        
        ! Set up the middle of the three values we will interpolate accross.
        teff_in(2)=isoc(2)%teff(imass)
        lbol_in(2)=isoc(2)%lbol(imass)
        logg_in(2)=isoc(2)%logg(imass)
        age_in(2)=isoc(2)%age

        ! Now interpolate the other two points.
        each_age: do iage=1, 3, 2

          age_in(iage)=isoc(iage)%age

          teff_in(iage)=linint(isoc(iage)%mass(1:isoc(iage)%npts), 
     &    isoc(iage)%teff(1:isoc(iage)%npts), mass(nmod), flag)
          lbol_in(iage)=linint(isoc(iage)%mass(1:isoc(iage)%npts), 
     &    isoc(iage)%lbol(1:isoc(iage)%npts), mass(nmod), flag)
          logg_in(iage)=linint(isoc(iage)%mass(1:isoc(iage)%npts), 
     &    isoc(iage)%logg(1:isoc(iage)%npts), mass(nmod), flag)

        end do each_age

        ! Now interpolate over the three points to get the right age.
        teff(nmod)=linint(age_in, teff_in, mage, flag)
        lbol(nmod)=linint(age_in, lbol_in, mage, flag)
        logg(nmod)=linint(age_in, logg_in, mage, flag)

      end do each_mass

      

      end subroutine read_padgen

      subroutine read_geneva_col(age, colflag, isoc)

      ! Reads the Geneva isochrones file, returning the three isochrones
      ! closest to the requested age which can then be interpolated.

      ! Colflag follows the usual rules,
      ! except that if it is zero the magnitude is lbol, and the colour
      ! is teff.

      real, intent(in) :: age
      integer, intent(in) :: colflag
      type(isochron), intent(out), dimension(3) :: isoc

      real :: teff, lbol
      integer :: n_mass
      integer :: nages, iage, jage
      character(len=30), dimension(:), allocatable :: isofiles
      real, dimension(:), allocatable :: log10_ages

      character(len=20), parameter :: isodir='Geneva'

      ! First create a list of ages and file names.
      open(unit=2, file=trim(data_dir())//'/'//trim(isodir)// 
     &'/ages.dat',status='old')
      read(2,*) nages
      allocate(log10_ages(nages), isofiles(nages))
      read(2,'(/)')
      do iage=1, nages
        read(2,*) log10_ages(iage), isofiles(iage)
      end do
      close(2)

      ! Find the nearest age, and one on either side.
      !jage=minloc(abs(log10_ages-(log10(age)+6.0)),1)
      jage=minloc(abs(log10_ages-age),1)
      ! If the nearest age is the first one, but its above that age
      ! then take the second age as the mid-point of the interpolation.
      if (jage==1 .and. log10_ages(1) < age) jage=2
      if (jage == 1) then
        print*, 'Youngest isochrone available is ', log10_ages(1)
        print*, 'So cannot do an age of ', age
        stop
      else if (jage > nages) then
        print*, 'Oldest isochrone available is ', log10_ages(nages)
        print*, 'So cannot do an age of ', age
        stop
      end if
      
      isoc%age=log10_ages(jage-1:jage+1)

      do iage=1, 3
        call read_one_geneva(trim(data_dir())//'/'//trim(isodir)//'/'//
     &  trim(isofiles(jage-2+iage)), colflag, isoc(iage))

      end do

      end subroutine read_geneva_col

      subroutine read_one_geneva(filnam, colflag, isoc)

      ! Reads a single Geneva isochrone.

      character(len=*), intent(in) :: filnam
      integer, intent(in) :: colflag

      type(isochron), intent(inout) :: isoc

      character :: ch_junk
      real :: junk
      real :: v, u_b, b_v, v_r, v_i
      integer :: kage, i


      open(unit=2, status='old', file=filnam)
      read(2,*)
      read(2,*)
      read(2,*) ch_junk, isoc%npts
      read(2,*)
      read(2,*)
      read(2,*)
      if (isoc%npts > mmod) then
         print*, 'mmod needs expanding to ', isoc%npts
         stop
      end if
      do i=1, isoc%npts
         read(2,*) junk, isoc%mass(i), junk, isoc%teff(i), 
     &        isoc%logg(i), isoc%lbol(i), v, u_b, b_v, v_r, v_i
         if (colflag == 0) then
           ! Do nothing, everything is fine.
         else if (colflag == 21) then
            isoc%mag(i)=v
            isoc%col(i)=v_i
         else if (colflag == 24) then
            isoc%mag(i)=v
            isoc%col(i)=b_v
         else if (colflag == 25) then
            isoc%mag(i)=u_b
            isoc%col(i)=b_v
         else
            print*,'For the Geneva isochrones only the colours V/V-I'
            print*,'V/B-V and U-B/B-V are read from the files supplied.'
            stop
         end if
      end do
      ! Sometimes (just to be a pest) there are no values for the last
      !few datapoints, which are set to -99.
      kage=isoc%npts
      do i=kage, 1, -1
         if (isoc%teff(i) < -98.0) isoc%npts=kage-1
         if (isoc%lbol(i) < -98.0) isoc%npts=kage-1
      end do
      close(2)

      end subroutine read_one_geneva 


      subroutine read_padova_col(ifname, age, colflag, isoc)

      ! A very general isochrone reader.  If isoc is of dimension one
      ! the reader expects to find an isochrone at exactly the right 
      ! age.  If it is if dimension three it will return the three
      ! nearest in age.

      character(len=*) :: ifname
      real, intent(in) :: age
      ! The colours required.  Set to zero for lbol and Teff.
      integer, intent(in) :: colflag
      type(isochron), dimension(:), intent(out) :: isoc

      character(len=150) :: test_str
      integer :: n_ages, iostat, i_ages, i, jage, j
      real :: old_mass, new_mass, old_age, new_age, junk
      integer, allocatable, dimension(:) :: n_masses
      real, allocatable, dimension(:) :: log10_ages
      integer, allocatable, dimension(:) :: icnt
      real :: teff, logg, mag_bol, lbol
      real :: mag_u, mag_b, mag_v, mag_r, mag_i, mag_j, mag_h, mag_k
      integer :: icol_plus, icol_minus, imag_plus, imag_minus
      integer :: imass, igrav, iteff, ilbol
      character(len=10) :: col_plus, col_minus, mag_plus, mag_minus
      character(len=20), dimension(20) :: col_head
      real, dimension(20) :: data
      integer :: ihed, nhed, ipos
      character(len=20) work_str

      logical :: first=.true.

      if (first) then
        print*, 'Using datafile ', trim(ifname)
        first=.false.
      end if

      open (unit=2, file=ifname, status='old')
      ! First get a feel for the ages available.
      n_ages=0
      each_line1: do
        read(2,'(a50)',iostat=iostat) test_str
        test_str=adjustl(test_str)
        if (iostat < 0) then
          exit each_line1
        else if (iostat > 0) then
          print*, 'Error ', iostat, ' reading file in each_line1.'
          stop
        end if
        if (test_str(1:1) == '#') cycle each_line1
        read(test_str,*) new_age
        if (n_ages == 0) then
          n_ages=1
          old_age=new_age
        else if (abs(new_age-old_age) > 2.0*tiny(old_age)) then
          n_ages=n_ages+1
          old_age=new_age
        end if
      end do each_line1
!      print*, 'Number of ages available is ', n_ages

      ! Now count the number of mass points at each age.
      rewind(2)
      allocate(n_masses(n_ages), log10_ages(n_ages))
      n_masses=0
      i_ages=0
      each_line2: do
        read(2,'(a50)',iostat=iostat) test_str
        test_str=adjustl(test_str)
        if (iostat < 0) then
          exit each_line2
        else if (iostat > 0) then
          print*, 'Error ', iostat, ' reading file in each_line2.'
          stop
        end if
        if (test_str(1:1) == '#') cycle each_line2
        read(test_str,*) new_age, new_mass
        if (i_ages == 0) then
          i_ages=1
          old_age =new_age
          old_mass=new_mass
          n_masses(i_ages)=n_masses(i_ages)+1
          log10_ages(i_ages)=new_age
        else if (abs(new_age-old_age) > 2.0*tiny(old_age)) then
          i_ages=i_ages+1
          old_age =new_age
          old_mass=new_mass
          log10_ages(i_ages)=new_age
        else
          if (abs(new_mass-old_mass) > 2.0*tiny(old_mass)) then
            old_age =new_age
            old_mass=new_mass
            n_masses(i_ages)=n_masses(i_ages)+1
          end if
        end if
      end do each_line2

      ! Find the nearest age.
      jage=minloc(abs(log10_ages-age),1)
!      print*, 'Nearest age is ', log10_ages(jage), 
!     &'Myr number ', jage
      if (size(isoc) == 1) then
        ! Do we have an exact match?
        if (abs(log10_ages(jage)-age) < 0.0001) then
          isoc(1)%age=age
          if (size(isoc) > 1) isoc(2)%age=0.0
          if (size(isoc) > 2) isoc(3)%age=0.0
          isoc(1)%npts=n_masses(jage)
        else 
          print*, 'read_padova_col called for one isochrone when there '
          print*, 'is not an exact match in the file.'
          stop
        end if
      else
        ! If the nearest age is the first one, but its above that age
        ! then take the second age as the mid-point of the interpolation.
        if (jage==1 .and. log10_ages(1) < age) jage=2
        if (jage  == 1) then
          print*, 'Youngest isochrone available is ', log10_ages(1)
          print*, 'So cannot do an age of ', age
          stop
        else if (jage > n_ages) then
          print*, 'Oldest isochrone available is ', log10_ages(n_ages)
          print*, 'So cannot do an age of ', age
          stop
        end if
        isoc%age=log10_ages(jage-1:jage+1)
        isoc%npts=n_masses(jage-1:jage+1)
      end if

      ! Now get the names of the column heads.
      rewind(2)
      col_head=' '
      each_line4: do 
        read(2,'(a150)',iostat=iostat) test_str
        test_str=adjustl(test_str)
        ! Remove the tabs.
        do ihed=1, 150
          if (test_str(ihed:ihed) == char(9)) test_str(ihed:ihed)=' '
        end do
        if (test_str(1:1) /= '#') exit each_line4
        work_str='#'
        each_header: do ihed=1, 20
          ipos=index(test_str, trim(work_str))+len_trim(work_str)
          test_str=test_str(ipos:len(test_str))
          test_str=adjustl(test_str)
          read(test_str(1:index(test_str, ' ')) ,'(20a)',
     &    iostat=iostat) col_head(ihed)
          if (iostat<0 .or. len_trim(col_head(ihed))<1) exit
          work_str=col_head(ihed)
          if (col_head(ihed) == 'Mu') col_head(ihed)='U'
          if (col_head(ihed) == 'Mb') col_head(ihed)='B'
          if (col_head(ihed) == 'Mv') col_head(ihed)='V'
          if (col_head(ihed) == 'Mr') col_head(ihed)='R'
          if (col_head(ihed) == 'Mi') col_head(ihed)='I'
          if (col_head(ihed) == 'Mj') col_head(ihed)='J'
          if (col_head(ihed) == 'Mh') col_head(ihed)='H'
          if (col_head(ihed) == 'Mk') col_head(ihed)='K'
          nhed=ihed
        end do each_header
      end do each_line4

      mag_plus='NOT SET'
      mag_minus='NOT SET'
      col_plus='NOT SET'
      col_minus='NOT SET'
      if (colflag == 0) then
        mag_plus='logL/Lo'
        col_plus='logTe'
        icol_minus=-1
        imag_minus=-1
      else
        ipos=index(mag_name(colflag), '-')
        if (ipos > 0) then
          mag_plus =mag_name(colflag)(1:ipos-1)
          mag_minus=mag_name(colflag)(ipos:len(mag_name(colflag)))
          imag_minus=0
        else
          mag_plus = mag_name(colflag)
          imag_minus=-1
        end if
        ipos=index(col_name(colflag), '-')
        if (ipos > 0) then
          col_plus =col_name(colflag)(1:ipos-1)
          col_minus=col_name(colflag)(ipos+1:len(col_name(colflag)))
          icol_minus=0
        else
          col_plus =col_name(colflag)
          icol_minus=-1
        end if
      end if

      imag_plus=-1
      icol_plus=-1
      do ihed=1, nhed
        if (trim(col_head(ihed)) == 'M_ini') imass=ihed
        if (trim(col_head(ihed)) == 'logG') igrav=ihed
        if (trim(col_head(ihed)) == 'logL/Lo') ilbol=ihed
        if (trim(col_head(ihed)) == 'logTe') iteff=ihed
        if (trim(col_head(ihed)) == mag_plus) imag_plus=ihed
        if (trim(col_head(ihed)) == col_plus) icol_plus=ihed
        if (trim(col_head(ihed)) == mag_minus .and. imag_minus>=0) 
     &  imag_minus=ihed
        if (trim(col_head(ihed)) == col_minus .and. icol_minus>=0) 
     &  icol_minus=ihed
      end do

      if (imag_plus == -1) then
        print*, 'Could not find the colour ', trim(mag_plus) 
        print*, 'amoungst ', col_head(1:nhed)
        stop
      end if
      if (icol_plus == -1) then
        print*, 'Could not find the colour ', trim(col_plus) 
        print*, 'amoungst ', col_head(1:nhed)
        stop
      end if

      ! Now get the three ages we want.
      rewind(2)
      allocate(icnt(size(isoc)))
      icnt=0
      old_mass=0.0
      each_line3: do
        read(2,'(a150)',iostat=iostat) test_str
        test_str=adjustl(test_str)
        if (iostat < 0) then
          exit each_line3
        else if (iostat > 0) then
          print*, 'Error ', iostat, ' reading file in each_line3.'
          stop
        end if
        if (test_str(1:1) == '#') cycle each_line3
        read(test_str,*) new_age, new_mass
        !j=minval(minloc(abs(new_age-(log10(isoc%age)+6.0))))
        j=minloc(abs(new_age-isoc%age),1)
        if (abs(new_age-isoc(j)%age) < 2.0*tiny(new_age)) then
          if (abs(old_mass-new_mass) > 2.0*tiny(new_mass)) then 
            icnt(j)=icnt(j)+1
            read(test_str,*) data(1:nhed)
            isoc(j)%lbol(icnt(j))=data(ilbol)
            isoc(j)%teff(icnt(j))=data(iteff)
            isoc(j)%mass(icnt(j))=data(imass)
            isoc(j)%logg(icnt(j))=data(igrav)
            if (icol_minus > 0) then
              isoc(j)%col(icnt(j))=data(icol_plus)-data(icol_minus)
            else
              isoc(j)%col(icnt(j))=data(icol_plus)
            end if
            if (imag_minus > 0) then
              isoc(j)%mag(icnt(j))=data(imag_plus)-data(imag_minus)
            else
              isoc(j)%mag(icnt(j))=data(imag_plus)
            end if
!           print*, new_age, icnt(j), isoc(j)%mass(icnt(j)), 
!     &     isoc(j)%mag(icnt(j)), isoc(j)%col(icnt(j))
          end if
          old_mass=new_mass
        end if
      end do each_line3
      deallocate(icnt)

!      if (colflag == 0) then
!        print*, 'Searched for logL/Lo and logTe amoungst'
!      else
!        print*, 'Searched for ', mag_name(colflag), ' and ', 
!     &  col_name(colflag), ' amoungst '
!      end if
!      print*, col_head(1:nhed)
!      print*, 'Needed columns ', imag_plus, imag_minus, icol_plus, 
!     &icol_minus
!      print*, 'Corresponding to ', mag_plus, mag_minus, col_plus, 
!     &col_minus

      deallocate(n_masses, log10_ages)
      close(2)

      !do j=1, 3
      !  write(30+j,*) isoc(j)%age
      !  write(30+j,*) trim(ifname)
      !  write(30+j,*) ' '
      !  do jage=1, isoc(j)%npts
      !    write(30+j,*) isoc(j)%col(jage), isoc(j)%mag(jage)
      !  end do
      !end do
      !stop

      end subroutine read_padova_col



c ******************************
      real function bcbv(bv, flag)
c ******************************

c Original version by Rob to use Flower(1996)

      implicit none

      real, intent(in) :: bv
      integer, intent(out) :: flag
      
      integer j, k
      real dbcbv

      integer, parameter :: nmax_flower=44
      real, dimension(nmax_flower) :: flower_bc, flower_x

      integer, parameter :: nmax_bessell=75
      real, dimension(nmax_bessell) :: bessell_bcor, bessell_x

      integer :: nmax
      real, dimension(nmax_bessell) :: bc, x

      real, dimension(3) :: dumx, dumbc

      data flower_bc/
     :        -4.72, -3.234,-2.177,-1.525,-1.013,-0.614,-0.334,-0.155,
     :        -0.050, 0.004, 0.024, 0.032, 0.035,0.034,0.03,0.020,0.006,
     :        -0.012,-0.035,-0.061,-0.091,-0.124,-0.161,-0.200,-0.242,
     :        -0.285,-0.332,-0.382,-0.437,-0.494,-0.552,-0.614,-0.679,
     :        -0.752,-0.831,-0.920,-1.024,-1.150,-1.312,-1.539,-1.885,
     :        -2.460,-3.502,-5.535/
      data flower_x/
     :      -0.35,-0.3,-0.25,-0.2,-0.15,-0.1,-0.05,0.0,0.05,0.1,0.15,
     :       0.20,0.25,0.30,0.35,0.40,0.45,0.5,0.55,0.6,0.65,0.7,0.75,
     :       0.8,0.85,0.9,0.95,1.0,1.05,1.1,1.15,1.2,1.25,1.3,1.35,
     :       1.4,1.45,1.5,1.55,1.6,1.65,1.7,1.75,1.80/

      data bessell_bcor/
     :-4.27, -4.21, -4.14, -4.07, -4.00, -3.93, -3.86, -3.79, -3.71, 
     :-3.63, -3.56, -3.48, -3.40, -3.33, -3.25, -3.18, -3.12, -3.05,
     :-2.99, -2.92, -2.85, -2.77, -2.68, -2.60, -2.50, -2.41, -2.30,
     :-2.19, -2.08, -1.95, -1.82, -1.68, -1.53, -1.37, -1.20, -1.03, 
     :-0.85, -0.80, -0.75, -0.70, -0.66, -0.61, -0.56, -0.51, -0.46,
     :-0.41, -0.36, -0.31, -0.25, -0.21, -0.16, -0.11, -0.07, -0.03,
     : 0.00,  0.00,  0.01,  0.02,  0.02,  0.01,  0.01,  0.00,  0.00,
     :-0.02, -0.04, -0.07, -0.11, -0.18, -0.27, -0.40, -0.56, -0.77,
     :-1.00, -1.25, -1.62/
      data bessell_x/
     :-0.319, -0.318, -0.317, -0.316, -0.314, -0.313, -0.311, -0.310,
     :-0.308, -0.305, -0.303, -0.301, -0.299, -0.296, -0.294, -0.291,
     :-0.288, -0.283, -0.278, -0.272, -0.266, -0.259, -0.252, -0.246,
     :-0.240, -0.233, -0.226, -0.218, -0.209, -0.200, -0.189, -0.178,
     :-0.166, -0.153, -0.139, -0.124, -0.106, -0.101, -0.096, -0.090,
     :-0.084, -0.078, -0.071, -0.063, -0.053, -0.042, -0.030, -0.016,
     : 0.000,  0.017,  0.037,  0.058,  0.083,  0.102,  0.138,  0.176,
     : 0.215,  0.252,  0.290,  0.329,  0.372,  0.421,  0.477,  0.540,
     : 0.609,  0.684,  0.763,  0.844,  0.925,  1.012,  1.118,  1.240,
     : 1.348,  1.415,  1.447/  


      flag=0

      nmax=nmax_flower
      bc(1:nmax)=flower_bc(1:nmax)
      x(1:nmax)=flower_x(1:nmax)
      
      if (bv<x(1) .or. bv>x(nmax)) flag=1

      

c use numerical recipes subroutine - returns j, where b-v is between
c x(j) and x(j+1)

      call locate(x,nmax,bv,j)

c piece of black magic from numerical recipes p.113

      k = min(max(j-1,1),nmax-2)

         
c now snip out the bits of the arrays we want into dummy arrays

      do j=1,3
        dumx(j)=x(k+j-1)
        dumbc(j)=bc(k+j-1)
      enddo

c now interpolate (parabolic so n=3), returns bcbv and dbcbv (error)

      call polint(dumx,dumbc,3,bv,bcbv,dbcbv)

      end function bcbv


c ****************************
      real function bcvi(vi, logg, teff, flag)
c ****************************

c     Uses a polynomial fit to data (described in the Bols directory) for
c     the red stars, Bessell for the blue stars, and whichever is the
c     larger in the crossover region.
      
      real, intent(in) :: vi, logg, teff
      integer, intent(out) :: flag

      character(len=30) :: cflag
      real :: work1, work2

      flag=0
      if (vi > 4.2) then
        flag=1
      else if (vi > 1.0) then  
        work1 = -0.1216 + 2.0591*vi - 2.0137*vi**2.0
     :      +0.923752*vi**3.0 -0.205533*vi**4.0 +1.697281e-2*vi**5.0
     :      - vi
        if (vi < 1.5) then
          cflag='OK'
          work2=bessell_bc_v(logg, teff, cflag)
          if (trim(cflag) =='OK') work1=max(work1,work2)
        end if
      else
        cflag='OK'
        work1=bessell_bc_v(logg, teff, cflag)
        if (trim(cflag) /='OK') flag=1
      end if

      bcvi=work1

      end function bcvi


c ************************
      real function bcri(ri, flag)
c ************************

c     New function added by timn (see the README in his bols
c     directory April 2006.      
      
      real ri
      integer :: flag

      flag=0
      if (ri<-0.3 .or. ri>2.8) flag=1
                                                               
c     bcri=0.1738985+0.8821769*ri-0.4753564*ri**2
      
      bcri = -0.189001963  +5.58346367*ri -12.7131376*(ri**2.0)  
     :      +12.4155569*(ri**3.0) -5.44285679*(ri**4.0) 
     :      +0.862898767*(ri**5.0)
      
      
      end function bcri



c ************************
      real function bcik(ik, flag)
c ************************
      
c valid for 1.7 < I-K < 5.2     
      
      real ik
      integer :: flag

      flag=0
      if (ik<1.7 .or. ik>5.2) flag=1                                                        

      bcik=1.4316+0.6933*ik-6.189e-02*(ik**2.0)

      end function bcik


      end module colteff_subs

program test

implicit none

!character(len=20) :: str
integer :: str
integer :: iostat

open(unit=2, file='data') 
do 
  read(2,*,iostat=iostat) str
  print*, iostat, str
  if (iostat < 0) exit
end do

end program test

  module define_star

    implicit none

    integer, parameter :: mcol=10

    type a_colour
      real :: data = 0.0
      real :: err = 0.0
      logical :: neg_flux = .false.
      character(len=2) :: flg = 'AA'
    end type a_colour
  
    type a_star
      integer :: field = 0
      integer :: id    = 0
      integer :: ccd   = 0
      integer :: ra_h  = 0
      integer :: ra_m  = 0
      real    :: ra_s  = 0.0
      integer :: dc_d  = 0 
      integer :: dc_m  = 0
      real    :: dc_s  = 0.0
      ! At the moment the rule is that if a declination is negative one of
      ! the above three should be set negative.  Eventually it will all be
      ! done via this variable.
      character(len=1) :: dc_sign = '+'
      real :: x = 0.0
      real :: y =0.0
      type(a_colour), dimension(mcol) :: col
    end type a_star

    logical, private :: pmt_nxtcls_out=.true., pmt_nxtcls_in=.true.
    character(len=100) :: nam_nxtcls_out, nam_nxtcls_in, nam_lstcls_in

    character(len=80), dimension(3), public, save :: cluster_header=' '

    interface zero_star
      
      module procedure zero_star_one
      module procedure zero_star_array

    end interface

    contains

    subroutine write_star(iunit, star, ncol)
      
      ! Writes out a star.  If any of the dc_d, dc_m or dc_s are negative 
      ! the declination is written out with a minus sign.
      ! Otherwise its given a plus sign.
      ! Eventually this code will use dc_sign, but at the moment not enough
      ! code sets it for its value to be reliable.

      integer, intent(in) :: iunit
      type(a_star), intent(in) :: star
      integer, optional :: ncol

      integer :: icol, jcol
      character(len=15) :: form
      type(a_star) :: st
      real :: flux, ferr
      
      jcol=mcol
      if (present(ncol)) jcol=ncol

      st=star

      if (st%x<-9999.99 .or. st%x>99999.99 &
     .or. st%y<-9999.99 .or. st%y>99999.99) then
        st%x=0.0
        st%y=0.0
      end if

      ! Deal with any lingering sign issues.
      if (st%dc_sign/='+' .and. st%dc_sign/='-') st%dc_sign='+'
      if (st%dc_d < 0) st%dc_sign='-'
      if (st%dc_m < 0) st%dc_sign='-'
      if (st%dc_s < 0.0) st%dc_sign='-'

      ! Now negative fluxes, noted in the code by neg_flux.
      do icol=1, jcol
        if (st%col(icol)%neg_flux .and. st%col(icol)%flg(2:2)=='O') then
          ! These are flagged in the output file by M.
          st%col(icol)%flg(2:2)='M'
          ! First get the flux from the magnitude.
          flux=10.0**(-0.4*st%col(icol)%data)
          ! And now uncertainty in flux.
          ferr=10.0**((st%col(icol)%err-st%col(icol)%data)/2.5) - flux
          ! Now the horrible way these are encoded in cluster files.
          ! The magnitude is placed in the uncertainty column with the sign 
          ! changed.
          st%col(icol)%err=-st%col(icol)%data
          ! And the magnitude column is the flux uncertainty converted to a 
          ! magnitude.
          st%col(icol)%data=-2.5*log10(ferr)
        end if
      end do
      
      if (st%id>999999 .or. st%id<-99999) then
        print*, 'Format statement cannot cope as star%id is ', st%id
      end if
      
      inquire(unit=iunit, form=form)
      if (form == 'UNFORMATTED') then
        write(iunit) st%field, st%ccd, st%id, st%ra_h, &
        st%ra_m, st%ra_s, st%dc_sign, abs(st%dc_d), abs(st%dc_m), &
        abs(st%dc_s), st%x, st%y, (st%col(icol)%data, st%col(icol)%err, &
        st%col(icol)%flg,icol=1,jcol)
      else
        write(iunit,10) st%field+real(st%ccd)/100.0, st%id, st%ra_h, &
        st%ra_m, st%ra_s, st%dc_sign, abs(st%dc_d), abs(st%dc_m), &
        abs(st%dc_s), st%x, st%y, (st%col(icol)%data, st%col(icol)%err, &
        st%col(icol)%flg, icol=1,jcol)
      end if
      
 10   format(1x,f6.2,2x,i6,2x,i2.2,1x,i2.2,1x,f6.3,1x, &
                           a1,i2.2,1x,i2.2,1x,f5.2,2x, &
      2(f9.3,2x),4(f9.3,2x,f9.3,2x,a2))
      
    end subroutine write_star

    integer function read_star(iunit, star, ncol)

      integer, intent(in) :: iunit
      type(a_star), intent(inout) :: star
      integer, optional :: ncol

      integer :: icol, jcol, iostat
      character(len=4) :: dc_d
      real :: field_ccd
      character(len=15) :: form
      real :: ferr, flux

      jcol=mcol
      if (present(ncol)) jcol=ncol

      inquire(unit=iunit, form=form)
      if (trim(form) == 'FORMATTED') then
        read(iunit,*,iostat=iostat) field_ccd, star%id, star%ra_h, &
        star%ra_m, star%ra_s, dc_d, star%dc_m, star%dc_s, star%x, &
        star%y, (star%col(icol)%data, star%col(icol)%err, &
        star%col(icol)%flg,icol=1,jcol)
      else if (trim(form) == 'UNFORMATTED') then
        read(iunit,iostat=iostat) star%field, star%ccd, star%id, &
        star%ra_h, star%ra_m, star%ra_s, star%dc_sign, star%dc_d, star%dc_m, &
        star%dc_s, star%x, star%y, (star%col(icol)%data, star%col(icol)%err, &
        star%col(icol)%flg,icol=1,jcol)
      else
        print*, 'Attempting to read file of form ', form
        stop
      end if
      
      if (iostat == 0) then
        
        if (jcol < mcol) then
          do icol=jcol+1, mcol
            star%col(icol)%data=0.0
            star%col(icol)%err=0.0
            star%col%neg_flux=.false.
            star%col(icol)%flg='AA'
          end do
        end if

        do icol=1, ncol
          if (star%col(icol)%flg(2:2) == 'M') then
            ! This is where we sort out the ghastly way negative fluxes are
            ! are stored in cluster files.
            ! The data column stores the uncertainty as a magnitude, get
            ! it as a flux.
            ferr=10.0**(-0.4*star%col(icol)%data)
            ! The uncertaintly stores the flux as a magnitude, but with the
            ! wrong sign.  So first get the flux from it.
            flux=10.0**(0.4*star%col(icol)%err)
            ! And now set the magnitude.
            star%col(icol)%data=-star%col(icol)%err
            ! And is a negative flux.
            star%col(icol)%neg_flux=.true.
            ! Which is unflagged.
            star%col(icol)%flg(2:2)='O'
            ! Finally create an uncertainty in magnitude space.
            star%col(icol)%err= 2.5*log10((ferr+flux)/flux)
          else
            star%col(icol)%neg_flux=.false.
          end if
        end do

        if (trim(form) == 'FORMATTED') then 
          ! Sort out the field and ccd numbers.
          star%field=int(field_ccd)
          if (100*star%field - nint(100.0*field_ccd) == 0) then
            star%ccd=0
          else
            star%ccd=nint(100.0*(field_ccd-real(star%field)))
          end if
      
          read(dc_d,*) star%dc_d
      
          ! Now find all the ways a negative sign declination could have been set.
          star%dc_sign='+'
          if (star%dc_d < 0) star%dc_sign='-'
          if (star%dc_m < 0) star%dc_sign='-'
          if (star%dc_s < 0.0) star%dc_sign='-'
          if (dc_d(1:1) == '-') star%dc_sign='-'
      
          ! When all cluster programs flag negative declination through 
          ! star%dc_sign, we won't need this bit.
          if (star%dc_sign == '-') then
            star%dc_d=-1*abs(star%dc_d)
            star%dc_m=-1*abs(star%dc_m)
            star%dc_s=-1.0*abs(star%dc_s)
          end if

          ! Convert from old-style flags.
          do icol=1, ncol
            if (star%col(icol)%flg(2:2) == ' ') then
              star%col(icol)%flg(2:2)=star%col(icol)%flg(1:1)
              star%col(icol)%flg(1:1)='O'
            end if
            call flagconv(star%col(icol)%flg)
          end do

          ! Get rid of aged values which may crash formats.
          star%col%data=min(star%col%data, 99.999)
          star%col%err =min(star%col%err,  99.999)
          star%col%data=max(star%col%data, -99.999)
          star%col%err =max(star%col%err,  -99.999)

        else

          if (star%dc_sign == '-') then
            star%dc_d=-star%dc_d
            star%dc_m=-star%dc_m
            star%dc_s=-star%dc_s
          end if

        end if

      end if

      read_star=iostat

    end function read_star

    subroutine zero_star_array(star)

      type(a_star), intent(inout), dimension(:) :: star

      integer :: icol

      star%field=0
      star%ccd=0
      star%id=0
      star%ra_h=0
      star%ra_m=0
      star%ra_s=0.0
      star%dc_d=0
      star%dc_m=0
      star%dc_s=0.0
      star%x=0.0
      star%y=0.0
      do icol=1, mcol
        star%col(icol)%data=0.0
        star%col(icol)%err=0.0
        star%col(icol)%neg_flux=.false.
        star%col(icol)%flg='AA'
      end do
    
    end subroutine zero_star_array


    subroutine zero_star_one(star)

      type(a_star), intent(inout) :: star

      integer :: icol

      star%field=0
      star%ccd=0
      star%id=0
      star%ra_h=0
      star%ra_m=0
      star%ra_s=0.0
      star%dc_d=0
      star%dc_m=0
      star%dc_s=0.0
      star%x=0.0
      star%y=0.0
      do icol=1, mcol
        star%col(icol)%data=0.0
        star%col(icol)%err=0.0
        star%col(icol)%neg_flux=.false.
        star%col(icol)%flg='AA'
      end do
    
    end subroutine zero_star_one

    subroutine flux_to_mag(col)

      type(a_colour), intent(inout) :: col
      
      real :: flux, ferr, tinyflux

      ! The smallest absolute value of the flux that we can represent in 
      ! in magnitude space.  (If its negative it uses the M flag.) We never 
      ! want a magnitude as faint as 100th (since it will overrun our format 
      ! statements), which implies a flux greater than 10**-100/2.5. Nor do 
      ! we want a flux so near zero that when we take the log of it we get a 
      ! floating point error.
      tinyflux=max(100.0*tiny(1.0), 1.0e-40)
    
      flux=col%data
      ferr=col%err

      if (flux < 0.0) then
        col%neg_flux = .true.
      else
        col%neg_flux = .false.
      end if

      flux=abs(flux)
      flux=max(tinyflux, flux)
      ferr=max(tinyflux, ferr)

      col%data=-2.5*log10(flux)
      col%err = 2.5*log10((ferr+flux)/flux)

    end subroutine flux_to_mag


    subroutine mag_to_flux(col)

      type(a_colour), intent(inout) :: col
      
      real :: mag, err
    
      mag=col%data
      err=col%err

      if (-mag/2.5 >= log10(huge(col%err)/10.0)) then 
        col%data=huge(col%err)/10.0
      else
        col%data=10.0**(-mag/2.5)
      end if
      ! Evaluating it this way avoids foloating point overflows
      ! if err and mag are both large.  Such a condition happens
      ! when the flux is small.
      if ((err-mag)/2.5 >= log10(huge(col%err)/10.0)) then
        col%err=huge(col%err)/10.0
      else
        col%err= 10.0**((err-mag)/2.5) - col%data
      end if

      if (col%flg =='OM' .or. col%neg_flux) col%data=-1.0*col%data
      ! And remove the flag.
      if (col%flg(2:2) == 'M') col%flg(2:2)='O'

    end subroutine mag_to_flux

    subroutine flagconv(aflag)

      ! Converts the old numerical flags into the new character ones,
      ! assuming the old flags have been read as characters.

      character(len=2), intent(inout) :: aflag

      character, dimension(0:9) :: convert=(/'O', 'N', 'E', 'B', 'S', &
      'I', 'V', 'A', 'F', 'M'/)
      integer :: i, ichr
      character :: test

      do ichr=1, 2
        do i=0, 9
          write(test,'(i1)') i
          if (aflag(ichr:ichr) == test) aflag(ichr:ichr)=convert(i)
        end do
      end do

    end subroutine flagconv


    subroutine sort_star(star, nstars, sort)

      type(a_star), dimension(:), intent(inout) :: star
      integer, intent(in) :: nstars
      character(len=*), intent(in) :: sort

      integer :: i, j, l, ir
      type(a_star) :: swap
      real, dimension(:), allocatable :: sort_key
      real :: sort_swap

      if (nstars < 1) then

        print*, ' Error in s/r sort.  Number of stars is ', nstars
        stop

      else if (nstars > 1) then

        ! If nstars==1, then the data are already sorted!
        
        allocate(sort_key(nstars))
        if (sort == 'increasing_col(1)%data') then
          sort_key=star%col(1)%data
        else if (sort == 'increasing_ra') then
          sort_key = real(star%ra_h) + real(star%ra_m)/60.0 + star%ra_s/3600.0
        else if (sort == 'increasing_dec') then
          sort_key = real(star%dc_d) + real(star%dc_m)/60.0 + star%dc_s/3600.0
          where(star%dc_sign == '-') sort_key=-1.0*abs(sort_key)
        else
          print*, 'Error in s/r sort.  Undefined sort key ', trim(sort)
          stop
        end if

        ir=nstars
        l=ir/2+1
        do
          if (l > 1)then
            l=l-1
            swap=star(l)
            sort_swap = sort_key(l)
          else
            swap=star(ir)
            sort_swap=sort_key(ir)
            star(ir)=star(1)
            sort_key(ir)=sort_key(ir)
            IR=IR-1
            if (ir == 1) then
              star(1)=swap
              sort_key=sort_swap
              exit
            end if
          end if
          i=l
          j=l+l
20        IF(J.LE.IR)THEN
            IF(J.LT.IR)THEN
              IF(sort_key(j) < sort_key(j+1)) j=j+1
            ENDIF
            IF(sort_swap < sort_key(j))THEN
              star(i)=star(j)
              sort_key(i)=sort_key(j)
              I=J
              J=J+J
            ELSE
              J=IR+1
            ENDIF
          GO TO 20
          ENDIF
          star(i)=swap
          sort_key(i)=sort_swap
        end do

        deallocate(sort_key)

      end if

    end subroutine sort_star

    subroutine nxtcls_in(ifname)

      character(len=*) :: ifname

      pmt_nxtcls_in=.false.
      nam_nxtcls_in=ifname

    end subroutine nxtcls_in


    integer function start_reading_cluster_file(iunit, nstars, ncol, colstr)

      ! Opens a cluster format file, and reads the header.
      ! The header ends up in cluster_header.

      ! The unit to be used (one day this should be made clever -- se below).
      integer, intent(out) :: iunit
      ! The number of stars (set to -1 if its a formatted file), and the
      ! number of colours.
      integer, intent(out) :: nstars, ncol
      ! The names of the colours.
      character(len=*), dimension(:), intent(out) :: colstr

      logical :: there
      integer :: iostat, i, itrim
      character(len=10), dimension(mcol) :: unformatted_colstr

      character(len=120) :: work_header

      ! Set iunit.
      iunit=21

      if (pmt_nxtcls_in) then
        get_name: do 
          print*, '> Give input cluster file name.'
          read(*,'(a)') nam_nxtcls_in
          inquire(file=nam_nxtcls_in, exist=there)
          if (there) exit get_name
          print*, 'Cannot find file ', trim(nam_nxtcls_in)
          print*, 'Try again.'
        end do get_name
      else
        pmt_nxtcls_in=.true.
      end if

      open(iunit,file=nam_nxtcls_in,status='old',iostat=iostat)
      start_reading_cluster_file=iostat
      if (iostat /= 0) return
      
      ! Three lines of header.
      read(iunit,*,iostat=iostat) ncol

      ! Now we can establish of this is an unformatted file or not.
      if (iostat/=0 .or. ncol<0 .or. ncol>mcol) then
        ! Try unformatted.
        print*, 'Trying unformatted read for file ', trim(nam_nxtcls_in)
        close(iunit)
        open(iunit,file=nam_nxtcls_in,status='old',form='unformatted')
        read(iunit) cluster_header(2)
        read(iunit) cluster_header(1)
        read(iunit) cluster_header(3)
        read(iunit) ncol
        read(iunit) (unformatted_colstr(i),i=1,ncol)
        colstr(1:ncol)=unformatted_colstr(1:ncol)
        read(iunit) nstars
      else
        rewind(iunit)
        read(iunit,'(a120)') work_header
        read(work_header,*,iostat=iostat) ncol
        if (iostat < 0) ncol=4
        ! Now clear out any comments about the number of colours.
        itrim=index(work_header, '#')
        if (itrim < 1) then
          itrim=index(work_header, 'colours were created.')+21
        end if
        if (itrim < 0) itrim=0
        cluster_header(1)=work_header(itrim+1:len(work_header))
        ! The next line should have the names of the colours on it, but
        ! it may not.
        read(iunit,'(a80)') cluster_header(2)
        read(cluster_header(2),*,iostat=iostat) (colstr(i),i=1,ncol)
        if (iostat < 0) colstr=' '
        read(iunit,'(a80)') cluster_header(3)
        nstars=-1
      end if

      nam_lstcls_in=nam_nxtcls_in

    end function start_reading_cluster_file

    subroutine lstcls_in(ifname)

      character(len=*), intent(out) :: ifname
      
      ifname=nam_lstcls_in

    end subroutine lstcls_in


    integer function read_cluster_file(nstars, ncol, colstr, star) 

      ! Reads in a cluster format file.

      integer, intent(out) :: nstars, ncol
      character(len=*), dimension(:), intent(out) :: colstr
      type(a_star), dimension(:), allocatable, intent(out) :: star
      type(a_star) :: test_star

      integer :: iostat, istar, iunit
      character(len=15) :: form

      read_cluster_file=0

      iostat=start_reading_cluster_file(iunit, nstars, ncol, colstr)

      if (nstars == -1) then
        ! Its a formatted file, so we have to count the hard way.
        rewind(iunit)
        read(iunit,'(/,/)')
        nstars=0
        count_them: do
          iostat=read_star(iunit, test_star, ncol)
          if (iostat < 0) exit count_them
          nstars=nstars+1
        end do count_them
        rewind(iunit)
        read(iunit, '(/,/)')
      end if

      if (allocated(star)) deallocate(star)
      allocate(star(nstars))
      do istar=1, nstars
        iostat=read_star(iunit, star(istar), ncol)
        if (iostat /= 0) then
          print*, 'Error reading that file, iostat is', iostat
          print*, 'For star record ', istar
        end if
      end do

      close(iunit)

    end function read_cluster_file

    subroutine nxtcls_out(ifname)

      character(len=*) :: ifname

      pmt_nxtcls_out=.false.
      nam_nxtcls_out=ifname

    end subroutine nxtcls_out

    subroutine write_cluster_file(ncol, colstr, star, nstars)

      integer, intent(in) :: ncol
      character(len=*), dimension(:), intent(in) :: colstr
      type(a_star), dimension(:), intent(in) :: star
      integer, intent(in) :: nstars

      integer :: iunit, istar

      call start_cluster_file(ncol, colstr, iunit, nstars) 

      do istar=1, nstars
        call write_star(iunit, star(istar), ncol)
      end do

      close(iunit)

    end subroutine write_cluster_file

    subroutine start_cluster_file(ncol, colstr, iunit, nstars) 

      ! Prompts for a cluster file name and writes out the header.

      ! The file will be created as unformatted, if the optional argument
      ! nstars is there, and larger than the operating system variable 
      ! CLUSTER_FORMATTED_MAX_STARS.

      ! Need to add the ability to write extra information in lines
      ! 1 and 3 (optional arguments).

      integer, intent(in) :: ncol
      character(len=*), dimension(:), intent(in) :: colstr
      integer, intent(out) :: iunit
      ! If nstars is not given, it will never write the file unformatted.
      integer, optional :: nstars

      ! Locals.
      logical :: open
      character(len=8) :: date
      character(len=10) :: time
      character(len=80) ::date_time
      integer :: i, iostat
      character(len=80) :: outstr
      logical :: unformatted
      character(len=10), dimension(mcol) :: unformatted_colstr
      integer :: cfms

      ! Get a free unit number.
      find: do i=12, 100
        if (i == 100) then
          print*,'s/r start_cluster_file cannot find a free unit number.'
          stop
        end if
        iunit=i
        inquire(unit=iunit, opened=open)
        if (.not. open) exit find
      end do find

      if (pmt_nxtcls_out) then
        print*, '> Give output file name for catalogue.'
        read(*,'(a)') nam_nxtcls_out
      else
        pmt_nxtcls_out=.true.
      end if
      call date_and_time(date, time)
      date_time=' # File written at '//date(1:4)//'/'//date(5:6)//'/'//date(7:8) &
      //' '//time(1:2)//':'//time(3:4)//':'//time(5:10)

      call getenv('CLUSTER_FORMATTED_MAX_STARS', outstr)
      read(outstr, *, iostat=iostat) cfms
      if (iostat /= 0) cfms=huge(cfms)
      unformatted=.false.
      if (present(nstars)) then
        if (nstars > cfms) unformatted=.true.
      end if
          
      if (unformatted) then
        open(unit=iunit, file=nam_nxtcls_out, status='unknown', &
        form='unformatted')
        outstr=' '
        write(iunit) date_time
        write(iunit) cluster_header(1)
        write(iunit) cluster_header(3)
        write(iunit) ncol
        unformatted_colstr(1:ncol)=colstr(1:ncol)
        write(iunit) unformatted_colstr(1:ncol)
        write(iunit) nstars
      else
        open(unit=iunit, file=nam_nxtcls_out, status='unknown')
        write(iunit,*) ncol, 'colours were created. # ', cluster_header(1)
        write(iunit,*) (trim(colstr(i))//' ',i=1,ncol), date_time
        write(iunit,*) cluster_header(3)
      end if

    end subroutine start_cluster_file

    subroutine set_cluster_header(cluster_header_in)

      character(len=*), dimension(3), intent(in) :: cluster_header_in

      cluster_header=cluster_header_in

    end subroutine set_cluster_header

  end module define_star

module quad

implicit none

contains

  real function quadintflg(x, y, xval, flag, xflg, yflg)

    ! Performs quadratic interpolation.
    ! flag returned as 'OK' for success, '1' if outside x-range,
    ! and hence extrapolated

    real, dimension(:), intent(in) :: x, y
    character(len=*), dimension(:), intent(in), optional :: xflg, yflg
    real, intent(in) :: xval
    character(len=*), intent(out) :: flag

    integer :: i, j
    real :: a, b, c

    ! Start as we hope to go on.
    flag='OK'

    if (size(x) == 2) then
      ! Only enough data for linear interpolation.
      quadintflg=y(1) + (y(2)-y(1))*(x(1)-xval)/(x(1)-x(2))
      if (present(xflg)) then
        do j=1, 2
          if (xflg(j) /= 'OK') flag=xflg(j)
        end do
      end if
      if (present(yflg)) then
        do j=1, 2
          if (yflg(j) /= 'OK') flag=yflg(j)
        end do
      end if
    else
      i=minloc(abs(x-xval),1) 
      ! Always interpolate between the two points either side and the
      ! point whose index is one more (this is for compatibility with 
      ! the numerical recipes routine we used to use, and to ensure 
      ! we do not change the interpolating polynomial between points).
      if ((xval-x(i))/(x(size(x))-x(1)) > 0.0) i=i+1
      ! Don't run off the top.
      if (i >= size(x)) i=size(x)-1
      ! Or the bottom.
      if (i <= 1) i=2
      a = (y(i-1)-y(i))/(x(i-1)-x(i)) - (y(i)-y(i+1))/(x(i)-x(i+1))
      a = a/((x(i-1)*x(i-1)-x(i)*x(i))/(x(i-1)-x(i)) - &
      (x(i)*x(i)-x(i+1)*x(i+1))/(x(i)-x(i+1)))
      b = (y(i-1)-y(i)-a*(x(i-1)*x(i-1)-x(i)*x(i)))/(x(i-1)-x(i))
      c = y(i-1) - a*x(i-1)*x(i-1) - b*x(i-1)
      quadintflg = a*xval*xval + b*xval + c
      if (present(xflg)) then
        do j=i-1, i+1
          if (xflg(j) /= 'OK') flag=xflg(j)
        end do
      end if
      if (present(yflg)) then
        do j=i-1, i+1
          if (yflg(j) /= 'OK') flag=yflg(j)
        end do
      end if
    end if

    ! Did we extrapolate?
    if (xval < minval(x)) then
      i=minloc(x,1)
      quadintflg=y(i)
      flag='1'
    else if (xval > maxval(x)) then
      i=maxloc(x,1)
      quadintflg=y(i)
      flag='1'
    end if

  end function quadintflg

  real function quadint(x, y, xval, flag)

    real, dimension(:), intent(in) :: x, y
    real, intent(in) :: xval
    character(len=*), intent(out) :: flag

    character(len=10), allocatable, dimension(:) :: xflg, yflg

    allocate(xflg(size(x)), yflg(size(y)))

    xflg='OK'
    yflg='OK'

    quadint=quadintflg(x, y, xval, flag, xflg, yflg)

    deallocate(xflg, yflg)

  end function quadint

  real function linint(x, y, xval, flag, xflg, yflg)

    real, dimension(:), intent(in) :: x, y
    ! Note these are interchangeable.  So if you only have one set of
    ! flags you can call it in just one set.
    character(len=*), dimension(:), intent(in), optional :: xflg, yflg
    real, intent(in) :: xval
    character(len=*), intent(out) :: flag
    
    integer :: i

    flag='OK'

    i=minloc(abs(x-xval),1) 
    ! Make i the data point above xval.
    if ((xval-x(i))/(x(size(x))-x(1)) > 0.0) i=i+1
    ! Don't run off the top.
    if (i >= size(x)) i=size(x)
    ! Or the bottom.
    if (i <= 1) i=2
    linint=y(i-1) + (y(i)-y(i-1))*(x(i-1)-xval)/(x(i-1)-x(i))

    ! Was either datapoint flagged?
    if (present(xflg)) then
      if (xflg(i-1) /= 'OK') flag=xflg(i-1)
      if (xflg(i) /= 'OK') flag=xflg(i)
    end if
    if (present(yflg)) then
      if (yflg(i-1) /= 'OK') flag=yflg(i-1)
      if (yflg(i) /= 'OK') flag=yflg(i)
    end if

    ! Did we extrapolate?
    if (xval < minval(x)) then
      flag='1'
    else if (xval > maxval(x)) then
      flag='1'
    end if

  end function linint

end module quad

program for_gaia

  ! Given a FITS file and a set of data points (in cluster format), this
  ! programme creates a file which can be plotted on the image using the 
  ! regions menu in GAIA.

  use ark_file_io
  use define_star

  implicit none

  integer, dimension(2) :: naxis
  real, dimension(:,:), allocatable :: data, axdata

  integer :: nstars, ncol
  character(len=3), dimension(mcol) :: colstr
  type(a_star), dimension(:), allocatable :: star

  integer :: iflag, istar
  integer :: i1, i2, ilow, ihigh
  real :: start1, start2, step1, step2, rlow, rhigh, r1, r2

  integer :: ipos, icol, icol1, icol2
  character(len=50) :: ofname

  iflag=read_cluster_file(nstars, ncol, colstr, star)
  call lstcls_in(ofname)
  ipos=index(ofname, '.')
  if (ipos < 1) ipos=len_trim(ofname)+1
  ofname=ofname(1:ipos-1)//'.ard'

  if (ncol > 2) then
    print*, 'Which number colour do you want as y-axis?'
    do icol=1, ncol
      print*, icol, colstr(icol)
    end do
    read(*,*) icol1
    print*, 'Which number colour do you want as x-axis?'
    do icol=1, ncol
      print*, icol, colstr(icol)
    end do
    read(*,*) icol2
  else
    icol1=1
    icol2=2
  end if
    
  print*, '> Give the FITS file for the best fit to the data.'
  iflag=inpark(naxis, data, axdata)

  open(unit=35, file=ofname)

  step1=(axdata(naxis(1),1)-axdata(1,1))/real(naxis(1)-1)
  start1=axdata(1,1)-step1
  step2=(axdata(naxis(2),2)-axdata(1,2))/real(naxis(2)-1)
  start2=axdata(1,2)-step2

  do istar=1, nstars

    if (star(istar)%col(icol1)%flg/='OO') cycle
    if (star(istar)%col(icol2)%flg/='OO') cycle

    ! And write a file of positions in X-Y space for Gaia.
    !i1=minloc(abs(star(istar)%col(icol2)%data-axdata(1:naxis(1),1)),1)
    !i2=minloc(abs(star(istar)%col(1    )%data-axdata(1:naxis(2),2)),1)
    r1=(star(istar)%col(icol2)%data-start1)/step1
    r2=(star(istar)%col(icol1)%data-start2)/step2
    ! Circle at position.
    ! For VBV diagrams set the circle radius to 2.0
    ! for the EBV diagrams use 4.0
    !write(34,*) 'CIRCLE(', i1, ',', i2, ',', 5.0, ')'
    write(35,*) 'CIRCLE(', r1, ',', r2, ',', 5.0, ')'

    ! And error bars.
    !ilow =minloc(abs(star(istar)%col(icol2)%data-star(istar)%col(icol2)%err-axdata(1:naxis(1),1)),1)
    !ihigh=minloc(abs(star(istar)%col(icol2)%data+star(istar)%col(icol2)%err-axdata(1:naxis(1),1)),1)
    rlow =(star(istar)%col(icol2)%data-star(istar)%col(icol2)%err-start1)/step1
    rhigh=(star(istar)%col(icol2)%data+star(istar)%col(icol2)%err-start1)/step1
    !if (ilow /= ihigh) write(34,*) 'LINE(', ilow, ',', i2, ',', ihigh, ',', i2, ')'
    if (abs(rlow-rhigh) > tiny(rlow)) write(35,*) 'LINE(', rlow, ',', r2, ',', rhigh, ',', r2, ')'

    !ilow =minloc(abs(star(istar)%col(    1)%data-star(istar)%col(    1)%err-axdata(1:naxis(2),2)),1)
    !ihigh=minloc(abs(star(istar)%col(    1)%data+star(istar)%col(    1)%err-axdata(1:naxis(2),2)),1)
    rlow =(star(istar)%col(icol1)%data-star(istar)%col(icol1)%err-start2)/step2
    rhigh=(star(istar)%col(icol1)%data+star(istar)%col(icol1)%err-start2)/step2
    if (abs(rlow-rhigh) > tiny(rlow)) write(35,*) 'LINE(', r1, ',', rlow, ',', r1, ',', rhigh, ')'    
    !if (ilow /= ihigh) write(34,*) 'LINE(', i1, ',', ilow, ',', i1, ',', ihigh, ')'    

  end do

  close(35)

end program for_gaia

program convert

  ! Takes the Seiss files and converts them into the standard format.

  implicit none

  real :: mass, age, teff, logg, logl
  real :: mbol, reff, rstar, rho
  integer :: model, phase, iostat
  character(len=120) :: input

  open(unit=1, file='siessz02.dat')
  open(unit=2, file='siessz02.iso')
  write(2,*) '-----------------------------------'
  write(2,*) 'm       age    Teff     g    log L'
  write(2,*) '-----------------------------------'


  do
    read(1,'(120a)',iostat=iostat) input
    print*, input
    if (iostat < 0) exit
    if (input(1:1) == '#') cycle
    read(input,*) model, phase, logl, mbol, reff, rstar, &
    teff, rho, logg, mass, age
    logl=log10(logl)
    age=age/1.0e+09
    write(2,*) mass, age, teff, logg, logl
  end do

end program convert

       Subroutine SETBUG( )
C
C       Call this at the start of a program.  Then in any subroutines where
C       you have debug statements include in the declarations;
C
       Logical Debug
       Common / bug / Debug
C
C       Then you can write statements like;
C       if (debug) print*, '@ Variable is ', i
C       These statements will only be used if the VMS symbol debug has been
C       set to YES or yes.
C
c       Original by Timn, better version by Koji, ARK Version 3 Version by
c       Timn.
c
       logical Set, arkgsm
       Character*3 String
C
       Set = arkgsm( 'ARK_DEBUG', String )
       If( Set ) THen
         If( String .eq. 'YES' .or. String .eq. 'yes' ) Then
           Debug = .True.
         Else If( String .eq. 'NO' .or. String .eq. 'no' ) Then
           Debug = .False.
         Else
           Write( *, 100 )
100        Format( ' ERROR:: Illegal value of DCL symbol ARK_DEBUG; ',
     1             'use ''yes'' or ''no''.' )
         End If
       Else
         Debug = .False.
       End If
C
       End

program monte

  use ark_file_io
  use cmdfit_subs
  use colteff_subs

  implicit none

  integer :: iflag, colflag, modflag
  integer :: iage, nage
  real :: age, age_low, age_high, age_step
  integer, dimension(2) :: naxis
  real, allocatable, dimension(:,:) :: data, axdata
  character(len=50) :: ofname
  character(len=8) :: age_name
  integer :: i1, i2
  real :: col_start, col_end, mag_start, mag_end, low_mass, high_mass
  ! For a long time this was hard coded in each call as -0.1.
  real, parameter :: pwr_mass=-0.35
  integer :: useful_top, useful_bottom

  integer :: i, imag, icol, istar, multiple, icount
  real :: p_mass, p_teff
  ! The number of stars in the simulation.
  integer :: nstar
  ! The number of stars in the simple isochrone.
  integer, parameter :: niso=10000
  ! The size of the pixels in magnitude.
  real, parameter :: pix_size=0.0025
  ! The binary fraction.
  real :: binary_fraction
  ! More edges.
  real :: mag_min, mag_max, col_min, col_max

  real, dimension(:), allocatable :: star_mag, star_col
  character(len=50) :: isoflag
  logical, dimension(:), allocatable :: isgood
  ! Allow extraoplation in colour-Teff relationship?  You may want to do
  ! this for luminous evolved stars as the gravity grids run out.
  ! Its only allowed to extraoplate in gravity, and this currently only works
  ! for the Bessell atmospheres.
  logical, parameter :: extrap_col_teff=.false.
  !call setbug()

  ! This used to be hard coded 0.04 3.0
  print*, 'What range of masses do you want (low, high)?'
  read(*,*) low_mass, high_mass
  
  print*, 'The following models are available.'
  do i=1, n_models
    if (len_trim(mod_name(i)) > 0) print*, i, trim(mod_name(i))
  end do
  print*, 'What model number do you want?'
  read(*,*) modflag

  print*, 'The available CMDs are '
  do i=1, n_names
    if (len_trim(mag_name(i)) > 0) & 
    print*, i, trim(mag_name(i)), ' vs ', trim(col_name(i)), &
    '   ('//trim(pht_comm(i))//')'
  end do
  print*, 'What colour number do you want?'
  read(*,*) colflag

  print*, 'What binary fraction do you want?'
  read(*,*) binary_fraction

  print*, 'What range of log10(ages) do you want?'
  read(*,*) age_low, age_high
  if (abs(age_low-age_high) > 2.0*tiny(age_low)) then    
    print*, 'What step in age do you want?'
    read(*,*) age_step
    nage=1+nint((age_high-age_low)/age_step)
    if (abs(age_high-age_low-real(nage-1)*age_step)/age_step > 0.0001) then
      print*, 'Age step does not make sense.  You require ', &
      nint(age_high-age_low)/age_step, ' age steps.' 
      stop
    end if
  else
    nage=1
  end if

  each_age: do iage=1, nage

    if (nage == 1) then
      age = age_low
    else
      age = age_low + real(iage-1)*(age_high-age_low)/real(nage-1)
    end if

    print*, 'Doing log10(age)', age


    ! Now calculate the number of stars required.
    nstar=1000000.0
    print*, 'With ', nstar, ' simulated objects.'
    allocate(star_mag(nstar), star_col(nstar), isgood(nstar))

    ! Write out a simple isochrone file.
    call iso_image_name(modflag, colflag, age, ofname)
    open (unit=12, file=trim(ofname)//'.iso')
    write(12,*) 'Colour, magnitude, mass, teff, flag.'
    write(12,*)
    write(12,*)

    call random_seed()

    create_each_star: do istar=1, nstar

      if (istar - 100000*nint(real(istar)/100000) == 0) &
      print*, 'Created ', 100.0*real(istar)/real(nstar), ' percent of stars.'

      multiple=1
      if (istar > nint(real(nstar)*(1.0-binary_fraction))) multiple=2

      call make_star(age, colflag, modflag, low_mass, high_mass, &
      pwr_mass, multiple, star_mag(istar), star_col(istar), p_mass, &
      p_teff, isoflag)
      !call make_star_ubv(age, modflag, low_mass, high_mass, &
      !pwr_mass, multiple, mag, col)
      isgood(istar)=.false.
      if (trim(isoflag)=='OK') isgood(istar)=.true.
      if (trim(isoflag)=='Colour-Teff (grav)' .and. extrap_col_teff) &
      isgood(istar)=.true.
      if (istar <= niso) write(12,*) star_col(istar), star_mag(istar), &
      p_mass, p_teff, trim(isoflag), isgood(istar)
      !print*, istar, star_mag(istar), star_col(istar), isgood(istar)
    end do create_each_star
    close(12)

    ! Pack the arrays.
    icount=0
    do istar=1, nstar
      if (isgood(istar)) then
        icount=icount+1
        star_mag(icount)=star_mag(istar)
        star_col(icount)=star_col(istar)
      end if
    end do
    nstar=icount
    print*, 'There were ', nstar, ' usable stars.'

    ! Find the size of image needed.    
    mag_start=maxval(star_mag(1:nstar))
    mag_end  =minval(star_mag(1:nstar))
    ! Its often best to be a little wider in colour.
    col_start=minval(star_col(1:nstar))-0.2
    col_end  =maxval(star_col(1:nstar))+0.2
    ! Round these to "nice" values.  This makes the grids look nicer, since
    ! the aliasing effects are minimised.
    mag_start=real(int(mag_start/pix_size)  )*pix_size
    mag_end  =real(int(mag_end  /pix_size)+1)*pix_size
    col_start=real(int(col_start/pix_size)+1)*pix_size
    col_end  =real(int(col_end  /pix_size)  )*pix_size
    naxis(1)=nint((col_end-col_start)/pix_size)+1
    naxis(2)=nint((mag_start-mag_end)/pix_size)+1
    print*, 'Grid will be ', naxis
    allocate(data(naxis(1),naxis(2)), axdata(maxval(naxis),2))
    print*, 'Covering mags ', mag_start, ' to ', mag_end
    print*, 'and colours ', col_start, ' to ', col_end
    do i=1, naxis(1)
      axdata(i,1)=col_start+(col_end-col_start)*real(i-1)/real(naxis(1)-1)
    end do
    do i=1, naxis(2)
      axdata(i,2)=mag_start+(mag_end-mag_start)*real(i-1)/real(naxis(2)-1)
    end do

    do istar=1, nstar

      if (istar - 100000*nint(real(istar)/100000) == 0) &
      print*, 'Placed ',  100.0*real(istar)/real(nstar), &
      ' percent of stars in grid.'

      ! Find the pixel number.
      imag=minloc(abs(axdata(1:naxis(2),2)-star_mag(istar)),1)
      icol=minloc(abs(axdata(1:naxis(1),1)-star_col(istar)),1)  

      ! Put the star into the image.
      data(icol,imag)=data(icol,imag)+1.0

    end do

    ! Make the sum over all area (including that not on the grid) one.
    data=data/((1.0+binary_fraction)*real(nstar))

    ! First write out the image file.
    call put_header_i('MODFLAG', modflag, 'Whose isochrones' , 1)
    call put_header_i('COLFLAG', colflag, 'Which colour' , 1)
    call put_header_r('BINFRAC', binary_fraction, 'Binary star fraction' , 1)
    call nxtark_out(ofname)
    iflag=makark(naxis, data, axdata)

    deallocate(data, axdata, star_mag, star_col, isgood)

  end do each_age

end program monte

        program binup

        use ark_file_io

        implicit none

!       Fortran 90 version by Timn.

        real, allocatable :: data(:,:), axdata(:,:)
        integer :: naxis(2), ndim
 
        integer :: i, j, nred(2)
        logical :: first
        data first /.true./
                   
        call setbug()
 
90      i=inpark(naxis, data, axdata) 
        if (i .eq. -1) goto 900

        if (first) then
          if (naxis(1) .ne. 1) then
5           print*, '> Give AXIS1 reduction factor (1=no reduction).'
            read(*,*,err=5) nred(1)
          else
            nred(1)=1
          end if
          if (naxis(2) .ne. 1) then
100         print*, '> Give AXIS2 reduction factor (1=no reduction).'
            read(*,*,err=100) nred(2)
          else
            nred(2)=1
          end if
          first=.false.
        end if

        call doit(data, naxis, nred)
        naxis(1)=naxis(1)/nred(1)
        naxis(2)=naxis(2)/nred(2)

        ndim=1
        if (naxis(2) .gt. 1) ndim=2
        do i=1, ndim
          do j=1, naxis(i)*nred(i), nred(i)
            axdata(((j-1)/nred(i))+1,i)=(axdata(j,i)+axdata(j+nred(i)-1,i))/2.0
          end do
        end do

        i=makark(naxis, data, axdata)
        deallocate(data)
        deallocate(axdata)
        goto 90                                                          
 
900     end


        subroutine doit(data, naxis, nred)
 
        integer :: naxis(2), nred(2)
        real :: data(naxis(1), naxis(2))

        integer :: is, i, j, k
  
        if (nred(1) .ne. 1) then
          do 30 k=1, naxis(2)
            do 20 i=1, naxis(1)/nred(1)
              is=nred(1)*(i-1) + 1
              data(i,k)=data(is,k)
              do 10 j=is+1, is+(nred(1)-1)
                data(i,k)=data(i,k)+data(j,k)
10            continue
20          continue
30        continue
        end if
 
        if (nred(2) .ne. 1) then
          do 130 k=1, naxis(1)/nred(1)
            do 120 i=1, naxis(2)/nred(2)
              is=nred(2)*(i-1) + 1
              data(k,i)=data(k,is)
              do 110 j=is+1, is+(nred(2)-1)
                data(k,i)=data(k,i)+data(k,j)
110           continue
120         continue
130       continue
        end if
 
500     end

use ark_file_io

implicit none
real, dimension(:,:), allocatable :: data
real, dimension(:,:), allocatable :: axdata
integer, dimension(2) :: naxis
integer :: iflag, i

call setbug

iflag=inpark(naxis, data, axdata)

do i=1, naxis(1)
  print*, axdata(i,1), data(i,1)
end do


end

module bessell

    ! Given the gravity and colour, this interpolates
    ! the Bessell models to get the bolometric correction.

    ! Error flag.
    ! 00 = success.
    ! 11 = out of range for gravity.
    ! 12 = out of range for colour.

  use quad

  implicit none

  integer, private, parameter :: mgrav=11
  real, private, save, dimension(mgrav) :: gravity
  real, private, save, dimension(100,mgrav) :: teff=0.0
  integer, private, save, dimension(mgrav) :: nteff
  real, private, save, dimension(100,mgrav) :: bc_v=0.0, u_b=0.0, b_v=0.0, &
  v_i=0.0
  logical, private, save :: first=.true.
  integer, private, save :: ntycho
  real, private, save, dimension(:), allocatable :: delta_bc, delta_col, &
  col_bess, col_tycho
  logical, private, save :: got_tycho=.false.

  ! Do you want the colours of Vega to be zero (the V magnitude is always
  ! 0.03), or do you want it to have the colours implied from the Kurucz
  ! model atmospheres?  See the discussion in Bessell, Castelli & Plez (1998)
  ! vs that in Giradi et al (2002).
  logical, private, parameter :: vega_col_zero=.true.

  contains

  subroutine readfiles()

    integer :: jgrav
    logical :: table2
    integer :: iostat
    real :: teff_in, logg, bc_k, v_r, v_k, j_h, j_k, k_l

    character(len=30) :: data_dir

    first=.false.
    each_grav: do jgrav=1, mgrav
      nteff(jgrav)=0
      gravity(jgrav) = 0.5*real(jgrav) - 0.5
      ! Open up table 2.
      call get_environment_variable('CMDDATA', data_dir)
      open(unit=1, file=trim(data_dir)//'/Bessell/table2.dat', &
      action='read')
      ! And make it clear we have not yet got to table3.
      table2=.true.
      read: do 
        read(1,*, iostat=iostat) teff_in, logg, &
        bc_k, bc_v(nteff(jgrav)+1,jgrav), u_b(nteff(jgrav)+1,jgrav), &
        b_v(nteff(jgrav)+1,jgrav), v_r, v_i(nteff(jgrav)+1,jgrav)
        if (iostat /= 0) then
          if (table2) then
            close(1)
            open(unit=1, file=trim(data_dir)//'/Bessell/table3.dat', &
            action='read')
            read(1,*)
            read(1,*)
            table2=.false.
            cycle read
          else
            close (1)
            exit read
          end if
        end if
        if (abs(logg - (0.5*real(jgrav) - 0.5)) < tiny(gravity(jgrav))) then
          nteff(jgrav)=nteff(jgrav)+1
          teff(nteff(jgrav),jgrav)=log10(teff_in)
        end if
      end do read
      !print*, gravity(jgrav)
      !print*, teff(1:nteff(jgrav),jgrav)
    end do each_grav
    close(1)

  end subroutine readfiles


  real function bessell_col_ub(grav_in, teff_in, flag)

    real, intent(in) :: grav_in, teff_in
    character(len=*), intent(out) :: flag
    real :: work

    work=0.0
    if (vega_col_zero) work=0.004

    if (first) call readfiles()
    bessell_col_ub=bessell_interp(grav_in, teff_in, u_b, flag)+work
    if (flag /= 'OK') flag='Colour-Teff '//trim(flag)

  end function bessell_col_ub


  real function bessell_col_bv(grav_in, teff_in, flag)

    real, intent(in) :: grav_in, teff_in
    character(len=*), intent(out) :: flag
    real :: work

    work=0.0
    if (vega_col_zero) work=0.002

    if (first) call readfiles()
    bessell_col_bv=bessell_interp(grav_in, teff_in, b_v, flag)+work
    if (flag /= 'OK') flag='Colour-Teff '//trim(flag)

  end function bessell_col_bv


  real function bessell_col_vi(grav_in, teff_in, flag)

    real, intent(in) :: grav_in, teff_in
    character(len=*), intent(out) :: flag
    real :: work

    work=0.0
    if (vega_col_zero) work=0.003

    if (first) call readfiles()
    bessell_col_vi=bessell_interp(grav_in, teff_in, v_i, flag)+work
    if (flag /= 'OK') flag='Colour-Teff '//trim(flag)

  end function bessell_col_vi


  real function bessell_bc_v(grav_in, teff_in, flag)

    real, intent(in) :: grav_in, teff_in
    character(len=*), intent(out) :: flag

    if (first) call readfiles()
    bessell_bc_v=bessell_interp(grav_in, teff_in, bc_v, flag)
    if (flag /= 'OK') flag='Bolometric correction '//trim(flag)

  end function bessell_bc_v


  real function bessell_interp(grav_in, teff_in, col, iflag)

    real, intent(in) :: grav_in, teff_in
    real, dimension(:,:), intent(in) :: col
    character(len=50), intent(out) :: iflag

    real, dimension(mgrav) :: col_grav, work_grav
    character(len=50) :: flag

    integer :: jgrav, kgrav

    iflag='OK'

    kgrav=0
    do jgrav=1, mgrav
      ! At each gravity interpolate at the requested temperature.
      col_grav(kgrav+1)=quadint(teff(1:nteff(jgrav),jgrav), &
      col(1:nteff(jgrav),jgrav), teff_in, flag)
      work_grav(kgrav+1)=gravity(jgrav)
      if (flag == 'OK') kgrav=kgrav+1
    end do
    if (kgrav > 1) then
      ! Now interpolate to the appropriate gravity.
      bessell_interp=quadint(work_grav(1:kgrav), col_grav(1:kgrav), &
      grav_in, flag)
      if (trim(flag) == 'OK') then
        !write(57,*) quadint(work_grav(1:kgrav), col_grav(1:kgrav), &
        !grav_in, flag), & 
        !work_grav(1:kgrav), grav_in, col_grav(1:kgrav)
      end if
      if (flag == '1') then
        iflag='(grav)'
        !write(3,*) grav_in, work_grav(1:kgrav), col_grav(1:kgrav)
      end if
    else
      iflag='(teff)'
      !print*, 'Only ', kgrav, ' gravities available at teff ', teff_in
      !stop
    end if

  end function bessell_interp

  subroutine read_tycho()

    character(len=50) :: data_dir
    integer :: i, iostat
    real :: dummy

    if (.not. got_tycho) then

      call get_environment_variable('CMDDATA', data_dir)
      open(unit=1, file=trim(data_dir)//'/Bessell/btvt.dat', &
      action='read')
      read(1,'(/,/)')

      ! Count the number of data points.
      ntycho=0
      count: do
        read(1,*,iostat=iostat) dummy
        if (iostat < 0) exit
        ntycho=ntycho+1
      end do count
      allocate(delta_bc(ntycho), delta_col(ntycho), col_bess(ntycho), &
      col_tycho(ntycho))
      rewind(1)
      read(1,'(/,/)')
      do i=1, ntycho
        read(1,*) col_tycho(i), delta_bc(i), delta_col(i)
      end do
      close(1)
      col_bess=col_tycho+delta_col
      ! print*, 'Read ', ntycho, ' tycho datapoints.'
      got_tycho=.true.

    end if

  end subroutine read_tycho

  real function tycho_bc(colour, flag)

    ! Given a Tycho B-V, this gives the change required to the V
    ! band bolometric correction.

    real, intent(in) :: colour
    character(len=*), intent(inout) :: flag

    call read_tycho()

    ! Since the bc is subtracted from the data, sign is right.
    !print*, colour
    tycho_bc=quadint(col_tycho, delta_bc, colour, flag)
    if (flag /= 'OK') flag='Bolometric correction '//trim(flag)
    !print*, flag
    !print*, col_tycho
    !print*, delta_bc
    !print*, colour
    !stop

  end function tycho_bc

  subroutine tycho_col(colour, flag)

    ! Given a Bessell B-V, this gives the change required to the V
    ! band bolometric correction

    real, intent(inout) :: colour
    character(len=*), intent(inout) :: flag
    real :: work

    call read_tycho()

    ! Since the colour difference is subtracted from the bessell colour.
    colour=colour-quadint(col_bess, delta_col, colour, flag)
    if (flag /= 'OK') flag='Colour-Teff (Tycho)'

  end subroutine tycho_col
  

end module bessell

program iso

  use cmdfit_subs
  use colteff_subs
  use define_star

  implicit none

  integer :: i, colflag, modflag, istar
  integer :: iage, nage
  real :: age, age_low, age_high
  character(len=50) :: ofname
  character(len=8) :: age_name
  integer :: i1, i2
  real :: mass, low_mass, high_mass

  real :: p_mass, p_teff
  character(len=50) :: isoflag
  ! The number of stars in the simulation.
  integer, parameter :: nstar=10000

  type (a_star) :: star

  ! This used to be hard coded 0.04 3.0
  print*, 'What range of masses do you want (low, high)?'
  read(*,*) low_mass, high_mass

  print*, 'The following models are available.'
  do i=1, n_models
    if (len_trim(mod_name(i)) > 0) print*, i, trim(mod_name(i))
  end do
  print*, 'What model number do you want?'
  read(*,*) modflag

  print*, 'The available CMDs are '
  do i=1, n_names
    if (len_trim(mag_name(i)) > 0) & 
    print*, i, trim(mag_name(i)), ' vs ', trim(col_name(i)), &
    '   ('//trim(pht_comm(i))//')'
  end do
  print*, 'What colour number do you want?'
  read(*,*) colflag

  print*, 'What log10(age) do you want?'
  read(*,*) age


  ! Write out a simple isochrone file.
  call iso_image_name(modflag, colflag, age, ofname)
  open (unit=12, file=trim(ofname)//'.iso')
  write(12,*) 'Colour, magnitude, mass, teff, flag.'
  write(12,*)
  write(12,*)
  ! And a cluster format catalogue.
  open (unit=11, file=trim(ofname)//'.cat')
  write(11,*) ' 2 colours'
  write(11,*) mag_name(colflag), ' ', col_name(colflag)
  write(11,*)
  call zero_star(star)
  star%col(1:2)%err=0.01
  star%col(1:2)%flg='OO'

  each_single_star: do istar=1, nstar

    mass=low_mass + (high_mass-low_mass)*real(istar)/real(nstar)

    call make_star(age, colflag, modflag, mass, mass, -0.1, &
    1, star%col(1)%data, star%col(2)%data, p_mass, p_teff, isoflag)
    write(12,*) star%col(2)%data, star%col(1)%data, p_mass, p_teff, &
    trim(isoflag)
    call write_star(11, star, 2)

  end do each_single_star
  close(12)
  close(11)

end program iso

When we moved from ark to fits files and extensions, the 3d capability was
lost.  This file is to help you restore it, by preserving the old routines


        integer function inpark_3d(naxis, data, axdata)
                                                                       
!       Outputs.
!       The lengths of each axis.
        integer, dimension(3) :: naxis
!       The data.
        real, dimension(:,:,:) :: data
!       The axis scales.
        real, dimension(:,:) :: axdata
                                
!       Locals           
        logical :: there
        character(len=8) :: arktyp
        integer :: i, ifail, iunit, iorder
        real, external :: ripoly
        character(len=80) :: input
        double precision, dimension(0:9) :: coefs
        real :: junk1, junk2

!       The header information.
        character*80 dross(180)
        common /pasdrs/ dross

        logical :: debug
        common /bug/ debug

        if (debug) then
          print*, '@ Entering inpark_3d, with;'
          print*, '@    naxis being ', naxis(1), naxis(2), naxis(3)
          print*, '@    the shape of data being ', &
          size(data,1), size(data,2), size(data,3)
          print*, '@    and axdata being ', &
          size(axdata,1), size(axdata,2)
        end if
                   
100     call inpprm('INPARK Version 2.0.', file_in, inter_in, filex, lstfil)
        if (lstfil.eq.'end' .or. lstfil.eq.'END') then 
          inpark_3d = -1
          goto 900
        end if

!       Inquire to see if the file is there, and at the same time find
!       out some other useful facts.
        call arkinq(lstfil, filex, there, arktyp)
        if (.not. there) then
          if (inter_in) then
            print*, 'File not found, please try again.'
            goto 100
          else                            
            inpark_3d=-2
            goto 900
          end if       
        end if
        print*, 'Reading file '//lstfil(1:50)
        call clear_header()
              
!       Now go to the appropriate read routine.
        if (arktyp .eq. 'ARK_FITS') then
          call arkfit_3d(data, naxis, axdata, ifail, inter_in, lstfil)
          if (ifail .ge. 0) then
            itypef=3
            inpark_3d=3
          else                    
            inpark_3d=ifail
          end if
        else if (ArkTyp .eq. 'ARK') Then  ! ARK file
          call arkopn(iunit, lstfil, ' ', 'old', 'readonly', &
          'unformatted', 'sequential', 0)
          read(iunit) naxis(1), (dross(i), i = 1, 36)
          if (naxis(1) .gt. size(data,1)) then
            if (inter_in) then
              print*, 'Array DATA too small in inpark.  The first'
              print*, 'dimension of the array is ', size(data,1)
              print*, 'but the data has ', naxis(1), ' points.'
            end if
            inpark_3d = -99
            goto 900
          end if
          if (naxis(1) .gt. size(axdata,1)) then
            if (inter_in) then      
              print*, 'Array AXDATA too small in inpark.  The first'
              print*, 'dimension of the array is ', size(axdata,1)
              print*, 'but the data has ', naxis(1), ' points.'
            end if
            inpark_3d = -99
            goto 900
          end if
          read(iunit) (data(i,1,1), i = 1, naxis(1))
          read(iunit) coefs
          close(iunit)
          do i = 0, 9
            if (coefs(i) .ne. 0.0) iorder = i
          end do      
          do i = 1, naxis(1)
            axdata(i,1) = RIPOLY(i, coefs, iorder)
          end do      
          inpark_3d = 1
          itypef=1
        else
          ! IUE File     
          call arkopn(iunit, lstfil, ' ', 'old', 'readonly', &
          'formatted', ' ', 0)
          ! Read the header.
          read(iunit,'(a80)') dross(1)
          read(iunit,'(a80)') dross(2)
          read(iunit,'(a80)') dross(3)
          dross(4)='END'
          i=0
          do                                                             
220         Read(iunit, '(A80)', End = 230 ) Input
            read(input, *, end = 220, err = 220 ) junk1, junk2
            i = i + 1
            if (i .gt. size(data,1)) then
              if (inter_in) then
                print*, 'Array DATA too small in inpark.  The first'
                print*, 'dimension of the array is ', size(data,1)
                print*, 'but the input file is bigger.'
              end if     
              inpark_3d = -99
              goto 900
            end if
            if (i .gt. size(axdata,1)) then                
              if (inter_in) then
                print*, 'Array AXDATA too small in inpark.  The first'
                print*, 'dimension of the array is ', size(axdata,1)
                print*, 'but the input file is bigger.'
              end if
              inpark_3d = -99
              goto 900
            end if
            Read(input, *, end = 220, err = 220 ) axdata(i,1), data(i,1,1)
          End Do              
230       close(iunit)
          naxis(1) = i
          naxis(2)=1
          naxis(3)=1
         inpark_3d = 2
          itypef=2
        end if
                    
900       inter_in=.true.
        end function inpark_3d



        subroutine arkfit_3d(data, naxis, axdata, ifail, inter, lstfil)
                                                 
!       ifail is returned as 3 for success.
                                           
!       Passed variables.
        integer, dimension(3) :: naxis
        real, dimension(:,:) :: axdata
        real, dimension(:,:,:) :: data
        integer ifail
        logical inter
        character(len=*) :: lstfil
                     
!       Locals.
        integer*2 inblk(1440)
        real, dimension(2880/4) :: relblk
        double precision bscale, bzero, crval(3), cdelt(3)
        logical scale, reals
        integer i, j, k, iblk, icount, max1, max2, max3, nbit, iunit
                                 
!       Functions called.
        logical, external :: arkgsm
                                                                
        common /bug/ debug
        logical debug

        iunit=0
        call fithed(lstfil, '   ', inter, iunit, ifail)
        if (ifail .ne. 0) goto 900
        ifail=3
        inquire(iunit, nextrec=iblk)
             
        i=get_header_i('BITPIX', nbit)
        if (nbit .eq. -32) then
          reals=.true.
        else if (nbit .eq. 16) then
          reals=.false.
        else
          if (inter) then
            print*, '* Warning BITPIX =', nbit
          else
            ifail=-30
            goto 900
          end if
        end if
        if (get_header_i('NAXIS1', naxis(1)).lt.1 .or. &
          get_header_i('NAXIS2', naxis(2)).lt.1) then
          if (inter) then
            print*,'* Failed to read image size from FITS file header.'
            print*,'* Currently NAXIS1 =', naxis(1), 'NAXIS2 =', &
            naxis(2)
410         print*,'> Please give NAXIS1, NAXIS2 for this file.'
            read(*,*,err=410) naxis(1), naxis(2)
          else
            ifail=-3
            goto 900
          end if
        end if
        if (get_header_i('NAXIS3', naxis(3)) .lt. 1) naxis(3)=1
        if (debug) print*, '@ Array is ', naxis(1), 'x', naxis(2),&
        'x', naxis(3)
        scale=.false.
        if (get_header_d('BSCALE', bscale) .gt. 0) then
          if (debug) print*, '@ bscale is ', bscale
          scale=.true.
        else
          bscale=1.0d0
        end if
        if (get_header_d('BZERO', bzero) .gt. 0) then
          if (debug) print*, '@ bzero is ', bzero
          scale=.true.
        else
          bzero=1.0d0
        end if
              
!       Check that reasonable naxis(1) and naxis(2) values have been found.
        if (naxis(1).gt.size(data,1) .or. naxis(2).gt.size(data,2)) then
          if (inter) then
            print*,'* Possible error in data array dimensions.'
            print*,'* Program data array size is ', size(data,1), &
            'x', size(data,2), 'x', size(data,3)
            print*,'* Data file header gives size as ', &
            naxis(1), 'x', naxis(2), 'x', naxis(3)
          else
            ifail=-99
            goto 900
          end if
        end if
        if (size(axdata,1) .lt. max(naxis(1), naxis(2), naxis(3))) then
          if (inter) then
            print*, '* Possible error in axdata array dimensions.'
            print*, '* Program size is ', size(axdata,1)
            print*, '* Data file header gives longest axis as ', &
            max(naxis(1), naxis(2), naxis(3))
          else
            ifail=-97
            goto 900                        
          end if
        end if  

!       Create the axis information.
        if (get_header_d('CRVAL1', crval(1)) .lt. 1) crval(1)=1.0d+00
        if (get_header_d('CDELT1', cdelt(1)) .lt. 1) cdelt(1)=1.0d+00
        if (get_header_d('CRVAL2', crval(2)) .lt. 1) crval(2)=1.0d+00
        if (get_header_d('CDELT2', cdelt(2)) .lt. 1) cdelt(2)=1.0d+00
        if (get_header_d('CRVAL3', crval(3)) .lt. 1) crval(3)=1.0d+00
        if (get_header_d('CDELT3', cdelt(3)) .lt. 1) cdelt(3)=1.0d+00
        do j=1, 3
          do i=1, naxis(j)
            axdata(i,j)=real(crval(j) + dble(i-1)*cdelt(j))
          end do
        end do
                
!       Read the data.
        max1=naxis(1)
        max2=naxis(2)
        max3=naxis(3)
        if (reals) then                 
          icount=2880/4
          do k=1, max3
            do j=1, max2
              do i=1, max1
                if (icount .eq. 2880/4) then
                  if (debug) print*, '@ About to read block ', iblk
                  read(unit=iunit, rec=iblk) relblk
                  iblk=iblk+1
                  icount=0
                end if
                icount=icount+1
                data(i,j,k)=relblk(icount)
              end do
            end do
          end do
        else
          icount=2880/2
          do k=1, max3
            do j=1, max2
              do i=1, max1
                if (icount .eq. 2880/2) then
                  if (debug) print*, '@ About to read block ', iblk
                  read(unit=iunit, rec=iblk) inblk
                  iblk=iblk+1
                  icount=0
                end if
                icount=icount+1
                data(i,j,k)=inblk(icount)
              end do                         
            end do
          end do
        end if                

        if (scale) then
          if (debug) print*, '@ Applying scale factors...'
          do k=1, naxis(3)
            do j=1, naxis(2)
              do i=1, naxis(1)
                data(i,j,k)=sngl(dble(data(i,j,k))*bscale + bzero)
              end do
            end do
          end do
        end if
              
        if (debug) then
          print*, '@ Test data point (1,1,1) = ', data(1,1,1)
        end if
              
900     close(iunit)
        end subroutine arkfit_3d

module tau_subs

  contains

  subroutine prob_bin(chi2, prob, num, chi2_of_bin, prob_in_bin)

    ! Given a set of chi-squareds, this routine will work out a binned
    ! probability distribution of chi-squared.

    ! The input probability points.
    real, dimension(:), intent(inout) :: chi2, prob 
    ! The number of bins to be used.
    integer, intent(in) :: num
    real, dimension(num), intent(out) :: prob_in_bin, chi2_of_bin
    real, dimension(num) :: weight

    real :: chi2_min, chi2_max
    integer :: i, itest
    real, dimension(num) :: bound_low, bound_up
    real :: work

    ! Do the binning in a log space.
    work=minval(chi2)-1.0
    chi2=log(chi2-work)

    ! Set up some histogram boundaries.
    chi2_min=minval(chi2)
    chi2_max=maxval(chi2)
    ! print*, 'Corresponding chi-squared values are ', chi2_min, chi2_max 

    do i=1, num
      bound_low(i)=chi2_min+real(i-1)*(chi2_max-chi2_min)/real(num)
      bound_up (i)=chi2_min+real(i  )*(chi2_max-chi2_min)/real(num)
    end do

    chi2_of_bin=0.0
    prob_in_bin=0.0
    num_of_chi2=0
    weight=0.0
    itest=0
    each_value: do i_val=1, size(chi2)
      do i=1, num
        if (chi2(i_val)>bound_low(i) .and. chi2(i_val)<=bound_up(i)) then
          prob_in_bin(i)=prob_in_bin(i)+prob(i_val)
          chi2_of_bin(i)=chi2_of_bin(i)+chi2(i_val)*prob(i_val)
          itest=itest+1
          cycle each_value
        end if
      end do
      if (chi2(i_val) <= bound_low(1)) then
        prob_in_bin(1)=prob_in_bin(1)+prob(i_val)
        chi2_of_bin(1)=chi2_of_bin(1)+chi2(i_val)*prob(i_val)
        itest=itest+1
        cycle each_value
      end if
      if (chi2(i_val) > bound_up(num)) then
        prob_in_bin(num)=prob_in_bin(num)+prob(i_val)
        chi2_of_bin(num)=chi2_of_bin(num)+chi2(i_val)*prob(i_val)
        itest=itest+1
        cycle each_value
      end if
      print*, 'Problem ', bound_low(1), chi2(i_val), bound_up(num), i_val
      print*, i_val
      stop
    end do each_value
    where(chi2_of_bin > 0.0) 
      chi2_of_bin=chi2_of_bin/prob_in_bin
    elsewhere
      chi2_of_bin=(bound_up+bound_low)/2.0
    endwhere

    ! Back into the linear space.
    chi2_of_bin=exp(chi2_of_bin) + work

  end subroutine prob_bin

  subroutine sort(xdata, ydata, ndata)

    implicit none

    real, dimension(:), intent(inout) :: xdata, ydata
    integer, intent(in) :: ndata

    integer :: i, j, l, ir
    real :: xswap, yswap

    if (ndata < 1) then
      print*, ' Error in s/r sort.  Number of data points is ', ndata
      stop
    else if (ndata > 1) then
      ! If ndata==1, then the data are already sorted!
      ir=ndata
      l=ir/2+1
      do
        if (l > 1)then
          l=l-1
          xswap=xdata(l)
          yswap=ydata(l)
        else
          xswap=xdata(ir)
          yswap=ydata(ir)
          xdata(ir)=xdata(1)
          ydata(ir)=ydata(1)
          IR=IR-1
          if (ir == 1) then
            xdata(1)=xswap
            ydata(1)=yswap
            exit
          end if
        end if
        i=l
        j=l+l
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(xdata(j) < xdata(j+1)) j=j+1
          ENDIF
          IF(xswap < xdata(j))THEN
            xdata(i)=xdata(j)
            ydata(i)=ydata(j)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
          GO TO 20
        ENDIF
        xdata(i)=xswap
        ydata(i)=yswap
      end do

    end if

  end subroutine sort

end module tau_subs


program tau

  use ark_file_io
  use cmdfit_subs
  use define_star
  use tau_subs

  implicit none

  integer :: ipos, i1, i2, i, j
  real, dimension(:,:), allocatable, save :: data, axdata, output
  integer, dimension(2) :: naxis
  real, dimension(:), allocatable, save :: grad, axgrad
  integer, save :: n_grad
  integer :: iflag
  character :: flag
  character(len=10) :: sflag
  character(len=50) :: ifname

  ! For the cluster file.
  integer :: nstars, ncol, istar, jstar
  character(len=10), dimension(mcol) :: colstr
  type(a_star), dimension(:), allocatable :: star
  character(len=30) :: clus_fil

  ! Integers for colour and magnitude in pixel space.
  integer :: icol, imag, i_mag_sig, i2_low, i2_high

  ! To correct for the number of degrees of freedom.
  integer :: nparams, npts
  
  ! The number of bins.
  integer, parameter :: num=1000
  real, dimension(num) :: tot_chi2_bin, tot_prob_bin, star_prob_bin, star_chi2_bin
  integer :: num_tot, tot_start, tot_end
  real, dimension(num*num) :: prod_prob, prod_chi2
  real, allocatable, dimension(:) :: prob, chi2

  integer :: n_val, i_val
  character(len=50) :: str_range
  real :: low, high
  integer :: jcol1, jcol2
  integer :: iminus, iband, correlated

  ! Distribution of tau for one realisation.
  integer, parameter :: n_one=10000
  real, dimension(n_one) :: tau_one, frac_one
  integer :: near

  real :: expect, sigma
  real, allocatable, dimension(:) :: integ_x, integ_y

  call setbug()

  print*, 'First read in the best fitting model FITS file.'
  iflag=inpark(naxis, data, axdata)
  if (iflag < 0) then
    print*, 'Error reading 2D isochrone file ', ifname
    stop
  end if

  allocate(output(naxis(1), naxis(2)))

  ! Now read the gradient file.
  call lstark_in(ifname)
  ipos=index(ifname, '.fit')
  ifname(ipos:ipos+3)='.grd'
  call nxtark_in(ifname)
  iflag=inpark(n_grad, grad, axgrad)
  if (iflag == -2) then
    print*, 'No gradient file found, using natural normalisation.'
  else if (iflag < 0) then
    print*, 'Error reading gradient file file ', ifname
    stop
  end if

  print*, '> Give the file of data points (or type end for chunk of image).'
  read(*,'(a)') clus_fil

  if (clus_fil == 'end') then

    nstars=1
    allocate(star(1))
    jcol1=1
    jcol2=2

    print*, '> Give uncertainty in magnitude.'
    read(*,*) star(1)%col(jcol1)%err

    star(1)%col(jcol2)%err=sqrt(2.0)*star(1)%col(jcol1)%err
    print*, 'Assuming uncertainty in colour of ', star(1)%col(jcol2)%err

    print*, 'And that the errors are uncorrelated.'
    correlated = 0

    print*, '> Give the number of datapoints and free parameters.'
    read(*,*) npts, nparams

  else

    call nxtcls_in(clus_fil)
    iflag=read_cluster_file(nstars, ncol, colstr, star)

    if (ncol > 2) then
      print*, 'The available magnitudes are'
      do jcol1=1, ncol
        print*, jcol1, colstr(jcol1)
      end do
      print*, 'Give the number of the magnitude you want.'
      read(*,*) jcol1
      print*, 'The available colours are'
      do jcol2=1, ncol
        print*, jcol2, colstr(jcol2)
      end do
      print*, 'Give the number of the colour you want.'
      read(*,*) jcol2
    else
      jcol1=1
      jcol2=2
    end if

    ! Check for flagged stars.
    istar=1
    do 
      if (istar > nstars) then
        exit
      else if (istar == nstars) then
        if (star(istar)%col(jcol1)%flg/='OO' .or. star(istar)%col(jcol2)%flg/='OO') &
        nstars=nstars-1
        exit
      else
        if (star(istar)%col(jcol1)%flg/='OO' .or. star(istar)%col(jcol2)%flg/='OO') then
          print*, 'Removing ', star(istar)%id, star(istar)%col(jcol1)%flg, star(istar)%col(jcol2)%flg
          star(istar:nstars-1)=star(istar+1:nstars)
          nstars=nstars-1
        else
          istar=istar+1
        end if
      end if
    end do

    !do istar=1, nstars
    !  print*, star(istar)%id, star(istar)%col(jcol1)%data, star(istar)%col(jcol2)%data
    !end do
    !print*, nstars

    ! Now lets sort out whether you add or subtract the colour from the
    ! magnitude to get the other magnitude.
    iminus=index(colstr(jcol2), '-')
    if (iminus == 0) then
      print*, 'Cannot find the minus sign in colour ', colstr(jcol2)
      stop
    end if
    iband=index(colstr(jcol2), trim(colstr(jcol1)))
    if (iband == 0) then
      print*, 'Cannot find the magnitude ', trim(colstr(jcol2)), &
      ' in the colour ', trim(colstr(jcol2))
      print*, 'Assuming colours are uncorrelated.'
      correlated=0
    else if (iband > iminus) then
      print*, 'Will add ', trim(colstr(jcol1)), ' to ', trim(colstr(jcol2)), &
      ' to create ', colstr(jcol2)(1:iminus-1)
      correlated = 1
    else
      print*, 'Will subtract ', trim(colstr(jcol2)), ' from ', trim(colstr(jcol1)), &
      ' to create ', trim(colstr(jcol2)(iminus+1:len(colstr(jcol2))))
      correlated = -1
    end if
    if (sum(star%col(jcol1)%err) >= 0.99*sum(star%col(jcol2)%err)) then
      print*, 'The uncertanties in magnitude are larger than in colour so'
      print*, 'I will take them as uncorrelated.'
      correlated = 0
    end if

    print*, '> Give the number of free parameters.'
    read(*,*) nparams
    npts=nstars

    ! Normalise the data.
    call natural_norm(maxval(star(1:nstars)%col(jcol1)%data,1), &
    minval(star(1:nstars)%col(jcol1)%data,1), data, axdata)    

  end if

  ! Set up the single realisation tau (x) axis.
  do i=1, n_one
    tau_one(i)=100.0*(real(i-n_one/2)-0.5)/real(n_one)
  end do
  ! And empty the fraction axis.
  frac_one=0.0

  ! Now, for each star
  each_star: do istar=1, nstars

    print*, 'Doing star ', star(istar)%id

    if (clus_fil == 'end') then

      print*, '> Give range of magnitudes to be used (<cr>=all).'
      read(*,'(a)') str_range

      if (str_range == ' ') then
        i2_low=1
        i2_high=naxis(2)
      else

        read(str_range,*) low, high
        i2_low =minloc(abs(axdata(:,2)-low ),1)
        i2_high=minloc(abs(axdata(:,2)-high),1)

        if (i2_low > i2_high) then
          iflag=i2_low
          i2_low=i2_high
          i2_high=iflag
        end if

      end if

      print*, 'Range of pixels is ', i2_low, i2_high

    else

      ! Find the nearest pixel in colour-magnitude space.
      imag=minloc(abs(axdata(1:naxis(2),2)-star(istar)%col(jcol1)%data),1)
      icol=minloc(abs(axdata(1:naxis(1),1)-star(istar)%col(jcol2)%data),1)

      ! Calculate how many pixels the magnitude uncertainty represents.
      i_mag_sig=nint(star(istar)%col(jcol1)%err/&
      abs(axdata(imag,2)-axdata(imag+1,2)))

      i2_low =max(imag-3*i_mag_sig,1)
      i2_high=min(imag+3*i_mag_sig,naxis(2))
      if (i2_low<1 .or. i2_high>naxis(2)) then
        print*, 'Warning, this star falls outside the image'
        i2_low=max(1, i2_low)
        i2_high=min(i2_high, naxis(2))
      end if
    end if

    output=0.0
    do i2=i2_low, i2_high
      do i1=1, naxis(1) 
        output(i1,i2)=likelihood(data, axdata, grad, i1, i2, &
        star(istar)%col(jcol2)%err, star(istar)%col(jcol1)%err, correlated, flag)
      end do
    end do
    ! Make a file of the output data to look at it.
    !iflag=makark(naxis, output, axdata)
    !stop

    n_val=0
    do i1=1, naxis(1)
      do i2=i2_low, i2_high
        if (output(i1,i2) > tiny(output(i1,i2))) n_val=n_val+1
      end do
    end do

    !print*, 'Found ', n_val, ' pixels above zero.'

    allocate(prob(n_val), chi2(n_val))
    i_val=0
    prob=0.0
    chi2=0.0
    do i1=1, naxis(1)
      do i2=i2_low, i2_high
        if (output(i1,i2) > tiny(output(i1,i2))) then
          i_val=i_val+1
          prob(i_val)=output(i1,i2)
          chi2(i_val)=-2.0*log(output(i1,i2))
        end if
      end do
    end do

    if (i_val /= n_val) then
      print*, 'Problem in tau.'
      stop
    end if

    prob=prob/sum(prob)
    do j=1, n_val
      near=minloc(abs(chi2(j)-tau_one),1)
      frac_one(near)=frac_one(near)+prob(j)
    end do

    call prob_bin(chi2, prob, num, star_chi2_bin, &
    star_prob_bin)

    deallocate(prob, chi2)

    if (istar == 1) then
      tot_prob_bin=star_prob_bin
      tot_chi2_bin=star_chi2_bin

    else

      ! Normalise, to stop numerical overflow.
      tot_prob_bin=1.0e22*tot_prob_bin/maxval(tot_prob_bin)

      ! Find the number of bins with zero in at the end of the array.
      low_empty_bins: do j=1, num
        if (tot_prob_bin(j) >= tiny(tot_prob_bin(j))) then
          tot_start=j
          exit low_empty_bins
        end if
      end do low_empty_bins

      ! Find the number of bins with zero in at the end of the array.
      num_tot=num
      find_empty_bins: do j=num, 1, -1
        if (tot_prob_bin(j) >= tiny(tot_prob_bin(j))) then
          tot_end=j
          exit find_empty_bins
        end if
      end do find_empty_bins

      num_tot=tot_end-tot_start+1

      ! Create a product array.
      do i=1, num
        do j=tot_start, tot_end
          prod_prob((i-1)*num_tot + j-tot_start+1)=&
          tot_prob_bin(j)*star_prob_bin(i)
          prod_chi2((i-1)*num_tot + j-tot_start+1)=&
          tot_chi2_bin(j)+star_chi2_bin(i)
        end do
      end do

      !call sort(prod_chi2, prod_prob, num*num)

      call prob_bin(prod_chi2(1:num*num_tot), prod_prob(1:num*num_tot), num, &
      tot_chi2_bin, tot_prob_bin)

    end if

    print*, 'Modal tau is ', tot_chi2_bin(maxloc(tot_prob_bin)), &
    ' for star ', istar, ' out of ', nstars

    if (clus_fil == 'end') iflag=makark(naxis, output, axdata)

  end do each_star

  allocate (integ_x(1:num-1), integ_y(1:num-1))
  do i=1, num-1
    integ_x(i)=(tot_chi2_bin(i)+tot_chi2_bin(i+1))/2.0
    integ_y(i)=sum(tot_prob_bin(i:num))/sum(tot_prob_bin(1:num))
  end do

  ! Lets measure the variance of the distribution, by measuring the
  ! 68.2 percent confidence interval.
  sigma = (integ_x(minloc(abs(0.159-integ_y),1)) - &
           integ_x(minloc(abs(0.841-integ_y),1)))/2.0
  print*, 'The sigma of the distribution is ', sigma, 'which should'
  print*, 'be approximately the square root of twice the number of free '
  print*, 'parameters ', npts-nparams, 'i.e. ', sqrt(real(2*(npts-nparams)))

  ! Note this is the exectation value were there no free parameters.
  expect=sum(tot_chi2_bin(1:num)*tot_prob_bin(1:num))/sum(tot_prob_bin(1:num))

  ! Not sure what one is supposed to do the the x-axis to allow for
  ! free parameters for the ditribution of individual points.
  open(unit=12, file='one.tau')
  write(12,'(/,/)')
  do j=1, n_one
    write(12,*) tau_one(j), sum(frac_one(j:n_one))/real(nstars)
  end do
  close(12)

  ! Now apply the scaling to allow for free parameters.
  integ_x = (integ_x-expect)
  integ_x = integ_x*real(npts-nparams)/real(npts)
  integ_x=integ_x+expect-real(nparams)

  open(unit=12, file='integ.tau')
  write(12,'(/,/)')
  do i=1, num-1
    write(12,*) integ_x(i), integ_y(i)
  end do
  close(12)

  open(unit=12, file='tau.diff')
  write(12,'(/,/)')
  do i=1, num
    write(12,*) tot_chi2_bin(i), tot_prob_bin(i)
  end do
  close(12)

  print*, ' '
  print*, 'Reading best-fit tau^2 value from grid.fit'
  call nxtark_in('grid.fit')
  iflag=inpark(naxis, data, axdata)
  print*, 'Pr(', minval(data), ') is ', &
  quadint(integ_x, integ_y, minval(data), sflag), &
  ' for ', nparams, ' free parameters.'  
  print*, 'Reduced tau^2 is ', 1.0 + ((minval(data)-expect)/real(nstars-nparams))

end program tau

module phoenix_bessell

  use quad

  implicit none

  integer, parameter, private :: m_grav=13, n_teff=66
  type a_teff
    real, dimension(m_grav) :: logg
  end type a_teff
  type a_corr
    type(a_teff), dimension(n_teff) :: teff
  end type a_corr

  ! Things read in from the data file.
  type(a_corr), save, private :: bc_u, bc_b, bc_v, bc_r, bc_i
  real, save, dimension(n_teff), private :: temp
  real, save, dimension(m_grav), private :: grav
  integer, save, dimension(n_teff), private :: n_grav
  logical, save, private :: first=.true.

contains

  subroutine readfiles()

    ! Allows table of bolometric corrections to be read in.
    integer, parameter :: m_grav=13
    integer, parameter :: n_teff=66
    type a_teff
      real, dimension(m_grav) :: logg
    end type a_teff
    type a_corr
      type(a_teff), dimension(n_teff) :: teff
    end type a_corr
    integer :: i, j, int_grav, int_temp, iostat, j_grav
    real :: u_in, b_in, v_in, r_in, i_in
    real :: grav_in, temp_in

    real, dimension(m_grav) :: col_grav, work_grav
    integer :: k_grav
    character(len=20) :: flag, iflg
    character(len=30) :: data_dir

    ! Define the gravity and temperature arrays.
    grav(1)=5.5
    do i=2, m_grav
      grav(i)=grav(i-1)-0.5
    end do

    temp(1)=2000.
    do i=2, n_teff
      temp(i)=temp(i-1)+100.
      if (i > 51.) then
        temp(i)=temp(i-1)+200.
      end if
    end do

    temp=log10(temp)

    call get_environment_variable('CMDDATA', data_dir)
    open(10, file=trim(data_dir)//'/phoenix_ubv_new1.dat', action='read')
    read(10,*)
    read(10,*)

    n_grav=0
    do 
      read(10,*,iostat=iostat)  temp_in, grav_in, u_in, b_in, v_in, r_in, i_in
      if (iostat < 0) exit
      temp_in=log10(temp_in)
      int_grav=minloc(abs(grav-grav_in),1)
      int_temp=minloc(abs(temp-temp_in),1)
      bc_u%teff(int_temp)%logg(int_grav)=u_in
      bc_b%teff(int_temp)%logg(int_grav)=b_in
      bc_v%teff(int_temp)%logg(int_grav)=v_in
      bc_r%teff(int_temp)%logg(int_grav)=r_in
      bc_i%teff(int_temp)%logg(int_grav)=i_in
      n_grav(int_temp)=n_grav(int_temp)+1
    end do

    close(10)

  end subroutine readfiles


  type(a_corr) function subtract_corr(bc1, bc2)

    type(a_corr), intent(in) :: bc1, bc2

    integer :: i_teff, i_grav

    subtract_corr = bc1
    do i_teff=1, n_teff
      do i_grav=1, m_grav
        subtract_corr%teff(i_teff)%logg(i_grav) = &
        bc1%teff(i_teff)%logg(i_grav) - bc2%teff(i_teff)%logg(i_grav)
      end do
    end do

  end function subtract_corr




  ! Functions to create colours from effective temperatures from 
  ! tabulated ones bolometric corections.
  real function phoenix_col_bv(grav_in, temp_in, flg)

    real, intent(in) :: grav_in, temp_in
    character(len=*), intent(out) :: flg

    if (first) call readfiles()
    phoenix_col_bv=interp(grav_in, temp_in, subtract_corr(bc_v,bc_b), flg)

  end function phoenix_col_bv

  real function phoenix_col_vi(grav_in, temp_in, flg)

    real, intent(in) :: grav_in, temp_in
    character(len=*), intent(out) :: flg

    if (first) call readfiles()
    phoenix_col_vi=interp(grav_in, temp_in, subtract_corr(bc_i,bc_v), flg)

  end function phoenix_col_vi
  


  ! Functions to create bolometric corrections from tabulated ones.
  real function phoenix_blc_u(grav_in, temp_in, flg)

    real, intent(in) :: grav_in, temp_in
    character(len=*), intent(out) :: flg

    if (first) call readfiles()
    phoenix_blc_u=interp(grav_in, temp_in, bc_u, flg)

  end function phoenix_blc_u

  real function phoenix_blc_b(grav_in, temp_in, flg)

    real, intent(in) :: grav_in, temp_in
    character(len=*), intent(out) :: flg

    if (first) call readfiles()
    phoenix_blc_b=interp(grav_in, temp_in, bc_b, flg)

  end function phoenix_blc_b

  real function phoenix_blc_v(grav_in, temp_in, flg)

    real, intent(in) :: grav_in, temp_in
    character(len=*), intent(out) :: flg

    if (first) call readfiles()
    phoenix_blc_v=interp(grav_in, temp_in, bc_v, flg)

  end function phoenix_blc_v

  real function phoenix_blc_r(grav_in, temp_in, flg)

    real, intent(in) :: grav_in, temp_in
    character(len=*), intent(out) :: flg

    if (first) call readfiles()
    phoenix_blc_r=interp(grav_in, temp_in, bc_r, flg)

  end function phoenix_blc_r

  real function phoenix_blc_i(grav_in, temp_in, flg)

    real, intent(in) :: grav_in, temp_in
    character(len=*), intent(out) :: flg

    if (first) call readfiles()
    phoenix_blc_i=interp(grav_in, temp_in, bc_i, flg)

  end function phoenix_blc_i

  real function interp(grav_in, temp_in, col, flg)

    real, intent(in) :: grav_in, temp_in
    type(a_corr), intent(in) :: col
    character(len=*), intent(out) :: flg

    real, dimension(m_grav) :: col_grav, work_grav
    real, dimension(n_teff) :: col_temp, work_temp
    character(len=20) :: flag

    integer :: j_grav, k_temp, j_temp

    flg='OK'

    ! At each gravity, interpolate the bolometric correction at the
    ! appropriate temperature, to make an array at a fixed temperature
    ! but a range of gravities.
    !do j_grav=1, m_grav
    !  col_grav(k_grav+1)=quadint(temp(:), col%teff(:)%logg(j_grav), &
    !       temp_in, flag)
    !  work_grav(k_grav+1)=grav(j_grav)
    !print*, grav(j_grav)
    !  k_grav=k_grav+1
    !end do
    !if (k_grav > 1) then
    !  interp=quadint(work_grav(1:k_grav), col_grav(1:k_grav), grav_in, flag)
    !end if

    ! At each temperature, interpolate the bolometric correction at
    ! the appropriate gravity, to make an array at a fixed gravity
    ! with a range of temperatures.
    k_temp=0
    do j_temp=1, n_teff
      col_temp(k_temp+1)=quadint(grav(1:n_grav(j_temp)), & 
           col%teff(j_temp)%logg(1:n_grav(j_temp)), grav_in, flag)
      !work_temp(j_temp)=grav(j_temp)
      if (flag == 'OK') then
        k_temp=k_temp+1
        work_temp(k_temp)=temp(j_temp)
        !print*, work_temp(k_temp), col_temp(k_temp)
      end if
    end do
    ! print*, grav_in, temp_in
    if (k_temp > 1) then
      interp=quadint(work_temp(1:k_temp), col_temp(1:k_temp), temp_in, flag)
      if (flag == '1') flg='1'
    else
      flg='1'
      interp=0.0
    end if

  end function interp

end module phoenix_bessell

       Subroutine WILDF( fildef, extdef, lastf, lstfil )
                                                  
       ! Given the file specification fildef (e.g. *.*) this routine will
       ! return a file name that matches it, and keep on doing so until
       ! it runs out of names.  On reaching the last name in the series
       ! it will return lastf as true.
                                     
       ! UNIX version, written by Koji in 10 minutes.

       ! Changed by Timn to close the unit it writes the file names to
       ! when it's finished, and not to write out "No match." to the
       ! terminal if no files match.

       ! Purists version for f95.

       ! This statement is needed for the NAG f95 compiler.
       ! use f90_unix_env

       implicit none
                                             
       ! Passed variables.
       character(len=*) :: fildef, lstfil
       character(len=3) :: extdef
       logical :: lastf
                     
       character(len=128), save :: olddef, safe, nextfil, scratch
       character(len=128), external :: addon
       integer :: iflag, iostat
       integer, save :: lun

       character(len=17) :: filnam

       ! This statement is needed when not using the NAG f95 compiler.
       ! integer, external :: getpid
                  
       ! Trap a blank file specification.
       if (fildef.eq.' ' .and. (extdef(1:1).eq.' ' .or. &
       extdef(1:1).eq.char(0))) goto 110

       lastf=.false.
       if( addon(fildef, extdef) .ne. olddef ) then
         ! The input specification is new, save it for later comparison.
         olddef = addon(fildef, extdef)
         ! Now expand the file name.
         call unix_extend( fildef, safe, iflag )
         call find_free( lun )
         filnam='/tmp/wildf.'
         ! filnam='~/wildf.'
         write(filnam(12:17),'(i6.6)') getpid()
         ! You need this in case you go back to writing it in the home
         ! directory.
         call UNIX_EXTEND( filnam, scratch, iflag )
         call arkcom( '/bin/ls ' // &
         addon(safe, extdef) // '> ' // scratch )
         ! * It will crash if you don't have write permission to 
         ! your home directory, or if the disk is full.
         open( lun, file=scratch, status='old' )
         ! Now the file 'wildf.tmp' contains all the file names that
         ! correspond to the input specification, one per line.
         read( lun, '(a)', end=100) nextfil
       end if
       
       lstfil=nextfil
       ! more or less
       read(lun, '(a)', iostat=iostat) nextfil
       if (iostat < 0) then
       !   The current 'lstfil' is the last one.
         lastf = .true.
         close (lun)
         call arkcom( '/bin/rm ' // scratch )
         olddef = ' '
       end if
       goto 900

       ! Case where no files exist that satisfy the input
       ! specification.
100    continue
       close (lun)
       call arkcom( '/bin/rm ' // scratch )
110    lstfil = fildef
       lastf = .true.
       olddef = ' '

900    end

      SUBROUTINE LOCATE(XX,N,X,J)

c     A numerical reciepes routine.

      DIMENSION XX(*)
      JL=0
      JU=N+1
10    IF(JU-JL.GT.1)THEN
        JM=(JU+JL)/2
        IF((XX(N).GT.XX(1)).EQV.(X.GT.XX(JM)))THEN
          JL=JM
        ELSE
          JU=JM
        ENDIF
      GO TO 10
      ENDIF
      J=JL
      RETURN
      END

module ken_hart

    ! Given the colour, this interpolates
    ! the Kenyon and Hartmann relationship to get the bolometric correction
    ! and colour.

    ! Error flag.
    ! 00 = success.
    ! 12 = out of range for colour.

  use quad

  implicit none

  integer, parameter :: nteff=55
  real, private, save, dimension(nteff) :: teff, bc_v, u_b, b_v, &
      v_rc, v_rj, v_i, v_ij, v_j, v_h, v_k, v_l 
  logical, private, save :: first=.true.

  contains

  subroutine readfiles_kh()

    integer :: iteff
    character(len=5) :: sp 

    character(len=30) :: data_dir

    first=.false.
    ! Open up table 5.
    call get_environment_variable('CMDDATA', data_dir)
    open(unit=1, file=trim(data_dir)//'/KenyonHartmann/table5.dat', &
    action='read')
    read(1,'(/,/)')
    each_teff: do iteff=1, nteff
      read(1,*) sp, teff(iteff), bc_v(iteff), u_b(iteff), b_v(iteff), &
      v_rc(iteff), v_rj(iteff), v_i(iteff), v_ij(iteff), v_j(iteff), &
      v_h(iteff), v_k(iteff), v_l(iteff) 
    end do each_teff
    teff=log10(teff)
    close(1)

  end subroutine readfiles_kh

  real function ken_hart_col_vi(teff_in, cflag)

    real, intent(in) :: teff_in
    character(len=*), intent(out) :: cflag

    if (first) call readfiles_kh()
    ken_hart_col_vi=quadint(teff, v_i, teff_in, cflag)

  end function ken_hart_col_vi


  real function ken_hart_bc_v(teff_in, iflag)

    real, intent(in) :: teff_in
    integer, intent(out) :: iflag

    character(len=2) :: cflag

    if (first) call readfiles_kh()
    ken_hart_bc_v=quadint(teff, bc_v, teff_in, cflag)
    iflag=0
    if (cflag /= 'OK') iflag=1

  end function ken_hart_bc_v

  real function ken_hart_col_jh(teff_in, cflag)

    real, intent(in) :: teff_in
    character(len=*), intent(out) :: cflag

    if (first) call readfiles_kh()
    ken_hart_col_jh=quadint(teff, v_h-v_j, teff_in, cflag)

  end function ken_hart_col_jh


  real function ken_hart_bc_j(teff_in, iflag)

    real, intent(in) :: teff_in
    integer, intent(out) :: iflag

    character(len=2) :: cflag

    if (first) call readfiles_kh()
    ! Think about the sign here.  As the star becomes redder, it becomes
    ! brighter in Mj, since the BC appears as negative in the expression
    ! for Mj.
    ken_hart_bc_j=quadint(teff, bc_v+v_j, teff_in, cflag)
    iflag=0
    if (cflag /= 'OK') iflag=1

  end function ken_hart_bc_j

end module ken_hart

program grid

  use define_star
  use cmdfit_subs
  use ark_file_io
  use colteff_subs

  implicit none

  integer, parameter :: n_par=3
  type(a_star), dimension(:), allocatable :: star
  real, dimension(n_par) :: a_par, best_par
  integer :: iflag, n_term, colflag, icol, modflag
  integer :: iostat, i
  integer :: points
  integer, dimension(2) :: naxis, jaxis
  integer, dimension(2) :: var_par
  real, dimension(2) :: start, end
  real, dimension(:,:), allocatable :: data, axdata, rnpts
  character(len=80), dimension(2) :: ctype
  real :: best_value, age_step
  type(a_star) :: test
  integer :: icol1, icol2
  integer :: ncol
  character(len=10), dimension(:), allocatable :: bands
  character(len=50) :: ofname, ifname
  real, dimension(:), allocatable :: best_distrib

  type(a_star), dimension(:), allocatable :: dat

  integer :: nleft
  real, allocatable, dimension(:) :: sorted_distrib
  real :: clipped_tau
  real :: soft_clip

  integer :: iminus, iband, correlated

  real :: mag_shift, colour_shift, global_mag_shift, pix_size, &
  global_colour_shift
  integer :: i_mag_shift
  real :: sys_mag, sys_col
  real :: low_tau

  ! Mode is 1 for searching in age and/or distance modulus.
  ! Anything else for searching in distance modulus and/or extinction.
  real, parameter :: mode=1

  print*, '> Give input catalogue name.'
  read(*,'(a)') ifname
  open(unit=1, file=ifname, action='read')
  read(1,*) ncol
  allocate(bands(ncol))
  read(1,*) bands
  read(1,*)

  print*, '* Will fit magnitude ', bands(1)
  if (ncol == 2) then
    print*, '* Against colour ', bands(2)
    icol1=1
    icol2=2
  else
    print*, '* Available magnitudes are '
    do icol=1, ncol
      print*, '* ', icol, bands(icol) 
    end do
    print*, '> Give the number of the one you want.'
    read(*,*) icol1
    print*, '* Available colours are '
    do icol=1, ncol
      print*, '* ', icol, bands(icol) 
    end do
    print*, '> Give the number of the one you want.'
    read(*,*) icol2
  end if
     

  ! O.K., lets sort out the colours being fitted.
  colflag=-1
  find_col: do icol=1, n_names
    if (trim(col_name(icol)) == trim(bands(icol2))) then
      if (trim(mag_name(icol)) == trim(bands(icol1))) then
        print*, 'Fitting magnitude ', trim(mag_name(icol)), &
        ' against colour ', trim(col_name(icol)), &
        '  ('//trim(pht_comm(icol))//')'
        colflag=icol
        exit find_col
      end if
    end if
  end do find_col
  if (colflag == -1) then
    print*, 'Cannot find colours ', bands(icol1), ' ', bands(icol2)
    stop
  end if
  ! print*, 'Fitting colour flag ', colflag

  ! Now lets sort out whether you add or subtract the colour from the
  ! magnitude to get the other magnitude.
  if (index(bands(icol1), '-') == 0) then
    ! This is truly a magnitude.
    iminus=index(bands(icol2), '-')
    if (iminus == 0) then
      print*, 'Cannot find the minus sign in colour ', bands(icol2)
      stop
    end if
    iband=index(bands(icol2), trim(bands(icol1)))
    if (iband == 0) then
      print*, 'Cannot find the magnitude ', trim(bands(icol2)), &
      ' in the colour ', trim(bands(icol2))
    else if (iband > iminus) then
      print*, 'Will add ', trim(bands(icol1)), ' to ', trim(bands(icol2)), &
      ' to create ', bands(icol2)(1:iminus-1)
      correlated = 1
    else
      print*, 'Will subtract ', trim(bands(icol2)), ' from ', &
      trim(bands(icol)), &
      ' to create ', trim(bands(icol2)(iminus+1:len(bands(icol2))))
      correlated = -1
    end if
  else
    ! Its colour-colour data.
    correlated=0
  end if

  print*, '> Give the extra uncertainty to be added to each magnitude.'
  read(*,*) sys_mag
  print*, '> Give the extra uncertainty to be added to each colour.'
  read(*,*) sys_col

  ! And the model.
  print*, 'The available models are '
  do i=1, n_models
    if (len_trim(mod_name(i)) > 0) print*, i, trim(mod_name(i))
  end do
  print*, '> Give the number for the model.'
  read(*,*) modflag

  points=0
  do
    iostat=read_star(1, test, ncol)
    if (iostat < 0) exit
    if (iostat > 0) then
      print*, 'Error reading file ', trim(ifname)
      stop
    end if
    if (test%col(icol1)%flg /= 'OO') cycle
    if (test%col(icol2)%flg /= 'OO') cycle
    points=points+1
  end do
  allocate(star(points), best_distrib(points))

  rewind(1)
  read(1,'(/,/)')
  i=1
  do 
    iostat=read_star(1, test, ncol)
    if (iostat < 0) exit
    if (test%col(icol1)%flg /= 'OO') cycle
    if (test%col(icol2)%flg /= 'OO') cycle
    star(i)=test
    i=i+1
  end do
  print*, 'Read ', points, ' of ', trim(bands(icol1)), ' vs ', &
  trim(bands(icol2))

  if (mode == 1) then
    ! Age.
    var_par(1)=1
    print*, '> Give range of log10(ages) to be searched.'
    read(*,*) start(1), end(1)
    if (abs(start(1)-end(1)) > 2.0*tiny(end(1))) then
      print*, '> And the log10(age) step to be used.'
      read(*,*) age_step
      naxis(1)=1+nint((end(1)-start(1))/age_step)
      if (abs(end(1)-start(1)-real(naxis(1)-1)*age_step)/age_step > 0.0001) then
        print*, 'Age step does not make sense.  You require ', &
        nint(end(1)-start(1))/age_step, ' age steps.' 
        print*, end(1)-start(1), real(naxis(1)-1)*age_step
        stop
      end if
    else
      naxis(1)=1
    end if
  else 
    ! The extinction in the colour in question.
    var_par(1)=3
    print*, '> Give the range of reddening to search in ', &
    trim(col_name(colflag))
    read(*,*) start(1), end(1)
    print*, '> And the number of reddening points in the grid.'
    read(*,*) naxis(1)
  end if
  ! The distance modulus.
  print*, '> Give the range in distance modulus to be searched.'
  read(*,*) start(2), end(2)
  print*, '> And the number of distance modulus points in the grid.'
  read(*,*) naxis(2)
  var_par(2)=2

  if (mode == 1) then
    ! The extinction in the colour in question.
    print*, '> Give reddening in ', trim(col_name(colflag))
    read(*,*) a_par(3)
  else
    ! Age
    print*, '> Give the log10(age).'
    read(*,*) a_par(1)
  end if

  ! The tau^2 at which data points get clipped out.
  print*, '> Give maximum allowed range of tau^2 (i.e. value of the soft clipping).'
  read(*,*) soft_clip

  allocate(data(naxis(1),naxis(2)), axdata(maxval(naxis),2), &
  rnpts(naxis(1),naxis(2)))

  n_term=2

  allocate(dat(points))

  do i=1, points
    ! Increase the uncertainties by the systematic.
    star(i)%col(icol1)%err  = sqrt(star(i)%col(icol1)%err**2.0 + sys_mag**2.0)
    ! Bug corrected here August 11 2006. 
    ! Used to be...
    ! star(i)%col(2)%err  = sqrt(star(i)%col(icol2)%err**2.0 + 2.0*(sys**2.0))
    ! The changed in the final stages of the NGC2169 paper (1st September 2006)
    ! to allow different uncertainties in mag and colour.
    star(i)%col(icol2)%err  = sqrt(star(i)%col(icol2)%err**2.0 + sys_col**2.0)
    ! Copy the star structure accross, which deals with colour 1.
    dat(i)=star(i)
    ! And now make sure colours are right.
    dat(i)%col(1)%data = star(i)%col(icol1)%data
    dat(i)%col(1)%err  = star(i)%col(icol1)%err
    dat(i)%col(2)%data = star(i)%col(icol2)%data
    dat(i)%col(2)%err  = star(i)%col(icol2)%err
  end do

  if (sum(dat%col(1)%err) >= 0.99*sum(dat%col(2)%err)) then
    print*, 'The uncertanties in magnitude are larger than in colour so'
    print*, 'I will take them as uncorrelated.'
    correlated = 0
  end if

  !  write(20,*) a_par
  !  write(20,*) colflag
  !  write(20,*) modflag
  !  write(20,*) correlated
  !  write(20,*) start
  !  write(20,*) end
  !  write(20,*) soft_clip

  call grid2d(a_par, dat, colflag, modflag, correlated, &
  var_par, start, end, &
  soft_clip, data, axdata, best_value, best_par, best_distrib, rnpts)

  low_tau=minval(best_distrib)

  ofname='grid.fit'
  call typark(2)
  call nxtark_out(ofname)
  jaxis=naxis
  ctype='NOT SET'
  if (mode == 1) then
    if (naxis(1) > 1) ctype(1)='LOG10(AGE)'
  else
    if (naxis(1) > 1) ctype(1)='EXTINCTION'
  end if
  if (naxis(2) > 1) ctype(2)='DISTANCE MODULUS'
  if (trim(ctype(1)) /= 'NOT SET') call put_header_s('CTYPE1', ctype(1), ' ', 1)
  if (trim(ctype(2)) /= 'NOT SET') call put_header_s('CTYPE2', ctype(2), ' ', 1)

  call put_header_r('HI_TAU', high_calc_tau(), 'HIGHEST CALCULABLE TAU^2', 1)

  if (naxis(2) == 1) then
    open(unit=11, file=trim(ofname)//'.asc')
    write(11,'(/,/)')
    do i=1, naxis(1)
      write(11,*) axdata(i,1), data(i,1)
    end do
    close(11)
  else if (naxis(1) == 1) then
    open(unit=11, file=trim(ofname)//'.asc')
    write(11,'(/,/)')
    do i=1, naxis(2)
      write(11,*) axdata(i,2), data(1,i)
    end do
    close(11)
    jaxis(1)=0
  end if
  i=makark(jaxis, data, axdata)

  ofname='grid_npts.fit'
  call nxtark_out(ofname)
  i=makark(jaxis, rnpts, axdata)

  print*, 'Lowest value ', best_value
  do i=1, 2
    print*, ' '
    if (ctype(i)(1:5) == 'LOG10') then
      print*, ' For parameter ', trim(ctype(i)(6:len(ctype)))//'/10^6'
      print*, ' Range searched ', 10.0**(axdata(1,i)-6.0), &
      10.0**(axdata(naxis(i),i)-6.0)
      print*, ' Best value ', 10.0**(best_par(var_par(i))-6.0)
    else
      print*, ' For parameter ', trim(ctype(i))
      print*, ' Range searched ', axdata(1,i), axdata(naxis(i),i)
      print*, ' Best value ', best_par(var_par(i))
    end if
  end do

  call iso_image_name(modflag, colflag, best_par(1), ifname)
  call nxtark_in(ifname)
  iflag=inpark(naxis, data, axdata)

  ! Write a file of the tau^2s
  open (unit=66, file='tau_point.out')
  write(66,*) 'Columns are field, id, colour, magnitude and tau^2'
  write(66,'(/)')
  do i=1, points
    ! If the value of tau is more than half that of a fully clipped point,
    ! clip it.
    write(66,*) dat(i)%field, dat(i)%id, dat(i)%col(2)%data, &
    dat(i)%col(icol1)%data, best_distrib(i)
  end do
  close(66)

  ! Find the number of unclipped point.
  if (soft_clip > 0.0) then
    nleft=0
    clipped_tau=0.0
    do i=1, points
      ! If the value of tau is more than half that of a fully clipped point,
      ! clip it.
      if (best_distrib(i) < low_tau+soft_clip/2.0) then
        nleft=nleft+1
        clipped_tau=clipped_tau+best_distrib(i)
      end if
    end do

    print*, 'After removing clipped points, tau is ', clipped_tau
    print*, 'For ', nleft, ' data points.'
    print*, '(There were ', points, ' before clipping.)'

    ! Now allocate an array, and fill it with the values of tau.
    allocate(sorted_distrib(nleft))
    nleft=0
    do i=1, points
      if (best_distrib(i) < low_tau+soft_clip/2.0) then
        nleft=nleft+1
        sorted_distrib(nleft)=best_distrib(i)
      end if
    end do
  else
    nleft=points
    allocate(sorted_distrib(nleft))
    sorted_distrib=best_distrib
  end if

  ! Now sort them.
  call tau_sort(sorted_distrib)

  ! Write out the unclipped points in apparent magnitude.
  open(unit=32, file='unclipped.cat')
  write(32,*) ncol
  write(32,*) bands(1:ncol)
  write(32,*)
  do i=1, points
    if (soft_clip > 0.0) then
      if (best_distrib(i) < low_tau+soft_clip/2.0) &
      call write_star(32, star(i), ncol)
    else
      call write_star(32, star(i), ncol)
    end if
  end do
  close(32)


  ! Change to absolute magnitude and write out the unclipped points.
  bands(icol1)='('//trim(bands(icol1))//')o'
  bands(icol2)='('//trim(bands(icol2))//')o'
  open(unit=32, file='unclipped_abs.cat')
  write(32,*) ncol
  write(32,*) bands(1:ncol)
  write(32,*)
  do i=1, points
    call reddening(colflag, -best_par(2), -best_par(3), &
    star(i)%col(icol2)%data, star(i)%col(icol1)%data)
    if (soft_clip > 0.0) then
      if (best_distrib(i) < low_tau+soft_clip/2.0) &
      call write_star(32, star(i), ncol)
    else
      call write_star(32, star(i), ncol)
    end if
  end do
  close(32)


  ! Change to absolute magnitude and write out the unclipped points.
  ! This is complex as the magnitude shift is colour dependent.
  ! The following only does the job to the nearest half pixel.
  ! Find the magnitude shift at the middle pixel.
  global_colour_shift=(axdata(1,1)+axdata(naxis(1),1))/2.0
  global_mag_shift=0.0
  call reddening(colflag, best_par(2), best_par(3), &
  global_colour_shift, global_mag_shift)
  ! Apply it.
  axdata(1:naxis(2),2)=axdata(1:naxis(2),2)+global_mag_shift
  do i=1, naxis(1)
    ! For each colour, work out the shift from nominal.
    colour_shift=axdata(i,1)
    mag_shift=0.0
    call reddening(colflag, best_par(2), best_par(3), &
    colour_shift, mag_shift)
    mag_shift=mag_shift-global_mag_shift
    pix_size=(axdata(naxis(2),2)-axdata(1,2))/real(naxis(2)-1)
    i_mag_shift=nint(mag_shift/pix_size)
    if (i_mag_shift > 0) then
      data(i,1+i_mag_shift:naxis(2))=data(i,1:naxis(2)-i_mag_shift)
      data(i,1:i_mag_shift)=0.0
    else if (i_mag_shift < 0) then
      data(i,1:naxis(2)+i_mag_shift)=data(i,1-i_mag_shift:naxis(2))
      data(i,naxis(2)+i_mag_shift+1:naxis(2))=0.0
    end if
  end do
  ! Apply the colour shift..
  global_colour_shift=global_colour_shift-(axdata(1,1)+axdata(naxis(1),1))/2.0
  axdata(1:naxis(1),1)=axdata(1:naxis(1),1)+global_colour_shift

  call nxtark_out('best_model.fit')
  iflag=makark(naxis, data, axdata)

  open(unit=22, file='distrib.tau')
  write(22, '(/,/)')
  write(22,*) 0.0, 1.0
  do i=1, nleft
    write(22,*) sorted_distrib(i), real(nleft-i+1)/real(nleft)
    write(22,*) sorted_distrib(i), real(nleft-i)/real(nleft)
  end do
  close(22)

end program grid

       Subroutine RDAI( X, Y, maxP, Pix, C, Order, iUnit, ifName, Flag )
C
C       This subroutine reads ARK and IUE files without asking the 
C       file type.  The Unit number passed to it is ignored.
C
        use get_header

       Integer maxP, Pix, Order, iUnit, Flag, Pix2
       Real X( maxP ), Y( maxP )
       Double Precision C( 0: 9 )
       Character*50 ifName
C
       Integer I, J, K, Labour, Test, Unit
       Real RMS
       Logical There, Warned
       Character Answer, ArkTyp*7
C
       Character*80 Dross( 180 ), Input
       Logical Debug
       Common / pasDrs / Dross
       Common / bug / Debug
C
       Real RIPOLY
C
       Do K = 1, 180
         Dross( K ) = ' '
       End Do
C
       Warned = .False.
       If( Flag .lt. 1000 ) Then       ! Interactive Mode
         Flag = 0
         There = .False.
         Do While( .not. There )       ! Keep asking
           Call WRITEN( 'Input file name (or END or $ VMS_command) >' )
           Read( *, '(A50)', End = 300 ) ifName
           If( ifName .eq. 'end' .or. ifName .eq. 'END' ) Then
             Flag = -1                     ! Abort reading
             If( Debug ) Call RDAI_ERROR( Flag )
             Return
           Else If( ifName( 1: 1 ) .eq. '$' ) Then
             Call arkcom( ifName( 2: 50 ))
           End If
            Call ARKINQ( ifName, ' ', There, ArkTyp )
         End Do
       Else                            ! Batch mode
         Flag = 0
          Call ARKINQ( ifName, ' ', There, ArkTyp )
         If( .not. There ) Then       ! Abort reading
           Flag = -2
           If( Debug ) Call RDAI_ERROR( Flag )
           Return
         End If
       End If
C
       Call ARKINQ( ifName, ' ', There, ArkTyp )
C
       If( ArkTyp .eq. 'ARK' ) Then       ! ARK file
         Flag = 1
          call arkopn(Unit, ifName, ' ', 'old', 'readonly', 
     1         'unformatted', 'sequential', 0)
         Read( Unit ) Pix, ( Dross( K ), K = 1, 36 )
         If( Pix .gt. maxP ) Then
           Flag = -99
           If( Debug ) Call RDAI_ERROR( Flag )
           Return
         End If
         Test = GET_HEADER_C( 'SIMPLE  ', Answer )
         If( Test .lt. 0 ) Then
           If( Debug ) Then
             Write( *, 110 )
110             Format( ' WARNING:: this is an old ARK file' )
             Warned = .True.
           End If
         Else If( Answer .ne. 'A' ) Then
           Flag = -11
           If( Debug ) Call RDAI_ERROR( Flag )
           Return
         End If
c         Test = GET_HEADER_C( 'REALTYPE', Answer )
c         If( Test .eq. -1 ) Then
c           If( Debug .and. .not. Warned ) Then
c             Write( *, 110 )
c           End If
c         Else If( Answer .ne. 'V' ) Then
c           Flag = -12
c           If( Debug ) Call RDAI_ERROR( Flag )
c           Return
c         End If
         Test = GET_HEADER_I( 'NAXIS   ', Labour )
         If( Test .eq. -1 ) Then
           If( Debug .and. .not. Warned ) Then
             Write( *, 110 )
             Warned = .True.
           End If
         Else If( Labour .ne. 1 ) Then
           If( Labour .eq. 2 ) Then
             Test = GET_HEADER_I( 'NAXIS2  ', Labour )
             If( Test .eq. -1 ) Then
              Flag = -21
              If( Debug ) Call RDAI_ERROR( Flag )
              Return
             Else If( Labour .ne. 1 ) Then
              Flag = -22
              If( Debug ) Call RDAI_ERROR( Flag )
              Return
             End If
           Else
             Flag = -13
             If( Debug ) Call RDAI_ERROR( Flag )
             Return
           End If
         End If
         Test = GET_HEADER_I( 'NAXIS1  ', Labour )
         If( Test .eq. -1 ) Then
           If( Debug .and. .not. Warned ) Then
             Write( *, 110 )
             Warned = .True.
           End If
         Else If( Labour .ne. Pix ) Then
           Flag = -14
           If( Debug ) Call RDAI_ERROR( Flag )
           Return
         End If
         Read( Unit ) ( Y( J ), J = 1, Pix )
         Read( Unit ) C
         Close( Unit )
         Do K = 0, 9
           If( C( K ) .ne. 0.0 ) Order = K
         End Do
         Do J = 1, Pix
           X( J ) = RIPOLY( J, C, Order )
         End Do
C
       Else                            ! IUE File
         Flag = 2
          call arkopn(Unit, ifName, ' ', 'old', 'readonly',
     &    'formatted', ' ', 0)
         J = 1
         Do While( .True. )
220           Read( Unit, '(A80)', End = 230 ) Input
            Read( Input, *, End = 220, Err = 220 ) X( J ), Y( J )
           J = J + 1
           If( J .gt. maxP ) Then
             Flag = -98
             If( Debug ) Call RDAI_ERROR( Flag )
             Return
           End If
         End Do
230         Continue
         Close( Unit )
          Pix = J - 1
         Order = 0
170       Do J = 1, 36
           Dross( J ) = ' '
         End Do
       End If
       
       Return
C
300       Continue
       Flag = -1
C
       End
    

module cmdfit_subs

  use colteff_subs

  implicit none

  real, private :: extra_mag, high_tau=-1.0

  contains

  real function high_calc_tau()

    high_calc_tau=high_tau/2.0

  end function high_calc_tau

  subroutine natural_norm(mag_max, mag_min, data, axdata)
    
    real, intent(in) :: mag_max, mag_min
    real, intent(inout), dimension(:,:) :: data, axdata

    integer :: npix, imag
        
    ! Fint the number of pixels we must sum over (avoids the number
    ! of pixels changing by +/-1 as you move over pixel boundaries).
    npix = abs(nint(real(size(data,2)) * &
    (mag_max-mag_min)/(axdata(size(data,2),2)-axdata(1,2))))
    ! Find the nearest position in mag, avoiding problems if
    ! magnitude axes run in the wrong direction).
    imag=min( minval(minloc(abs(mag_min-axdata(1:size(data,2),2)))), &
    minval(minloc(abs(mag_max-axdata(1:size(data,2),2)))))
    if (imag < 1) then
      npix=imag+npix-1
      imag=1
    end if
    if (imag+npix-1 > size(data,2)) npix=size(data,2)+1-imag
    if (imag<1 .or. imag+npix-1>size(data,2)) then
      print*, 'Problem ', imag, imag+npix-1
      stop
    end if
    data=data/sum(data(:,imag:imag+npix-1))

  end subroutine natural_norm

    subroutine make_star(age, colflag, modflag, low_mass, up_mass, &
    pwr_mass, multiplicity, mag, col, p_mass, p_teff, flag_out)

    ! The flags indicating which age, colour and model to use.
    real, intent(in) :: age
    integer, intent(in) :: colflag, modflag
    ! For this model the range of mass and power-law distribution
    ! in mass to be simulated.
    real, intent(in) :: up_mass, low_mass, pwr_mass 
    ! dN/dlog(M) = M**(-1 + pwr_mass), or dN/dM = M**(-2 + pwr_mass), or
    ! N = M**(-1 + pwr_mass).
    ! Thus for a Salpeter mass function (-1+pwr_mass)=-1.35; pwr_mass=-0.35
    ! For a 40Myr DAM isochrone, the following numbers give roughly
    ! evenly spaced stars over an Mv range of 2 to 11.
    ! real, parameter :: up_mass=1.9, low_mass=0.36, pwr_mass=-1.5
    ! Flag indicating multiplicity (1=single, 2=binary, 3=triple etc).
    integer :: multiplicity

    ! The colour and magnitude of the stars created. 
    ! The mass and effective temperature of the primary star.
    real, intent(out) :: mag, col
    real, intent(out) :: p_mass, p_teff
    ! A character flag, 'OK' if things are.
    character(len=*), intent(out) :: flag_out

    ! Locals.
    logical, save :: first=.true.
    character(len=50) :: isofil
    real, save :: col1, col2, mag1, mag2
    real :: harvest, grad
    real, dimension(multiplicity) :: mass, uflux, bflux, vflux, iflux
    real :: umb, bmv, vmi, v
    integer :: i, iminus
    logical :: v_vmi_like, v_bmv_like, umb_bmv_like
    character(len=20) :: flag, work_flag

    if (modflag == 0) then

      ! This is test code, which creates a linear isochrone.

      if (multiplicity /= 1) then
        print*, 'Cannot create a binary sequence for a linear isochrone.'
        stop
      end if

      if (first) then
        print*, '> Give the name of the isochrone (.iso) file.'
        read(*,*) isofil
        open(unit=10, file=isofil, action='read')
        ! Rob's 6 lines of header.
        read(10,'(/,/,/,/,/)')
        read(10,*) col1, mag1
        read(10,*) col2, mag2
        close(10)
        ! Now, chop a magnitude off the start and end points to allow
        ! for a range of possible distance modulii when fitting.
        grad=(col1-col2)/(mag1-mag2)
        mag1=mag1+1.0
        col1=col1+grad
        mag2=mag2-1.0
        col2=col2-grad
        first=.false.
      end if

      call random_number(harvest)
      ! Calculate the start and range of the isochrone in colour space
      ! space.
      col=col1+(col2-col1)*harvest
      ! And now in magnitude (remembering to reverse the gradient).
      mag=mag1+(mag2-mag1)*harvest

    else

      ! Create a real isochrone.       

      ! First find out if the colours are of the form V vs V-I or V vs B-V.
      umb_bmv_like=.false.
      v_vmi_like=.false.
      v_bmv_like=.false.
      ! First is this colour/colour?
      iminus=index(mag_name(colflag), '-') 
      if (iminus > 0) then
        ! O.K., is it in the correct order?
        if (trim(mag_name(colflag)(iminus+1:len(mag_name(colflag)))) /= &
          col_name(colflag)(1:index(col_name(colflag), '-')-1)) then
          print*, 'Colour not of form U-B vs B-V.'
          stop
        else
          umb_bmv_like=.true.
        end if
      else
        iminus=index(col_name(colflag), '-') 
        if (iminus == 0) then
          print*, 'Cannot find the minus in ', col_name(colflag)
          stop
        else
          if (trim(mag_name(colflag)) == col_name(colflag)(1:iminus-1)) then
            v_vmi_like=.true.
          else if (trim(mag_name(colflag)) == &
            trim(col_name(colflag)(iminus+1:))) then
            v_bmv_like=.true.
          else
            print*, 'Cannot find ', trim(mag_name(colflag)), ' in ', &
            trim(col_name(colflag))
            stop
          end if
        end if
      end if


100   each_component: do i=1, multiplicity

        call random_number(harvest)
        if (i == 1) then
          mass(1) = (low_mass**pwr_mass - &
          harvest*(low_mass**pwr_mass-up_mass**pwr_mass))**(1.0/pwr_mass)
          ! Work out the primary's temperature.
          p_teff=10.0**isochr('mas', mass(i), 'tef', age, colflag, modflag, flag)
        else
          mass(i) = mass(i-1)*harvest
          ! Hack to cut off at 0.25Mo for simulation of effect of
          ! binary wedge for original tau^2 paper.
          !if (mass(i) < 0.25) then
          !  flux1(i)=0.0
          !  flux2(i)=0.0
          !  cycle each_component
          !end if
        end if
        if (v_vmi_like .or. v_bmv_like) then
          v=isochr('mas', mass(i), 'mag', age, colflag, modflag, flag)
        else if (umb_bmv_like) then
          ! In the colour-colour case get V from another isochrone.
          v=isochr('mas', mass(i), 'mag', age, colflag-1, modflag, flag)
        end if
        ! Now, if the flag is not OK, continue, but note the fact.
        work_flag=flag
        if (v_bmv_like .or. umb_bmv_like) then
          bmv=isochr('mas', mass(i), 'col', age, colflag, modflag, flag)
          vmi=0.0
        else if (v_vmi_like) then
          vmi=isochr('mas', mass(i), 'col', age, colflag, modflag, flag)
          bmv=0.0
        end if
        if (flag /= 'OK') work_flag=flag
        if (umb_bmv_like) then
          ! In the colour-colour case U-B is stored as a magnitude.
          umb=isochr('mas', mass(i), 'mag', age, colflag, modflag, flag)
          if (flag /= 'OK') work_flag=flag
        else
          umb=0.0
        end if
        if (i == 1) then
          flag_out=work_flag
        else
          ! This is a secondary star.  
          if (trim(work_flag) /= 'OK') then
            ! Only possible error is that its dropped 
            ! off the bottom of the isochrone.  
            ! Set fluxes already to zero.
            uflux(i)=0.0
            bflux(i)=0.0
            vflux(i)=0.0
            iflux(i)=0.0
            cycle each_component
          end if
        end if
        uflux(i)=10.0**(-0.4*(v+bmv+umb))
        bflux(i)=10.0**(-0.4*(v+bmv))
        vflux(i)=10.0**(-0.4*v)
        iflux(i)=10.0**(-0.4*(v-vmi))

      end do each_component

      ! Add up all the components.
      if (v_vmi_like) then
        mag=-2.5*log10(sum(vflux))
        col=-2.5*log10(sum(vflux)/sum(iflux))    
      else if (v_bmv_like) then
        mag=-2.5*log10(sum(vflux))
        col=-2.5*log10(sum(bflux)/sum(vflux))
      else if (umb_bmv_like) then
        mag=-2.5*log10(sum(uflux)/sum(bflux))
        col=-2.5*log10(sum(bflux)/sum(vflux))
        extra_mag=-2.5*log10(sum(vflux))
      end if
      p_mass=mass(1)

    end if

  end subroutine make_star

  real function v_for_ubv()

    v_for_ubv=extra_mag

  end function v_for_ubv

  subroutine iso_image_name(modflag, colflag, age, filnam)

    integer, intent(in) :: modflag, colflag
    real :: age
    character(len=*), intent(out) :: filnam

    character(len=8) :: age_name

    write(age_name, 30) int(age+tiny(age)), nint(100*(age-int(age+tiny(age))))
30  format(i5.5, '.', i2.2)

    filnam=trim(mod_name(modflag))//'_'// &
           trim(mag_name(colflag)) //'_'// &
           trim(col_name(colflag)) //'_'// &
                age_name          //'.fit'

  end subroutine iso_image_name

  real function likelihood(data, axdata, grad, icol, imag, sig_col, &
    sig_mag, correlated, flag, sum_gauss)
    
    ! The unsmoothed image and axes.
    real, dimension(:,:), intent(in) :: data, axdata
    real, dimension(:), allocatable :: grad
    ! The co-ordinates of the position being considered.
    integer, intent(in) :: icol, imag
    real, intent(in) :: sig_col, sig_mag
    ! If correlated is zero the colour and magnitude uncertainties are taken
    ! to be uncorrelated.  If its 1, they are correlated as would
    ! be expected in I vs R-I; if its -1 as for V vs V-I (i.e. its whether 
    ! you add or subtract the colour to make the other magnitude).  
    ! If the uncertainties are correlated, make sure sig_col > sig_mag.
    integer, intent(in) :: correlated
    character, intent(out) :: flag

    real, optional, intent(out) :: sum_gauss

    ! We cut off the Gaussian smoothing the 2D distribution at some sigma.
    real, parameter :: sig_cut=3.0
    real, parameter :: pi=3.141592654

    ! Gradient in mag-mag space, and uncertainty in second magnitude.
    real :: mag_grad, mag_sig
    integer :: iicol, iimag, i1, i2
    real :: col, mag
    real :: work
    real, save :: area, pix1, pix2
    real :: d_col, d_mag, gauss, rho, gauss_norm
    logical, save :: first=.true.
    
    if (first) then
      ! Find the area of a pixel.
      pix1=(axdata(size(data,1),1)-axdata(1,1))/real(size(data,1)-1)
      pix2=(axdata(size(data,2),2)-axdata(1,2))/real(size(data,2)-1)
      area=abs(pix1*pix2)
      first=.false.
    end if

    ! Find the nearest positions in X and Y.
    col=axdata(icol,1)
    mag=axdata(imag,2)

    ! How far out do we need to go? 
    iicol=nint(sig_cut*sig_col/abs(pix1))
    iimag=nint(sig_cut*sig_mag/abs(pix2))

    ! For correlated uncertainties calculate mag_sig.
    if (correlated == 0) then
      mag_sig=sig_col
    else
      if (sig_mag > sig_col) then
        mag_sig=sig_mag/2.0
      else
        mag_sig=max(sqrt(sig_col**2.0 - sig_mag**2.0), sig_mag/2.0)
      end if
    end if

    ! Now we normalise the model so it is one within the magnitude
    ! range.


    if (present(sum_gauss)) then
      sum_gauss=0.0
      
      fudge: do i1=icol-iicol, icol+iicol

        ! This sums up the volume under the uncertainty ellipse which
        ! lies on the area of the model.  If it falls outside the colour
        ! range of the image we still add up the volume.  This is because
        ! monte trims in colour to save space.  In magnitude its a
        ! different story.  The model may well be non-zero outside the
        ! magnitude range, so we need to calculate what fraction of this 
        ! error ellipse falls within the monte grid.

        ! This works for all values of i1, even if they lie outside the grid.
        work=axdata(1,1) + (pix1*real(i1-1)) - col

        do i2=max(imag-iimag, 1), min(imag+iimag, size(data,2))
          
          d_mag=(axdata(i2,2)-mag)/sig_mag
          if (correlated == 0) then
            d_col=work/sig_col
          else if (correlated == 1) then
            d_col=(axdata(i2,2)-mag)+work
            d_col=d_col/mag_sig
          else if (correlated == -1) then
            d_col=(axdata(i2,2)-mag)-work
            d_col=d_col/mag_sig
          else 
            print*, 'Unacceptable value of ', correlated
            stop
          end if
          gauss=exp(-0.5*(d_mag**2.0 + d_col**2.0))
          sum_gauss=sum_gauss+(area*gauss)
          
        end do
      end do fudge

      sum_gauss=sum_gauss/(2.0*pi*mag_sig*sig_mag)

    end if


    ! Removed this if.  It used to check you didn't skip off the edge of the
    ! image.  Now the assmumption is that if you do, the values of the image
    ! pixels should be zero.
    !if (icol-iicol>0       .and. imag-iimag>0 .and. &
    !  icol+iicol<=size(data,1) .and. imag+iimag<=size(data,2)) then

      work=0.0

    
      outer: do i1=max(icol-iicol, 1), min(icol+iicol, size(data,1))

        if (allocated(grad)) then
          if (grad(i1) < tiny(grad(i1))) cycle outer
          ! I.e. if there are any non-zero data points at this colour.
          ! Calculate the normalisation.
          if (correlated == 0) then
            rho=(1.0/sig_mag)**2.0 + 1.0/(sig_col*grad(i1))**2.0
          else 
            mag_grad=1.0/(1.0-(1.0/grad(i1)))
            ! Avoid a numberical error if the two uncertainties are equal.
            mag_sig=max(sqrt(sig_col**2.0 - sig_mag**2.0), sig_mag/2.0)
            ! write(22,*) 'Got ', grad(i1), mag_grad, i1, mag_sig
            rho=(1.0/sig_mag)**2.0 + 1.0/(mag_sig*mag_grad)**2.0
            ! write(22,*) 'Which gave ', rho
          end if
          ! rho=sqrt(rho/pi)
          ! Correct the factor two error.
          rho=sqrt(0.5*rho/pi)
          gauss_norm=1.0
        else
          rho=1.0
          gauss_norm=1.0/(2.0*pi*mag_sig*sig_mag)
        end if



        do i2=max(imag-iimag, 1), min(imag+iimag, size(data,2))
          if (data(i1,i2) >= tiny(data(i1,i2))) then
            ! Find the colour difference from this point to the
            ! data point, and put it in terms of sigma.
            if (correlated == 0) then
              d_col=(axdata(i1,1)-col)/sig_col
            else if (correlated == 1) then
              ! But now comes the swindle to account for correlated
              ! uncertainties.  The colour distance we calculate, is 
              ! actually the distance in the other magnitude.
              d_col=(axdata(i2,2)-mag)+(axdata(i1,1)-col)
              ! Thus we have to divide by the uncertainty in the other 
              ! magnitude, reconstructed from the given uncertainties.
              d_col=d_col/mag_sig
            else if (correlated == -1) then
              d_col=(axdata(i2,2)-mag)-(axdata(i1,1)-col)
              d_col=d_col/mag_sig
            else 
              print*, 'Unacceptable value of ', correlated
              stop
            end if
            ! The same for the magnitude.  
            d_mag=(axdata(i2,2)-mag)/sig_mag
            ! gauss=exp(-1.0*(d_mag**2.0 + d_col**2.0))
            ! Correct the factor two error.
            gauss=exp(-0.5*(d_mag**2.0 + d_col**2.0))
            ! Now multiply the Gaussian at this point by the value of the
            ! model, the area of the pixel, and apply the normalisation.
            ! write(22,*) work, rho, area, gauss, data(i1,i2), i1, i2
            work=work+rho*area*gauss_norm*gauss*data(i1,i2)
          end if
        end do
      end do outer

      likelihood=work
      flag = 'O'

    !else

    !  likelihood=0.0
    !  flag = 'A'

    !end if

  end function likelihood


  real function func2d(a_par, dat, colflag, modflag, correlated, &
    distrib, distrib_flag, rnpts)

    use ark_file_io
    use define_star

    real, intent(in), dimension(:) :: a_par
    type(a_star), dimension(:), intent(in) :: dat
    integer, intent(inout) :: colflag
    integer, intent(in) :: modflag
    ! The correlation flag for s/r likelihood.
    integer, intent(in) :: correlated
    real, intent(out), dimension(:) :: distrib
    character, intent(out), dimension(:) :: distrib_flag
    real, optional, intent(out) :: rnpts

    integer :: i
    real, save :: last_age=-1
    real, dimension(:,:), allocatable, save :: data, axdata
    integer, dimension(2), save :: naxis
    real, dimension(:), allocatable, save :: grad, axgrad
    integer, save :: n_grad
    integer :: iflag

    integer :: ipos, icol, imag
    real :: mag, col
    character(len=50) :: ifname

    real :: sum_gauss

    ! The nomrmalisation for the model.
    real :: rho_norm
    integer :: npix
    real :: mag_min, mag_max
    logical, save :: natural

    ! In this example case the function is simply a straight line with 
    ! a width given by the uncertainty in the second co-ordinate.

    if (abs(last_age-a_par(1)) > tiny(last_age)) then
      call iso_image_name(modflag, colflag, a_par(1), ifname)
      call nxtark_in(ifname)
      iflag=inpark(naxis, data, axdata)
      if (iflag < 0) then
        print*, 'Error reading 2D isochrone file ', ifname
        stop
      end if
      ! At the moment colflag could be for the wrong flavour of the filters 
      ! (e.g. Bessell not Jeffries/Naylor).  Lets make sure its right.
      if (get_header_i('COLFLAG', colflag) < 0) then
        print*, 'Cannot find colour number in header.'
        stop
      end if

      last_age=a_par(1)

      ! Now read the gradient file.
      natural=.false.
      ipos=index(ifname, '.fit')
      ifname(ipos:ipos+3)='.grd'
      call nxtark_in(ifname)
      iflag=inpark(n_grad, grad, axgrad)
      if (iflag == -2) then
        print*, 'No gradient file found, using natural normalisation.'
        natural=.true.
      else if (iflag < 0) then
        print*, 'Error reading gradient file file ', ifname
        stop
      end if

    end if

    if (natural) then
      ! Find the range of magnitudes in the data.
      find_range: do i=1, size(dat,1)
        ! Change to reddening-free absolute magnitude.
        mag=dat(i)%col(1)%data
        col=dat(i)%col(2)%data
        call reddening(colflag, -a_par(2), -a_par(3), col, mag)
        if (i ==1) then
          mag_min=mag
          mag_max=mag
        else
          mag_min=min(mag_min, mag)
          mag_max=max(mag_max, mag)
        end if
      end do find_range
      call natural_norm(mag_max, mag_min, data, axdata)
    else
      rho_norm=1.0
      data=data/rho_norm
    end if

    func2d = 0.0
    if (present(rnpts)) rnpts=0.0


    each_point: do i=1, size(dat,1)

      ! Change to reddening-free absolute magnitude.
      mag=dat(i)%col(1)%data
      col=dat(i)%col(2)%data
      call reddening(colflag, -a_par(2), -a_par(3), col, mag)

      ! Find the nearest positions in X and Y.  (S/R likelihood will spot
      ! if we are close to the array edge).
      icol=minval(minloc(abs(col-axdata(1:size(data,1),1))))
      imag=minval(minloc(abs(mag-axdata(1:size(data,2),2))))

      if (present(rnpts)) then
        distrib(i)=likelihood(data, axdata, grad, icol, imag, &
        dat(i)%col(2)%err, dat(i)%col(1)%err, correlated, distrib_flag(i), &
        sum_gauss)
        rnpts=rnpts+sum_gauss
      else
        distrib(i)=likelihood(data, axdata, grad, icol, imag, &
        dat(i)%col(2)%err, dat(i)%col(1)%err, correlated, distrib_flag(i))
      end if

      if (distrib_flag(i) /= 'O') then

        ! Probably outside grid range, so set value to that of the soft
        ! clipping.
        distrib(i) = 0.0

      end if

      func2d=0.0

    end do each_point

    data=data*rho_norm

  end function func2d


  real function isochr(axis_in, val_in, axis_out, age, colflag, modflag, flag)

    ! Given one parameter from an isochrone, this function interpolates 
    ! another parameter from the table.

    ! The axis the input parameter is from, should be 'mag, 'col', or 'mass'.
    character(len=3), intent(in) :: axis_in
    ! The value of the input parameter.
    real, intent(in) :: val_in
    ! The axis the output parameter is from, should be 'mag, 'col', or 'mass'.
    character(len=3), intent(in) :: axis_out
    ! The age, colour and model to be used.
    real :: age
    integer :: colflag, modflag
    ! And a flag.  
    character(len=*), intent(out) :: flag

    real :: val_out, dx
    integer :: i, iostat, j

    logical, save :: first=.true.

    integer :: npt
    real, allocatable, dimension(:) :: newcol, temp

    type chrone 
      ! Now the specification of the iscohrone.  Its age, colours and model.
      real :: age
      integer :: colflag, modflag, npts
      real, dimension(:), allocatable :: col, mag, mass, teff
      character(len=50), dimension(:), allocatable :: &
      colflg, magflg, massflg, teffflg
    end type chrone

    type(chrone), save :: a, b, c

    if (colflag > 20 .and. colflag<=30) then
      isochr=isochr_p(axis_in, val_in, axis_out, age, colflag, modflag, flag)
    else

      if (first) then
        b%age=0.0
        c%age=0.0
        b%colflag=-1
        c%colflag=-1
        first=.false.
      end if

      if (abs(a%age-age)<=2.0*tiny(age) .and. a%colflag==colflag) then
        ! Still using same isochrone.
      else if (abs(b%age-age)<=2.0*tiny(age) .and. b%colflag==colflag) then
        a=b
      else if (abs(c%age-age)<=2.0*tiny(age) .and. c%colflag==colflag) then
        a=c
      else
        a%age=age
        a%colflag=colflag
        a%modflag=modflag
        if (colflag < 10) then
          ! Read the colour-Teff relationship
          open(unit=11, file=&
          trim(data_dir())//'/'//trim(mod_name(modflag))//'_'//&
          trim(mag_name(colflag))//'_'//trim(col_name(colflag))//'.dat', &
          status='old', iostat=iostat)      
          if (iostat /= 0) then
            print*, 'Error opening file ', &
            trim(data_dir())//'/'//trim(mod_name(modflag))//'_'//&
            trim(mag_name(colflag))//'_'//trim(col_name(colflag))//'.dat'
            stop
          end if
          read(11,'(//)')
          npt=0
          count_teff: do
            read(11,*,iostat=iostat)
            if (iostat < 0) exit count_teff
            npt=npt+1
          end do count_teff
          rewind(11)
          allocate(newcol(npt), temp(npt))
          read(11,'(//)')
          do i=1, npt
            read(11,*) newcol(i), temp(i)
          end do
          temp=log10(temp)
          close(11)
        end if
 
        ! Calculate the isochrone
        !print*, 'Calling iso_calc.'
        call iso_calc(a%age, a%colflag, a%modflag, &
        npt, newcol, temp, a%npts, a%col, a%colflg, a%mag, a%magflg, &
        a%mass, a%massflg, a%teff, a%teffflg)

        !do i=1, a%npts
        !  print*, a%col(i), a%colflg(i), a%mag(i), a%magflg(i)
        !end do

        if (b%colflag == -1) then
          b=a
        else if (c%colflag == -1) then
          c=a
        end if

      end if

      if (axis_in=='mag' .and. axis_out=='col') then
        val_out=quadintflg(a%mag, a%magflg, a%col, a%colflg, val_in, flag)
        if (trim(flag) == '1') flag='outside magnitude range'
      else if (axis_in=='col' .and. axis_out == 'mag') then
        val_out=quadintflg(a%col, a%colflg, a%mag, a%magflg, val_in, flag)
        if (trim(flag) == '1') flag='outside colour range'
      else if (axis_in=='mas' .and. axis_out == 'mag') then
        val_out=quadintflg(a%mass, a%massflg, a%mag, a%magflg, val_in, flag)
        if (trim(flag) == '1') flag='outside mass range'
      else if (axis_in=='mas' .and. axis_out == 'col') then
        val_out=quadintflg(a%mass, a%massflg, a%col, a%colflg, val_in, flag)
        if (trim(flag) == '1') flag='outside mass range'
      else if (axis_in=='mas' .and. axis_out == 'tef') then
        val_out=quadintflg(a%mass, a%massflg, a%teff, a%teffflg, val_in, flag)
        if (trim(flag) == '1') flag='outside mass range'
      else if (axis_in=='mag' .and. axis_out == 'mas') then
        val_out=quadintflg(a%mag, a%magflg, a%mass, a%massflg, val_in, flag)
        if (trim(flag) == '1') flag='outside magnitude range'
      else
        print*, 'Illegal combination of axis_in ', axis_in
        print*, 'and axis_out ', axis_out, ' in function isochr.'
        stop
      end if

      isochr=val_out

    end if

  end function isochr

    subroutine grid2d(a_par, dat, colflag, modflag, correlated, &
      var_par, start, end, soft_clip, &
      data, axdata, best_value, best_par, best_distrib, rnpts)

      use define_star

      ! Performs a 2d grid search.

      ! The model parameters.
      real, dimension(:) :: a_par
      ! The data points.
      type(a_star), dimension(:), intent(in) :: dat
      ! The model and colours being used.
      integer, intent(inout) :: colflag
      integer, intent(in) :: modflag
      ! The correlation flag for s/r likelihood.
      integer, intent(in) :: correlated
      ! The numbers of the parameters to be searched.
      integer, dimension(2), intent(in) :: var_par
      ! The ranges of parameters to be searched.
      real, dimension(2), intent(in) :: start, end
      real, intent(in) :: soft_clip
      ! The output grid.
      real, dimension(:,:), intent(out) :: data, axdata
      ! And an optional fraction of the stars on the grid.
      real, dimension(:,:), intent(out), optional :: rnpts

      real, intent(out) :: best_value
      logical :: first_value
      real, intent(out), dimension(:) :: best_par
      real, intent(out), dimension(:) :: best_distrib

      ! Locals.
      character, allocatable, dimension(:) :: distrib_flag
      real, allocatable, dimension(:) :: distrib
      integer :: i1, i2, i3
      real, dimension(size(data,1), size(data,2), size(dat,1)) :: distrib_full
      real :: dummy, work, low_tau
      integer, dimension(2) :: loc

      allocate(distrib_flag(size(dat,1)), distrib(size(dat,1)))

      ! Set up the values of best_par to be those of a_par.  We'll
      ! the correct the ones we fit.
      best_par=a_par

      first_value=.true.
      do i1=1, size(data,1)
        if (size(data,1) == 1) then
          a_par(var_par(1))=start(1)
        else
          a_par(var_par(1))=start(1)+(end(1)-start(1))*real(i1-1) &
          /real(size(data,1)-1)
        end if
        axdata(i1,1)=a_par(var_par(1))
        do i2=1, size(data,2)
          if (size(data,2) == 1) then 
            a_par(var_par(2))=start(2)
          else
            a_par(var_par(2))=start(2)+(end(2)-start(2))*real(i2-1) &
            /real(size(data,2)-1)
          end if
          axdata(i2,2)=a_par(var_par(2))
          if (present(rnpts)) then
            dummy=func2d(a_par, dat, colflag, modflag, correlated, &
                 distrib_full(i1,i2,:), distrib_flag, rnpts(i1, i2))
          else 
            dummy=func2d(a_par, dat, colflag, modflag, correlated, &
                 distrib_full(i1,i2,:), distrib_flag)
          end if
        end do
      end do

      ! Find the highest probability in the whole fit.
      low_tau=-2.0*log(maxval(distrib_full))
      print*, 'Lowest tau-squared for any point is ', low_tau
      if (soft_clip > 0.0) then
        work=exp(-0.5*(soft_clip+low_tau))
      else
        work=0.0
      end if
      ! Soft clip the probabilities.
      distrib_full=distrib_full+work

      data=0.0
      high_tau=-2.0*log(2.0*tiny(1.0))*size(dat,1)
      do i1=1, size(data,1)
        do i2=1, size(data,2)
          ! Construct the tau**2 for this grid point by adding
          ! the tau^2 of each point.
          each_point: do i3=1, size(dat,1)
            ! Protect against infinities.
            if (distrib_full(i1,i2,i3) > 2.0*tiny(1.0)) then
              data(i1,i2)=data(i1,i2)-2.0*log(distrib_full(i1,i2,i3))
            else
              ! At least one data point is returning a probablilty so low
              ! we can't cope, so set the entire grid point to a very
              ! high tau^2.
              data(i1,i2)=high_tau
              exit each_point
            end if
          end do each_point
        end do
      end do

      ! Find the best fit.
      loc=minloc(data)
      best_distrib=-2.0*log(distrib_full(loc(1),loc(2),:))
      best_par(var_par(1))=axdata(loc(1),1)
      best_par(var_par(2))=axdata(loc(2),2)
      best_value=sum(best_distrib)

      deallocate(distrib_flag, distrib)

    end subroutine grid2d

    subroutine tau_sort(tau_data)

      real, intent(inout), dimension(:)  :: tau_data

      integer :: k, l, m
      real :: safe

      outer: do k=2, size(tau_data)
        safe=tau_data(k)
        do l=1,k-1
          if (safe < tau_data(l)) then
            do m=k, l+1, -1
              tau_data(m)=tau_data(m-1)
            end do
            tau_data(l)=safe
            cycle outer
          endif
        end do
      end do outer

    end subroutine tau_sort

    real function isochr_p(axis_in, val_in, axis_out, age, colflag, &
         modflag, flag)

      implicit none

      ! The axis the input parameter is from, should be 'mag, 'col', or 'mass'.
      character(len=3), intent(in) :: axis_in
      ! The value of the input parameter.
      real, intent(in) :: val_in
      ! The axis the output parameter is from, should be 'mag, 'col', or 'mass'.
      character(len=3), intent(in) :: axis_out
      ! Now the specification of the iscohrone.  Its age, colours and model.
      real, intent(in) :: age
      integer, intent(in) :: colflag, modflag
      ! And a flag.
      character(len=*), intent(out) :: flag

      real :: dmass, dage, val_out
      integer :: iage, jpt
      logical, save :: first=.true.

      type(isochron), dimension(3), save :: isoc, last_but_one_isoc, safe
      real, dimension(3) :: work_out
      real, save :: last_age
      integer, save :: last_colflag, last_but_one_colflag
      real, save :: min_mass, max_mass

      if (.not. first) then
        if (abs(age-last_age) > 2.0*tiny(age)) then
          first=.true.
          last_colflag=colflag
          last_but_one_colflag=0
        else
          if (colflag /= last_colflag) then
            if (colflag == last_but_one_colflag) then
              ! This is the last-but-one colour used, so swap isoc and
              ! but-one isoc.
              safe=isoc
              isoc=last_but_one_isoc
              last_but_one_isoc=safe
              last_but_one_colflag=last_colflag
              last_colflag=colflag
            else
              ! Never used before.  So put the current isoc into the
              ! last-but-one, and read a new one.
              first=.true.
              last_but_one_colflag=last_colflag
              last_but_one_isoc=isoc
              last_colflag=colflag
            end if
          else
            ! Using the current isoc.
          end if          
        end if
      end if
      last_age=age
      last_colflag=colflag

      if (first) then
        if (modflag == 8) then
          call read_padova_col(age, colflag, isoc)
        else if (modflag == 9) then
          call read_geneva_col(age, colflag, isoc)
        else
          print*, 'Only the Padova and Geneva isochrones are available'
          print*, 'with their own supplied colours.'
          stop
        end if
        first=.false.
      end if

      min_mass=maxval(isoc%mass(1))
      max_mass=min(isoc(1)%mass(isoc(1)%npts), &
      min(isoc(2)%mass(isoc(2)%npts), &
      isoc(3)%mass(isoc(3)%npts)))

      isochr_p=0.0
      if (val_in < min_mass .and. axis_in=='mas') then
        flag='Below minimum mass'
      else if (val_in > max_mass .and. axis_in=='mas') then
        flag='Above maximum mass'
      else
        ! Interpolate the three isochrones to the appropriate mass.
        do iage=1, 3
          ! Find the nearest point to the mass required.
          if (axis_in == 'mas') then
            call locate(isoc(iage)%mass, isoc(iage)%npts, val_in, jpt)
          else if (axis_in == 'mag') then
            call locate(isoc(iage)%magnitude, isoc(iage)%npts, val_in, jpt)
          end if
          ! Avoid running off the end.
          jpt = min(max(jpt-1,1), isoc(iage)%npts-2)
          ! Now interpolate (parabolic so n=3), returns colour_out and 
          ! dmass (error)   
          if (axis_in == 'mas') then
            if (axis_out == 'col') then
              call polint(isoc(iage)%mass(jpt:jpt+2), &
              isoc(iage)%colour(jpt:jpt+2), 3, val_in, work_out(iage), dmass)
            else if (axis_out == 'mag') then
              call polint(isoc(iage)%mass(jpt:jpt+2), &
              isoc(iage)%magnitude(jpt:jpt+2), 3, val_in, work_out(iage), dmass)
            else if (axis_out == 'tef') then
              work_out(iage)=0.0
            else
              print*, 'Error.  Requested output axis is ', axis_out
              print*, 'For input axis ', axis_in
              stop
            end if
          else if (axis_in == 'mag') then
            if (axis_out == 'mas') then
              call polint(isoc(iage)%magnitude(jpt:jpt+2), &
              isoc(iage)%mass(jpt:jpt+2), 3, val_in, work_out(iage), dmass) 
            else
              print*, 'Error.  Requested output axis is ', axis_out
              print*, 'For input axis ', axis_in
              stop
            end if
          else
            print*, 'axis_in must be mag or mas'
            stop
          end if
        end do

        ! Interpolate to the appropriate age.
        call polint(isoc%age, work_out, 3, age, val_out, dage)

        isochr_p=val_out
        flag='OK'
      end if

    end function isochr_p

    end module cmdfit_subs

       Subroutine UNIX_EXTEND( o_Name, n_Name, Flag )
C
C       Looks through the file name as given, and expands any
C       environment name (e.g., $ARKINFO) into full pathname.
C
       Character*( * ) o_Name, n_Name
       Integer Flag
C
       Integer L, M, o_Len, n_Len, Colon, Tilde, Slash, Dollar
       Character One, Work*7
C
        Flag = 1
       o_Len = Len( o_Name )
       n_Len = Len( n_Name )
       M = 0
       Colon = 0
       Tilde = 0
       Slash = 0
        Dollar = 0
       Do L = 1, o_Len
         One = o_Name( L: L )
         If( One .eq. ':' ) Then
           Colon = L
           M = L
         Else If( One .eq. '~' ) Then
           Tilde = L
           M = L
         Else If( One .eq. '/' ) Then
           If( Slash .eq. 0 .and.
     1             ( Colon.gt.0 .or. Tilde.gt.0 .or. Dollar.gt.0) ) Then
             Slash = L
           End If
           M = L
          Else If( One .eq. '$' ) Then
            Dollar = L
            M = L
         Else If( One .gt. ' ' ) Then
           M = L
         End If
       End Do
       o_Len = M
C
       If( Colon.gt.0 .or. Tilde.gt.0 .or. Dollar.gt.0) Then
         If(Colon.eq.8 .or. Colon.eq.7) Then
            Work=o_name(1:Colon-1)
            call upcase(Work)
            If (Work.eq.'ARKTEST' .or.
     &          Work.eq.'ARKDOCS' .or.
     &          Work.eq.'ARKDATA' .or.
     &          Work.eq.'FOSDAT') Then
c             Env name found, which matches an ARK one.
             Call ARKGSM( Work, n_Name )
             Slash = Colon
            End if
         Else If( Tilde .gt. 0 ) Then
c                                   ! ~ used
           If( Slash .ne. Tilde + 1 ) Then
             Flag = -11
             Write( *, 120 )
 120         Format( ' ERROR:: Cannot expand other user''s home' )
             Return
           Else If( Tilde .ne. 1 ) Then
             Flag = 0
             Write( *, 125 )
125             Format( ' ERROR:: UNIX file name syntax error' )
           End If
           Call ARKGSM( 'HOME', n_Name )
          Else If( Dollar .gt. 0) Then
            Call ARKGSM( o_Name( Dollar + 1: Slash - 1 ), n_Name )
         End If
         M = 0
         Do L = 1, n_Len
           If( n_Name( L: L ) .gt. ' ' ) M = L
         End Do
         If( M .eq. 0 ) Then
           Flag = -12
           Write(*,*) ' ERROR:: Non-existent environment name ', work
           Return
         Else If( M + o_Len - Slash + 1 .gt. n_Len ) Then
           Flag = -13
           Write( *, 140 )
140           Format( ' ERROR:: Running out of file name buffer' )
           Return
         End If
         n_Name = n_Name( 1: M ) //'/'//o_Name( Slash+1: o_Len )
       Else
         If( o_Len .gt. n_Len ) Then
           Flag = -13
           Write( *, 140 )
           Return
         End If
         n_Name = o_Name
       End If
C
       End
    

      SUBROUTINE POLINT(XA,YA,N,X,Y,DY)

c     A numerical reciepes routine.

      PARAMETER (NMAX=10) 
      DIMENSION XA(N),YA(N),C(NMAX),D(NMAX)
      NS=1
      DIF=ABS(X-XA(1))
      DO 11 I=1,N 
        DIFT=ABS(X-XA(I))
        IF (DIFT.LT.DIF) THEN
          NS=I
          DIF=DIFT
        ENDIF
        C(I)=YA(I)
        D(I)=YA(I)
11    CONTINUE
      Y=YA(NS)
      NS=NS-1
      DO 13 M=1,N-1
        DO 12 I=1,N-M
          HO=XA(I)-X
          HP=XA(I+M)-X
          W=C(I+1)-D(I)
          DEN=HO-HP
          IF(DEN.EQ.0.)PAUSE
          DEN=W/DEN
          D(I)=HP*DEN
          C(I)=HO*DEN
12      CONTINUE
        IF (2*NS.LT.N-M)THEN
          DY=C(NS+1)
        ELSE
          DY=D(NS)
          NS=NS-1
        ENDIF
        Y=Y+DY
13    CONTINUE
      RETURN
      END

        subroutine locase(string)
                                 
c       Translates a string to lower case.
                                          
        character*(*) string
                            
        integer i
                 
        do 310 i=1, len(string)
          if (ichar(string(i:i)).ge.65 .and. ichar(string(i:i)).le.90)
     &    string(i:i) = char(ichar(string(i:i))+32)
310     continue
                
        end

module uncer_subs

  use cmdfit_subs

  implicit none

contains

  subroutine create_cum_prob(tau2_grid, axgrid, axnam, tau2_cum, &
  cum_prob, one_sig_tau2)

    ! Creates the plot of tau^2 against cumulative probability.

    ! The input tau2 grid.
    real, dimension(:,:), intent(in) :: tau2_grid, axgrid
    character(len=*), dimension(:) :: axnam
    ! The output plot.
    real, allocatable, dimension(:), intent(out) :: tau2_cum, cum_prob
    ! And the tau2 corresponding to one sigma.
    real :: one_sig_tau2

    ! Local variables.
    integer, dimension(2) :: naxis
    integer :: icount, i1, i2, i
    real :: tau2_min, tot_prob
    character(len=10) :: flag
    real, allocatable, dimension(:) :: pix_prob

    naxis(1)=size(tau2_grid,1)
    naxis(2)=size(tau2_grid,2)
    allocate(tau2_cum(naxis(1)*naxis(2)), &
    pix_prob(naxis(1)*naxis(2)), cum_prob(naxis(1)*naxis(2)))

    ! The numerics can fail if tau**2 is too high.
    tau2_min=minval(tau2_grid)

    icount=0
    do i2=1, naxis(2)
      do i1=1, naxis(1)
        icount=icount+1
        tau2_cum(icount)=tau2_grid(i1,i2)
        ! Now mulitply by the area of the pixel.
        pix_prob(icount)=sum_tau2(tau2_grid-tau2_min, &
        axgrid, axnam, i1, i1, i2, i2)
      end do
    end do
    call tau_sort(tau2_cum, pix_prob)

    tot_prob=sum_tau2(tau2_grid-tau2_min, axgrid, axnam, 1, &
    naxis(1), 1, naxis(2))

    do icount=1, naxis(1)*naxis(2)
      cum_prob(icount)=&
      100.0*sum(pix_prob(1:icount))/tot_prob
    end do

    ! Find the 1 sigma contour by quadratic interpolation.
    one_sig_tau2=quadint(cum_prob, tau2_cum, 68.26, flag)

  end subroutine create_cum_prob



  subroutine conf2(tau2_grid, axgrid, axnam, long_axis)

    ! Print out the positions above and below which (1-0.68)/2 
    ! of the probability lies.

    ! The tau^2 grid and associated axis information.
    real, intent(in), dimension(:,:) :: tau2_grid, axgrid
    character(len=*), dimension(2) :: axnam
    ! Which axis is NOT to be summed over.
    integer, intent(in) :: long_axis

    real, parameter :: conf_level=(1.0-0.6826)/2.0
    !real, parameter :: conf_level=0.5
    integer :: i, ilow, ihigh
    character(len=8) :: flag
    real :: low, high, best, tot_prob, sum_prob
    integer, dimension(2) :: iwhere

    real, allocatable, dimension(:) :: cum

    sum_prob=sum_tau2(tau2_grid, axgrid, axnam, 1, size(tau2_grid,1), 1, &
    size(tau2_grid,2))
    tot_prob=0.0
    allocate(cum(size(tau2_grid,long_axis)))
    from_bottom: do i=1, size(tau2_grid,long_axis)
      if (long_axis == 1) then
        tot_prob=tot_prob+sum_tau2(tau2_grid, axgrid, axnam, &
        i, i, 1, size(tau2_grid,2))
      else
        tot_prob=tot_prob+sum_tau2(tau2_grid, axgrid, axnam, &
        1, size(tau2_grid,1), i, i)
      end if
      cum(i)=tot_prob/sum_prob
    end do from_bottom
    ! Find the confidence limits by quadratic interpolation.
    low=quadint(cum, axgrid(1:size(cum),long_axis), conf_level, flag)
    ilow=minloc(abs(low-axgrid(1:size(cum),long_axis)),1)
    high=quadint(cum, axgrid(1:size(cum),long_axis), 1.0-conf_level, flag)
    ihigh=minloc(abs(high-axgrid(1:size(cum),long_axis)),1)

    iwhere=minloc(tau2_grid)
    best=axgrid(iwhere(long_axis), long_axis)
    print*, ' '
    if (trim(axnam(long_axis)(1:5)) == 'LOG10') then
      print*, 'For ', &
      trim(axnam(long_axis)(6:len(axnam(long_axis))))//'/10^6', &
      ' one parameter of interest.'
      best=10.0**(best-6.0)
      high=10.0**(high-6.0)
      low= 10.0**(low -6.0)
    else
      print*, 'For ', trim(axnam(long_axis)), ' one parameter of interest.'
    end if
    if (best < low) then
      ! Ah, this can only be an upper limit.
      high=quadint(cum, axgrid(1:size(cum),long_axis), 1.0-2.0*conf_level, flag)
      print*, 'Since the best value is ', best, ' and the lower limit is '
      print*, low, ' we can only derive an upper limit.'
      print*, 100.0*(1.0-2.0*conf_level), ' percent limit is <', high 
    else
      print*, best, '+', high-best, low-best
      print*, 'i.e. ', low, ' -> ', high, '(=', ihigh-ilow, ' grid pixels.)'
      best=(low+high)/2.0
      print*, best, '+/-', (high-low)/2.0 ,'(symmetrised)'
    end if
  
  end subroutine conf2

end module uncer_subs

program uncer

  ! Calculates the uncertainties using a new experimental method.

  use ark_file_io
  use uncer_subs
  use quad

  implicit none

  integer :: iflag
  real, allocatable, dimension(:,:) :: axgrid, tau2_grid
  real, allocatable, dimension(:) :: cum_prob, tau2_cum
  real, allocatable, dimension(:,:) :: oneDgrid
  integer, dimension(2) :: naxis

  integer :: i, i1, i2, iaxis
  real :: tot_prob
  ! The minimum tau**2, removed to make numerics work.
  real :: tau2_min
  real :: work

  real :: one_sig_tau2, one_sig_1d_tau2
  character(len=80), dimension(2) :: axnam

  call nxtark_in('grid.fit')
  iflag=inpark(naxis, tau2_grid, axgrid)
  do iaxis=1, 2
    if (naxis(iaxis) == 1) cycle
    if (iaxis == 1) then 
      iflag=get_header_s('CTYPE1', axnam(1))
      if (iflag < 0) axnam(1)='AXIS 1'
    else if (iaxis == 2) then
      iflag=get_header_s('CTYPE2', axnam(2))
      if (iflag < 0) axnam(2)='AXIS 2'
    end if
  end do

  call create_cum_prob(tau2_grid, axgrid, axnam, tau2_cum, cum_prob, &
  one_sig_tau2)

  print*, 'The 68 percent confidence contour is at tau^2 =', one_sig_tau2

  call nxtark_out('uncer.out')
  call typark(2)
  iflag=makark(naxis(1)*naxis(2), cum_prob, tau2_cum)

  !deallocate(cum_prob, tau2_cum)

  tau2_min=minval(tau2_grid)
  tau2_grid=tau2_grid-tau2_min
  do iaxis=1, 2
    if (naxis(iaxis) == 1) cycle
    call conf2(tau2_grid, axgrid, axnam, iaxis)
  end do

end program uncer

      module get_header

!       The standard set of routines for getting headers from ARK files.
                                                                        
!       The routines are functions of the form;
!       integer get_header_%(key, value), where key is a character*(*) string
!       and value and % take the following meanings.
!       %     Value
!       -     -----
!       S     character*(*)
!       C     character*1
!       R     real
!       D     double precision
!       I     integer
!
!       The value of the function is the line number where the key was
!       found unless;
!       (1) If the key was not found -1 is returned.
!       (2) The key was found, but there was an error reading the value,
!           then -2 is returned.
!       If the input string is less than 8 characters, blanks are matched
!       for the remaining characters.  The match is performed in upper case,
!       translating the input string if need be.
                                                
!       History.
!       Original by Koji.
!       Get_header_s added by Tim.
!       Changes made to make it general for ARK and ARKFITS files:
!         1) Dross increased to 180 lines.
!         2) Keys made to be any length.
!         3) get_header_d added.
!       Made into Fortran 90 by Timn.

        implicit none

      contains
                                
       Integer Function GET_HEADER_S( Key, Value )

       Character*(*) Value, Key

       Integer I
        character*8 expkey

       Common / pasdrs / Dross
       Character*80 Dross( 180 )

        i=matkey(key, expkey)
        if (i .gt. 0) then
         read(Dross( I )(11:80), *, err=100) value
          goto 200
!           If someone has missed the quotes of the string, read it this way.
100         read(Dross( I )(11:80), '(a)', err=800) value
200       continue
         If ( Value .gt. ' ' ) Then
           GET_HEADER_S = i
         Else
           GET_HEADER_S = -2
         End If
       else
         GET_HEADER_S = -1
        end if
        goto 900
                
800     get_header_s = -2
                         
900       End Function GET_HEADER_S



       Integer Function GET_HEADER_C(key, value)

       Character Value
        Character*(*) key

       Integer I, L
        character expkey*8

       Character*80 Dross( 180 )
       Common / pasdrs / Dross

        i=matkey(key, expkey)
        if (i .gt. 0) then
         Value = Dross( I )( 30: 30 )
         If ( Value .gt. ' ' ) Then
           GET_HEADER_C = i
         Else
           GET_HEADER_C = -2
         End If
       else
         GET_HEADER_C = -1
        end if
              
900       End Function GET_HEADER_C


       Integer Function GET_HEADER_R(key, value)

       Character*(*) Key
       Real Value

       Integer I
       character expkey*8

       Character*80 Dross( 180 )
       Common / pasdrs / Dross

       i = matkey(key, expkey)
       if (i .gt. 0) then
         Read( Dross( I )( 11: 30 ), *, Err = 100 ) Value
         GET_HEADER_R = i
       else
          GET_HEADER_R = -1
       end if
       goto 900
                
!      Condition if fail to read the header.
100    get_header_r = -2

900    End Function GET_HEADER_R



       Integer Function GET_HEADER_D( Key, Value )

       Character*(*) Key
       double precision Value

       Integer I, L
        character expkey*8

       Character*80 Dross( 180 )
       Common / pasdrs / Dross

        i = matkey(key,expkey)
        if (i .gt. 0) then
         Read( Dross( I )( 11: 30 ), *, Err = 100 ) Value
         GET_HEADER_D = i
        else
          GET_HEADER_D = -1
        end if
        goto 900
                
!       Condition if fail to read the header.
100     get_header_D = -2

900       End Function GET_HEADER_D



       Integer Function GET_HEADER_I( Key, Value )

       Character*(*) Key
       Integer Value

       Integer I, L
        character expkey*8

       Character*80 Dross( 180 )
       Common / pasdrs / Dross

        i = matkey(key,expkey)
        if (i .gt. 0) then
         Read( Dross( I )( 11: 30 ), *, Err = 100 ) Value
         GET_HEADER_i = i
        else
          GET_HEADER_i = -1
        end if
        goto 900
                
!       Condition if fail to read the header.
100     get_header_i = -i

900       End function GET_HEADER_I


        integer function matkey(key,expkey)
                                           
!       Returns the number of the first line whose key matches the
!       input key.  The search is not case sensitive for the input
!       key (but the key in the header must be in upper case).  If the
!       input key is shorter than 8 characters, blanks are matched as
!       rest of the key.  If the key is not found -1 is returned.
!       The upper case, 8 character version of the key is also returned.
                                                                        
        character*(*) key
        character expkey*8
        integer i, n, j
                      
        Character*80 Dross( 180 )
        Common / pasdrs / Dross
                        
!       Convert to upper case.
        do i= 1, min(len(key),8)
          n = ichar( Key(i:i) )
          if (n.ge.97 .and. n.le.122 ) n = n - 32
!         And catch nulls.
          if (n .eq. 0) n=32
          expkey(i:i) = char(n)    
        end do
!       Pad with blanks.
        if (len(key) .lt. 8) then
          do 120 i=len(key)+1, 8
            expkey(i:i) = ' '
120       continue
        end if
              
!       Now if we are trying to match 'END' only examine the first 3
!       letters.
        j=8
        if (expkey(1:3) .eq. 'END') j=3
                                       
!       Look for a matching keyword.
        do 310 i=1, lndrss()
          if (dross(i)(1:j) .eq. expkey(1:j)) then
            matkey=i
            goto 900
          end if
310     continue
                
!       If we get to here we've failed to match the key.
        matkey=-1
                 
900     end function matkey
           
           
        Integer Function LNDRSS( )

!       Finds the next line of the header that should be written to.  Thus
!       if there is an 'END' statement, that line is returned, otherwise
!       it returns 180.

        integer :: k
 
        character(len=80), dimension(180) :: dross
        common / pasdrs / dross
 
        lndrss = 180
        end_search: do k=1, 180
          if (dross(k)(1:3) == 'END') then
            lndrss=k
            exit end_search
          end if 
        end do end_search
 
        End Function LNDRSS
      
        subroutine deblank
      
          integer :: k
        
          character(len=80), dimension(180) :: dross
          common / pasdrs / dross
          
          do
            k=lndrss()
            if (dross(k-1)(1:8)  == '        ') then
              dross(k-1)='END     '
              dross(k)='        '
            else
              exit
            end if
          end do
          
        end subroutine deblank

      end module get_header

        logical function arkgsm(symbol, value)
                                              
!       Gets a DCL global symbol or a UNIX enviroment variable.

        character(len=*), intent(in) :: symbol
        character(len=*), intent(out) :: value

        character(len=30) :: work

        work=symbol
        call upcase(work)
                                       
        call getenv(trim(work), value)
        if (value(1:1).ne.' ' .and. value(1:1).ne.char(0)) then
          arkgsm=.true.
        else
          arkgsm=.false.
        end if
              
        end function arkgsm

       subroutine ARK_TIME( hh, mm, ss )
C
C       Get time of day as 3 integers
c
       integer hh, mm, ss
c
       integer array( 3 )
c
       call ITIME( array )
       hh = array( 1 )
       mm = array( 2 )
       ss = array( 3 )
c
       end

       subroutine ARK_STDO( )
C
C       This is an optional subroutine, to be called near the beginning of
C       a program, to "beautify" the terminal output for those program
C       that assumes Fortran Carriage Control.  Needs a blank subroutine
C       in vms_system.for; no harm if not called, other than the blank first
C       column.
C
C
C       This is the ULTRIX version.
c        open (unit=6, status='unknown', carriagecontrol='fortran')
       end

      Subroutine SETDT( Type )

      use get_header
C
       Integer Type
C
       Integer Type2, K, n_Dross
C
       Character*80 Dross( 36 )
       Common / pasDrs / Dross
C
       Character*80 Header( -1: 6 )
       Data Header/'DATATYPE=                    Z /DIMENSIONLESS',
     1       'DATATYPE=                    U /UNKNOWN',
     2       'DATATYPE=                    C /COUNTS',
     3       'DATATYPE=                    E /ERRORS (COUNTS)',
     4       'DATATYPE=                    L /F-LAMBDA',
     5       'DATATYPE=                    F /ERROR (F-LAMBDA)',
     6       'DATATYPE=                    N /F-NU',
     7       'DATATYPE=                    G /ERROR (F-NU)' /
C                            Find where to put the datatype
       Type2 = Type
       If( Type2 .lt. -1 .or. Type2 .gt. 6 ) Type2 = 0
       n_Dross = LNDRSS( )
       Do K = 1, n_Dross
         If( Dross( K )( 1: 8 ) .eq. 'DATATYPE' ) Goto 100
       End Do
       If( Dross( n_Dross ) .eq. 'END' ) Then
         If( n_Dross .le. 35 ) Then
           Dross( n_Dross + 1 ) = 'END'
           K = n_Dross
         Else
           K = 0
         End If
       Else
         If( n_Dross .le. 34 ) Then
           Dross( n_Dross + 2 ) = 'END'
           K = n_Dross + 1
         Else If( n_Dross .eq. 35 ) Then
           K = n_Dross + 1
         Else
           K = 0
         End If
       End If
C                            Insert the datatype header
100       Continue
       If( K .ne. 0 ) Then
         Dross( K ) = Header( Type2 )
       End If
C
       End

c       The tapeio routines for reading tapes.  Based loosely on what 
c       UNIX should (but often doesn't) provide.  The idea is that you
c       call topen, and then tread until you reach the end of file.
c       You should then call topen before reading the next file (but
c       needn't call tclose).

        integer function topen(itlu, devnam, islabeled)

        integer itlu
        character*(*) devnam
        logical islabeled

c       This array holds the fortran unit numbers corresponding to
c       tape unit numbers 0 to 3.
        integer iunit(0:3), irec, irw, nblk
        character*30 dunit(0:3)
        common /arktap/ iunit, dunit, irec, irw, nblk
        common /chatap/ device
        character*30 device
        integer iflag, tclose
        external tclose

        topen=0
        irec=0
        irw=0

        if (itlu.ge.0 .and. itlu.le.3) then
          if (iunit(itlu) .gt. 0) then
c           The tape unit is already open, let's close it.
            iflag=tclose(itlu)
            if (iflag .ne. 0) then
              print*, 'Error in ARK TAPEIO S/R TOPEN, which called'
              print*, 'S/R TCLOSE, which reported error ', iflag
              stop
            end if
          end if
          call find_free(iunit(itlu))
          dunit(itlu)=devnam
        else
          print*, 'Error in ARK routine topen, itlu = ', itlu
          print*, 'itlu must be between 0 and 3.'
          topen=-1
          goto 900
        end if

        device=devnam

900     end


        subroutine tblock(iblk)

        integer iunit(0:3), irec, irw, nblk
        character*30 dunit(0:3)
        common /arktap/ iunit, dunit, irec, irw, nblk

        integer iblk

        nblk=iblk
                          
        end


        integer function tread(itlu, buffer)

        ! This is needed for the NAG compiler.
        !use f90_unix_proc

        integer itlu
        character*(*) buffer

        integer i

c       This array holds the fortran unit numbers corresponding to
c       tape unit numbers 0 to 3.
        integer iunit(0:3), irec, irw, nblk
        character*30 dunit(0:3)
        common /arktap/ iunit, dunit, irec, irw, nblk
        common /chatap/ device
        character device*30, work*39
        logical there

c       Set tread to the end-of-file condition.
        tread=0

        if (itlu.lt.0 .or. itlu.gt.3) then
          print*, 'Error in ARK routine tread, itlu = ', itlu
          print*, 'itlu must be between 0 and 3.'
          tread = -1
          goto 900
        end if

        if (irw .eq. 2) then
          print*, 'Error in ARK routine tread.  These routines'
          print*, 'cannot support reading a writing to the same'
          print*, 'file.'
        else
          irw = 1
        end if

        if (iunit(itlu) .eq. -1) then
          print*, 'Error in ARK routine tread.  Tape unit ', itlu
          print*, 'has not been opened yet.'
          tread = -1
          goto 900
        end if

        if (irec .eq. 0) then
c         The tape unit has just been opened, and seeing as how a
c         read has been asked for, we'd better read the file off
c         tape.
c         So first see if the file name we are to dump to is being
c         used.
          inquire(file='arktio.tmp', exist=there)
          if (there) then
c           Get rid of it.
            call system('rm -f arktio.tmp')
          end if
c         For some reason you need a <cr> between fortran writes and
c         the output from dd.
          print*, ' '
          work='dd bs=????? of=arktio.tmp conv=sync if='
          write(work(7:11), '(i5.5)') nblk     
          call system(work//device)
          open(unit=iunit(itlu), file='arktio.tmp',
     &    form='unformatted', recl=nblk/4, iostat=i,
     &    access='direct', status='old')
!          open(unit=iunit(itlu), file='arktio.tmp',
!     &    form='unformatted', recl=nblk/4, blocksize=nblk, iostat=i,
!     &    access='direct', status='old')
          if (i .ne. 0) then
            print*, 'Error in ARK subroutine tread.'
            print*, 'Fortran open statement reports error number ', i
            tread=-1
            goto 900
          end if
        end if

        irec=irec+1
        read(iunit(itlu), iostat=i, rec=irec) buffer
c       Check for end-of-file.
        if (i .eq. 36) goto 900
        tread=len(buffer)

        if (i .ne. 0) then
          print*, 'Error in ARK subroutine tread.'
          print*, 'Fortran read statement reports error number ', i
          tread=-1
        end if

900     end


        integer function tclose(itlu)

        ! This is needed for the NAG compiler.
        !use f90_unix_proc

        integer itlu

c       This array holds the fortran unit numbers corresponding to
c       tape unit numbers 0 to 3.
        integer iunit(0:3), irec, irw, nblk
        character*30 dunit(0:3)
        common /arktap/ iunit, dunit, irec, irw, nblk
        common /chatap/ device
        character device*30, work*39

        logical debug
        common /bug/ debug

        tclose=0

        if (itlu.lt.0 .or. itlu.gt.3) then
          print*, 'Error in ARK routine tclose, itlu = ', itlu
          print*, 'itlu must be between 0 and 3.'
          tclose = -1
          goto 900
        end if

        if (iunit(itlu) .ne. -1) close(iunit(itlu))

        if (irw .eq. 2) then
c         For some reason you need a <cr> between fortran writes and
c         the output from dd.
          print*, ' '
          work='dd bs=????? if=arktio.tmp conv=sync of='
          write(work(7:11), '(i5.5)') nblk     
          if (debug) print*, '@ ', work//device
          call system(work//device)
        end if

c       call system ('rm arktio.tmp')

        iunit(itlu)=-1

900     end

        integer function tskipf(itlu, nfiles, nrecs)

        integer itlu, nfiles, nrecs

c       This array holds the fortran unit numbers corresponding to
c       tape unit numbers 0 to 3.
        integer iunit(0:3), irec, irw, nblk
        character*30 dunit(0:3)
        common /arktap/ iunit, dunit, irec, irw, nblk

        integer i
        character*70 spawn_line

        tskipf=0

        if (nfiles .gt. 0) then
          write(spawn_line, 120) dunit(itlu)(1:15), nfiles
120         format( 'mt -f ', A15, ' fsf ', I3.3 )
c         And now set the number of records read to zero.
          irec=0
        else if (nfiles .lt. 0) then
          write(spawn_line, 130) dunit(itlu)(1:15), abs(nfiles)
130         format( 'mt -f ', A15, ' bsf ', I3.3 )
          irec=0
        end if
       call arkcom(spawn_line)

        if (nrecs .gt. 0) then
          do 240 i=1, nrecs
            read(iunit(itlu))
240       continue
        else if (nrecs .lt. 0) then
          print*, 'Error in ARK routine tskipf.'
          print*, 'Attempt to skip a negative number of records.'
          tskipf=-1
        end if

        end

        integer function twrite(itlu, buffer)

        integer itlu
        character*(*) buffer

        integer i

c       This array holds the fortran unit numbers corresponding to
c       tape unit numbers 0 to 3.
        integer iunit(0:3), irec, irw, nblk
        character*30 dunit(0:3)
        common /arktap/ iunit, dunit, irec, irw, nblk

        twrite=0

        if (itlu.lt.0 .or. itlu.gt.3) then
          print*, 'Error in ARK routine twrite, itlu = ', itlu
          print*, 'itlu must be between 0 and 3.'
          twrite = -1
          goto 900
        end if

        if (irw .eq. 1) then
          print*, 'Error in ARK routine twrite.  These routines'
          print*, 'cannot support reading a writing to the same'
          print*, 'file.'
        else
          irw = 2
        end if

        if (iunit(itlu) .eq. -1) then
          print*, 'Error in ARK routine twrite.  Tape unit ', itlu
          print*, 'has not been opened yet.'
          twrite = -1
          goto 900
        end if

        if (irec .eq. 0) then
          open(unit=iunit(itlu), file='arktio.tmp',
     &    form='unformatted', recl=nblk/4, iostat=i,
     &    access='direct', status='unknown')
!          open(unit=iunit(itlu), file='arktio.tmp',
!     &    form='unformatted', recl=nblk/4, blocksize=nblk, iostat=i,
!     &    access='direct', status='unknown')
          if (i .ne. 0) then
            print*, 'Error in ARK subroutine twrite.'
            print*, 'Fortran open statement reports error number ', i
            twrite=-1
            goto 900
          end if
        end if

        irec=irec+1
        write(iunit(itlu), rec=irec, iostat=i) buffer

        if (i .ne. 0) then
          print*, 'Error in ARK subroutine twrite.'
          print*, 'Fortran read statement reports error number ', i
          twrite=-1
        else
          twrite=len(buffer)
        end if

900     end

        block data
        integer iunit(0:3), irec, irw, nblk
        character*30 dunit(0:3)
        common /arktap/ iunit, dunit, irec, irw, nblk
        data iunit /4*-1/
        data nblk /2880/
        end

        subroutine arkopn(iunit, file, filex, stat, pos, form, acces, &
        irecl)

        implicit none
              
!       Opens a file with a machine independent call.            

!       For the access='direct' part of this the DEC OSF/1 version should
!       have recl=irecl/4, but for the Solaris and Linux version recl=irecl.

!       Returned values.
!       The number of the unit opened.
        integer :: iunit
                     
!       Input values.
!       The file name, and the default extension to be used.
        character(len=*) :: file, filex
!       The status to be used (OLD, NEW or UNKNOWN)
        character(len=*) :: stat
!       The position to start writing into the file (APPEND, OVERWRITE,
!       READONLY).
        character(len=*) :: pos
!       The form of the file (FORMATTED, UNFORMATTED or TAPE)
        character(len=*) :: form
!       The file access (DIRECT or SEQUENTIAL), need only be supplied if
!       form is UNFORMATTED.
        character(len=*) :: acces
!       The record length (the BLOCKSIZE is
!       set to the input record length).  Only used if access is 'DIRECT'.
        integer :: irecl
                     
!       Locals.
!       All the above strings translated to upper case.
        character(len=80) :: ufile, ustat, upos, uform, uacces
!       And some similar strings.
        character(len=80) :: uaction
!       The error flag from UNIX_EXTEND
        integer :: iflag
!       The VAX default file extension simulator.
        character(len=80) :: addon
!       An error flag.
        integer :: iostat
!       The debugger.
        logical :: debug
        common /bug/ debug
                          
!       Copy the strings into local variables.
        call unix_extend(file, ufile, iflag)
        ufile = addon(ufile, filex)

        ustat = stat    
        call upcase(ustat)

        uform = form
        call upcase(uform)

        uacces = 'SEQUENTIAL'
        if (uform .eq. 'UNFORMATTED') uacces = acces
        call upcase(uacces)

        uaction='READWRITE'

        upos = pos
        call upcase(upos)
!       We had better check that pos has a legal value, as the operating
!       system won't tell us!
        if (upos .eq. 'READONLY') then
          uaction='READ'
          upos='REWIND'
        else if (upos .eq. 'OVERWRITE') then
          upos='REWIND'     
!         This is a UNIX system which will crash if it attempts to open
!         an extant file with status='new', so cure the problem if the
!         user has specified 'OVERWRITE'.
          if (ustat .eq. 'NEW') ustat='UNKNOWN'
        else if (upos .ne. 'APPEND') then
          print*, 'ARK S/R ARKOPN called in illegal value for POS.'
          print*, 'POS was "'//upos(1:len(pos))//'"'
          goto 900
        end if
              
!       Get a free unit.
        call find_free(iunit)
                             
!       Write out an informational message.
        if (debug) then
          print*, '@ S/R ARKOPN about to open file ', ufile
          print*, '@ with argument list ', stat, ' ',  pos, ' ', &
          form, ' ', acces, ' ', irecl
          print*, '@ and unit number ', iunit
        end if
              
                                                                     
!       The hard work is done here.
        if (uacces .ne. 'DIRECT') then
          open (unit=iunit, status=ustat, form=uform, access=uacces, &
          file=ufile, action=uaction, position=upos, iostat=iostat)
        else
          open (unit=iunit, status=ustat, form=uform, access=uacces, &
          file=ufile, action=uaction, recl=irecl, iostat=iostat)
        end if

        if (iostat /= 0) then
          print*, 'ARK subrouine arkopn reports error ', iostat
          print*, 'for file name ', ufile
          stop
        end if
              
900     end subroutine arkopn

        subroutine arkgcl(cbuf)

!       Returns the entire command line in cbuf.
!       Based on the XANADU subroutine rdforn.

!       This statement is needed for the NAG f95 compiler.
!       use f90_unix_env

        character cbuf*(*)
        integer narg, i, j, lbuf

        narg=iargc()
        cbuf=' '
        lbuf=0
        if (narg .gt. 0) then
          do 190 i=1, narg
            call getarg(i, cbuf(lbuf+1:len(cbuf)))
!           Add a space between arguments, and update lbuf.
            do 170 j=len(cbuf), 1, -1
              if(cbuf(j:j).ne.' ' .and. cbuf(j:j).ne.char(0)) then
                cbuf(j+1:j+1)=' '
                lbuf=j+1
                goto 190
              end if
170         continue
190       continue
        end if

        end subroutine arkgcl

      module put_header

        use get_header
        implicit none

      contains

!       Subroutines in this file add one line to an ARK_FITS header.
!       see the subroutines in GETDROSS.FOR to recover the info.
!       If header line of the same KEY value exists, you can over-write it
!       (Override=1), add another line (Override=0) or stop writing it
!       (Override=-1).
 
       Subroutine CLEAR_HEADER( )
 
       Integer K
 
       Character*80 Dross( 180 )
       common / pasdrs / dross
                        
       Do 100 K = 1, 180
         call blklin(dross(k))
100     continue
        dross(1)(1:8)='END     '
 
 
       End subroutine clear_header
 
 
 
       Subroutine put_header_c( Key, Value, Descriptor, Override )
 
       Character*( * ) Key, Descriptor
       Character Value
       Integer Override
 
       Character*8 out_Key
       Integer I, L
 
       Character*80 Dross( 180 )
       common / pasdrs / dross
 
       Call MATCH_KEY( Key, out_Key, L, Override )
       If( L .le. 0 ) Return
       call blklin(Dross( L ))
       Dross( L )( 1: 8 ) = out_Key
       Dross( L )( 9: 9 ) = '='
       I = Ichar( Value )
       If( I .ge. 97 .and.  I .le. 122 ) Value = Char( I - 32 )
       Dross( L )( 30: 30 ) = Value
       If( Descriptor .eq. ' ' ) Return
       Dross( L )( 32: 32 ) = '/'
       I = Min( Len( Descriptor ) + 32, 80 )
       Dross( L )( 33: I ) = Descriptor( 1: I - 32 )
 
900       End subroutine put_header_c
 
 
 
       Subroutine Put_header_r( Key, Value, Descriptor, Override )
 
       Character*( * ) Key, Descriptor
       Real Value
       Integer Override
 
       Character*8 out_Key
       Integer I, L
 
       Character*80 Dross( 180 )
       common / pasdrs / dross
 
       Call MATCH_KEY( Key, out_Key, L, Override )
       If( L .le. 0 ) Return
       call blklin(Dross( L ))
       Dross( L )( 1: 8 ) = out_Key
       Dross( L )( 9: 9 ) = '='
       If( Value .gt. 1.0E+04 .or. Value .lt. -1.0E+04 ) Then
         Write( Dross( L )( 15: 30 ), '(E16.10)' ) Value
       Else
         Write( Dross( L )( 15: 30 ), '(E16.10)' ) Value
       End If
       If( Descriptor .eq. ' ' ) Return
       Dross( L )( 32: 32 ) = '/'
       I = Min( Len( Descriptor ) + 32, 80 )
       Dross( L )( 33: I ) = Descriptor( 1: I - 32 )
 
       End subroutine put_header_r
 
 
 
       Subroutine Put_header_d( Key, Value, Descriptor, Override )
 
       Character*( * ) Key, Descriptor
       double precision Value
       Integer Override
 
       Character*8 out_Key
       Integer I, L
 
       Character*80 Dross( 180 )
       common / pasdrs / dross
 
       Call MATCH_KEY( Key, out_Key, L, Override )
       If( L .le. 0 ) Return
       call blklin(Dross( L ))
       Dross( L )( 1: 8 ) = out_Key
       Dross( L )( 9: 9 ) = '='
       If( Value .gt. 1.0E+04 .or. Value .lt. -1.0E+04 ) Then
         Write( Dross( L )( 15: 30 ), '(E16.10)' ) Value
       Else
         Write( Dross( L )( 15: 30 ), '(E16.10)' ) Value
       End If
       If( Descriptor .eq. ' ' ) Return
       Dross( L )( 32: 32 ) = '/'
       I = Min( Len( Descriptor ) + 32, 80 )
       Dross( L )( 33: I ) = Descriptor( 1: I - 32 )
 
       End subroutine put_header_d
 
 
 
       Subroutine put_header_i( Key, Value, Descriptor, Override )
 
       Character*( * ) Key, Descriptor
       Integer Value
       Integer Override
 
       Character*8 out_Key
       Integer I, L
 
       Character*80 Dross( 180 )
       common / pasdrs / dross
 
       Call MATCH_KEY( Key, out_Key, L, Override )
       If( L .le. 0 ) Return
       call blklin(Dross( L ))
       Dross( L )( 1: 8 ) = out_Key
       Dross( L )( 9: 9 ) = '='
       Write( Dross( L )( 20: 30 ), '(I11)' ) Value
       If( Descriptor .eq. ' ' ) Return
       Dross( L )( 32: 32 ) = '/'
       I = Min( Len( Descriptor ) + 32, 80 )
       Dross( L )( 33: I ) = Descriptor( 1: I - 32 )
 
       End subroutine put_header_i
 
 
 
       Subroutine put_header_s( Key, Value, Descriptor, Override )
 
       Character*( * ) Key, Descriptor
       Character*( * ) Value
       Integer Override
 
       Character*8 out_Key
       Integer I, K, L, N, Length, Pos
 
       Character*80 Dross( 180 )
       common / pasdrs / dross
 
       Call MATCH_KEY( Key, out_Key, L, Override )
       If( L .le. 0 ) Return
       call blklin(Dross( L ))
       Dross( L )( 1: 8 ) = out_Key
       Dross( L )( 9: 11 ) = '= '''
       I = Len( Value )
!       Make all blank strings have 1 character.
        Length = 1
       Do K = 1, I
         N = Ichar( Value( K: K ) )
         If( N .ge. 33 ) Then
           Length = K
!           If( N .ge. 97 .and. N .le. 122) Value( K: K ) = Char( N - 32 )
         End If
       End Do
       Length = Min( Length, 68 )
       Pos = Length + 11
       Dross( L )( 12: Pos ) = Value( 1: Length )
       Pos = Pos + 1
       Dross( L )( Pos: Pos ) = ''''
       If( Pos .ge. 71 .or. Descriptor .eq. ' ' ) Return
       Pos = Max( 32, ( Pos + 9 ) / 8 * 8 )
       Dross( L )( Pos: Pos ) = '/'
       I = Min( Len( Descriptor ) + Pos, 80 )
       Dross( L )( Pos + 1: I ) = Descriptor( 1: I - Pos )
 
       End subroutine put_header_s
 
 
 
       Subroutine MATCH_KEY( Key, out_Key, L, Override )
!
!       Tells the put_header_% routines where to write the line of header,
!       or tells then -1 if they are not to.  This version emulates Koji's
!       original using matkey, and also writes a 'END' to the header.
 
       Character*( * ) Key
       Character*8 out_Key
       Integer L, Override
 
        integer iend
       Character*80 Dross( 180 )
       common / pasdrs / dross
 
        l=matkey(Key, out_Key)
        iend=lndrss()
        if (override .eq. 0) then
          if (out_key .eq. 'SIMPLE  ' &
         .or. out_key .eq. 'BITPIX  ' &
         .or. out_key .eq. 'REALTYPE' &
         .or. out_key .eq. 'NAXIS   ' &
         .or. out_key .eq. 'NAXIS1  ' &
         .or. out_key .eq. 'NAXIS2  ' &
         .or. out_key .eq. 'NAXIS3  ') then
            print*, 'Error in ARK S/R MATCH_KEY, attempt to add a'
            print*, 'second line of header with the keyword ', out_key
            print*, 'aborted.  Please call PUT_HEADER routine with'
            print*, 'override value other than 0.'
            goto 900
          end if
        end if              
              
!       Check for manditory header items.  If the item is manditory,
!       put it in the right place and delete any other versions of it.
        if (     out_key.eq.'SIMPLE  ' .and. l.ne.1) then
          call sdown(1)
          l=1
          call rem_header('SIMPLE  ')
          iend=max(iend+1,2)
        else if (out_key.eq.'BITPIX  ' .and. l.ne.2) then
          call sdown(2)
          l=2
          call rem_header('BITPIX  ')
          iend=max(iend+1,3)
        else if (out_key.eq.'REALTYPE' .and. l.ne.2) then
          call sdown(2)
          l=2
          call rem_header('REALTYPE')
          iend=max(iend+1,3)
        else if (out_key.eq.'NAXIS   ' .and. l.ne.3) then
          call sdown(3)
          l=3
          call rem_header('NAXIS   ')
          iend=max(iend+1,4)
        else if (out_key.eq.'NAXIS1  ' .and. l.ne.4) then
          call sdown(4)
          l=4
          call rem_header('NAXIS1  ')
          iend=max(iend+1,5)
        else if (out_key.eq.'NAXIS2  ' .and. l.ne.5) then
          call sdown(5)
          l=5
          call rem_header('NAXIS2  ')
          iend=max(iend+1,6)
        else if (out_key.eq.'NAXIS3  ' .and. l.ne.6) then
          call sdown(6)
          l=6
          call rem_header('NAXIS3  ')
          iend=max(iend+1,7)
        else
!         l is now equal to the line number of the header item,
!         or negative if the item doesn't exist.              
          if (l.gt.0 .and. override.eq.-1) then
!           The item exists and is not to be overwritten.
            l=-1
          end if
          if (l.lt.0 .or. override.eq.0) then
!           If the line of header does not exist, or an extra
!           line is to be written even if it does, then add
!           a line of header.
!           Check for a full header.
            if (iend .ge. 180) then
              print*, 'Warning, header is full, overwriting item ', &
              dross(179)(1:8)
              l=179
            else
              l=iend
              iend=iend+1
            end if
          end if
        end if

        call blklin(dross(iend))
        dross(iend)(1:8)='END     '

900     end Subroutine MATCH_KEY
           
        subroutine sdown(itop)
                              
!       Moves the header down a line, to make room for a manditory item.
                                                                        
        integer itop
                    
       Character*80 Dross( 180 )
       common / pasdrs / dross
                        
        integer i

        if (lndrss() .ge. 180) then
          print*, 'Warning, header is full, overwriting item ', &
          dross(179)(1:8)
          call blklin(dross(179))
          dross(179)(1:3)='END'
        end if
                 
        do 190 i=179, itop, -1
          dross(i+1)=dross(i)
190     continue
       call blklin(dross(itop))
                         
        end subroutine sdown
           
        subroutine rem_header(key)
                                  
!       Removes all the lines of header matching the key given.
                                                               
        character key*(*), outkey*8
        integer i, iend
                               
       Character*80 Dross( 180 )
       common / pasdrs / dross
                        
100     iend=matkey(key,outkey)
        if (iend .lt. 0) goto 900
                                 
        do 780 i=iend+1, 180
          dross(i-1)=dross(i)
780     continue
        call blklin(dross(180))
                
        goto 100
                
900     end subroutine rem_header
           
           
        subroutine blklin(string)
                                 
!       Makes sure every character in a string is a blank.
                                                          
        character*(*) string
                            
        integer i
                 
        do 300 i=1, len(string)
          string(i:i)=' '
300     continue
                
        end subroutine blklin

      end module put_header

module ark_file_io

  ! This module is the Fortran 90 I/O for the ARK.  It should emulate all the
  ! old calls, except that the facility to write integer*2 images has gone,
  ! and reading such images may not work on certain machines.

  use get_header
  use put_header
  implicit none

  ! The number of bytes for a real written to a FITS file.
  integer, parameter :: k4=4

  ! The length of file name strings to be used.
  integer, parameter :: filnam_len=128

  ! The next input and output files, and last input file
  character(len=filnam_len), private :: file_in = ' ', file_out, lstfil
  character(len=3), private :: filex = '   '
  ! The default file type to be written is ARK.
  integer, private :: itypef = 1
  ! Interactive mode is to be used by default.
  logical, private :: inter_in=.true., inter_out=.true.
  ! The error array to be written out.
  real, private, allocatable, dimension(:) :: yerr_out
  ! The flag array to be written out.
  character, dimension(:,:), save, allocatable, private :: pix_flg_out
  integer, dimension(2), save, private :: naxis_pix_flg
  character(len=filnam_len), save, private :: nxt_pix_file
  ! The last extension read and next extension to read.
  integer, private :: lext_in=0, next_in=0, next_out=0
  logical, private :: ext_write=.false.
        
  ! The header information.
  character(len=80), private, dimension(180) :: dross
  common /pasdrs/ dross

  common /bug/ debug
  logical, private :: debug
      
  interface inpark

    module procedure inpark_1d
    module procedure inpark_2d

  end interface 

  interface makark           

    module procedure makark_1d
    module procedure makark_2d

  end interface 

  contains

    ! These routines ensure that extension 0 has the header item in it
    ! to make it clear there are subsequent extensions.
    ! You should only need to call this when creating FITS files from 
    ! scratch, otherwise the headers of the files you read in should
    ! be correct for the ones you write out.
    subroutine write_ext()
      ext_write=.true.
    end subroutine write_ext
      
    subroutine no_write_ext()
      ext_write=.false.
      next_out=0
    end subroutine no_write_ext
      
    subroutine nxtark_in(ufile, iext)
      ! Specifies what the next file to be read is called, and tells inpark
      ! not to prompt for the file name
      character(len=*) ::  ufile
      integer, optional :: iext
      inter_in=.false.
      file_in=ufile
      if (present(iext)) then
        next_in=iext
      else
        next_in=0
      end if
    end subroutine nxtark_in

    subroutine nxtark_out(ufile, iext)
      ! Specifies what the next file to be read is called, and tells inpark
      ! not to prompt for the file name
      character(len=*) ::  ufile
      integer, optional :: iext
      inter_out=.false.
      file_out=ufile
      if (present(iext)) then
        next_out=iext
      else
        next_out=0
      end if
    end subroutine nxtark_out
           
    subroutine typark(itype)
      ! Specifies that the next spectrum is to be written as either a
      ! binary or an ASCII file.
      integer :: itype
      itypef=itype
    end subroutine typark
           
    subroutine lstark_in(ufile, iext)
      ! Returns the name of the last file read in.
      character(len=*) ufile
      integer, optional :: iext
      ufile=lstfil
      if (present(iext)) iext=lext_in
    end subroutine lstark_in
           
    subroutine lstark_out(ufile, iext)
      ! Returns the name of the last file written out.
      character(len=*) ufile
      integer, optional :: iext
      ufile=file_out
      if (present(iext)) then
        print*, 'Using a second argument to lstark_out still needs coding.'
        stop
      end if
    end subroutine lstark_out
           
    subroutine extark(ufilex)
      ! Specifies the default file extension.
      character(len=*) :: ufilex
      if (len(ufilex) .gt. 3) then
        print*, 'Warning from ARK S/R EXTARK.  The supplied'
        print*, 'file extension was more than 3 characters.'
      end if
      filex=ufilex
    end subroutine extark

    subroutine quick_for_fudge(iext)
      integer :: iext
      lext_in=iext
    end subroutine quick_for_fudge
           

    integer function inpark_1d(naxis, data, axdata)
                                                                       
      ! Outputs.
      ! The lengths of each axis.
      integer :: naxis
      ! The data.
      real, dimension(:), allocatable :: data
      ! The axis scales.
      real, dimension(:), allocatable :: axdata
                      
      ! Locals
      logical :: there                     
      character(len=8) :: arktyp

100   if (inter_in) then
        call inpprm('INPARK Version 2.0.', filex, lstfil)
        if (lstfil.eq.'end' .or. lstfil.eq.'END') then 
          inpark_1d = -1
          goto 900                 
        end if
      else
        lstfil=file_in
      end if

      ! Inquire to see if the file is there, and at the same time find
      ! out some other useful facts.
      call arkinq(lstfil, filex, there, arktyp)
      if (.not. there) then
        if (inter_in) then
          print*, 'File not found, please try again.'
          goto 100
        else                            
          inpark_1d=-2
          goto 900
        end if       
      end if
      print*, 'Reading file '//trim(lstfil)
      call clear_header()
              
      ! Now go to the appropriate read routine.
      if (arktyp .eq. 'ARK_FITS') then
        if (inter_in) then
          print*, 'ERROR.  This file is an image, not an X-Y file.'
          goto 100
        else
          inpark_1d=-4
          goto 900
        end if
      else if (ArkTyp .eq. 'ARK') Then
        ! ARK file
        call arkark(lstfil, naxis, data, axdata)
        inpark_1d = 1
        itypef=1
      else
        ! IUE File
        call arkiue(lstfil, naxis, data, axdata)
        inpark_1d = 2
        itypef=2
      end if
                                               
900   inter_in=.true.

    end function inpark_1d


      subroutine arkark(lstfil, naxis, data, axdata)

        character(len=*), intent(in) :: lstfil
        integer, intent(out) :: naxis
        real, dimension(:), allocatable, intent(out) :: data, axdata

        real, external :: ripoly

        integer :: iunit, i, iorder
        double precision, dimension(0:9) :: coefs

        call arkopn(iunit, lstfil, ' ', 'old', 'readonly', &
        'unformatted', 'sequential', 0)
        read(iunit) naxis, (dross(i), i = 1, 36)
        if (allocated(data)) deallocate(data)
        allocate(data(naxis))
        if (allocated(axdata)) deallocate(axdata)
        allocate(axdata(naxis))
        read(iunit) (data(i), i = 1, naxis)
        read(iunit) coefs
        close(iunit)
        do i = 0, 9
          if (coefs(i) .ne. 0.0) iorder = i
        end do      
        do i = 1, naxis
          axdata(i) = RIPOLY(i, coefs, iorder)
        end do

      end subroutine arkark

      subroutine arkiue(lstfil, naxis, data, axdata)

        character(len=*), intent(in) :: lstfil
        integer, intent(out) :: naxis
        real, dimension(:), allocatable, intent(out) :: data, axdata

        character(len=80) :: input           
        real :: junk1, junk2
        integer :: i, iunit

        call arkopn(iunit, lstfil, ' ', 'old', 'readonly', &
        'formatted', ' ', 0)
        ! Read the header.
        read(iunit,'(a80)') dross(1)
        read(iunit,'(a80)') dross(2)
        read(iunit,'(a80)') dross(3)
        dross(4)='END'
        naxis=0
        do   
220       Read(iunit, '(A80)', End = 230 ) Input
          read(input, *, end = 220, err = 220 ) junk1, junk2
          naxis = naxis + 1
        end do
230     if (allocated(data)) deallocate(data)
        allocate(data(naxis))
        if (allocated(axdata)) deallocate(axdata)
        allocate(axdata(naxis))
        rewind(iunit)
        read(iunit, '(/,/)')
        do i=1, naxis
240       Read(iunit, '(A80)') Input   
          Read(input, *, end = 240, err = 240 ) axdata(i), data(i)
        End Do              
        close(iunit)

      end subroutine arkiue

        integer function inpyer(yerr, npts)

        real, dimension(:), intent(out), allocatable :: yerr
        integer, optional, intent(in) :: npts

        integer :: iunit, iostat, i, naxis
        character(len=filnam_len) :: wrk_filnam
        character(len=filnam_len) :: wrkstr
        character(len=filnam_len), external :: addon
        real :: junk1, junk2

        character(len=8) :: arktyp
        logical :: there

        inpyer=-2
!       Does an error file exist?
        i=index(lstfil,'.',.true.)
        there=.false.
        if (i > 0) then
          wrk_filnam=lstfil(1:i+1)//lstfil(i+3:i+3)//'e'
          call arkinq(wrk_filnam, ' ', there, arktyp)
        end if
        if (present(npts)) then
          if (allocated(yerr)) deallocate(yerr)
          allocate(yerr(npts))
        end if
        if (there) then
          print*, 'And error file '//trim(wrk_filnam)
          if (ArkTyp .eq. 'ARK') Then  ! ARK file
            call arkopn(iunit, wrk_filnam, ' ', 'old', 'readonly', &
            'unformatted', 'sequential', 0)
!           Skip out reading header.
            read(iunit) naxis
            read(iunit) (yerr(i), i = 1, naxis)
!           Skip reading X-axis.
            close(iunit)
            inpyer=1
          else ! IUE File     
            call arkopn(iunit, wrk_filnam, ' ', 'old', 'readonly', &
            'formatted', ' ', 0)
!           Skip the header.
            read(iunit,'(a80)') wrkstr
            read(iunit,'(a80)') wrkstr
            read(iunit,'(a80)') wrkstr
            readloop: do i=1, size(yerr)
              tryloop: do
                read(iunit, '(a80)', iostat=iostat) wrkstr
                if (iostat < 0) exit readloop
                Read(wrkstr, *, iostat=iostat) junk1, yerr(i)
                if (iostat == 0) exit tryloop
              end do tryloop
            end do readloop
            close(iunit)
            inpyer=2
          end if
        else if (itypef == 2) then
          inpyer = 2
          call arkopn(iunit, lstfil, ' ', 'old', 'readonly', &
          'formatted', ' ', 0)
          ! Read the header.
          read(iunit,'(a80)') wrkstr
          read(iunit,'(a80)') wrkstr
          read(iunit,'(a80)') wrkstr
          read: do i=1, size(yerr)
            try: do
              read(iunit, '(a80)', iostat=iostat) wrkstr
              if (iostat == 0) then
                read(wrkstr, *, iostat=iostat) junk1, junk2, yerr(i)
                if (iostat == 0) exit try
              else if (iostat < 0) then
                ! End of file.
                if (i < size(yerr)) then
                  ! Hmm.  Reached end-of-file before reading all the
                  ! required data.  Better tell someone.
                  inpyer=-5
                end if
                exit read
              else
                ! Some other error.
                inpyer = -5
                exit read
              end if
            end do try
          end do read
          close(iunit)
        end if

        end function inpyer



        integer function makyer(yerr)

        real, dimension(:) :: yerr        

        allocate(yerr_out(size(yerr)))
        yerr_out=yerr

        makyer=1

        end function makyer

    integer function inpark_2d(naxis, data, axdata)
                                                                       
      ! Outputs.
      ! The lengths of each axis.
      integer, dimension(2) :: naxis
      ! The data.
      real, dimension(:,:), allocatable :: data
      ! The axis scales.
      real, dimension(:,:), allocatable :: axdata
                      
      ! Locals           
      logical :: there
      character(len=8) :: arktyp
      integer :: ifail
      real, external :: ripoly
      real, allocatable, dimension(:) :: data_1d, axdata_1D

100   if (inter_in) then
        call inpprm('INPARK Version 2.0.', filex, lstfil)
        if (lstfil.eq.'end' .or. lstfil.eq.'END') then 
          inpark_2d = -1
          goto 900
        end if
        !print*, 'Called in interactive mode, returning file name ', lstfil
        !print*, 'And the next extension ', next_in
      else
        lstfil=file_in
        !print*, 'Called in batch mode for file ', trim(lstfil)
      end if

      ! Inquire to see if the file is there, and at the same time find
      ! out some other useful facts.
      call arkinq(lstfil, filex, there, arktyp)
      if (.not. there) then
        if (inter_in) then
          print*, 'File not found, please try again.'
          goto 100
        else                            
          inpark_2d=-2
          goto 900
        end if       
      end if
      if (next_in > 0) then
        print*, 'Reading file '//trim(lstfil)//' extension ', next_in
      else
        print*, 'Reading file '//trim(lstfil)
      end if
      call clear_header()
              
      ! Now go to the appropriate read routine.
      if (arktyp .eq. 'ARK_FITS') then
        call arkfit(data, naxis, axdata, ifail, inter_in, lstfil)
        if (ifail==-5 .and. next_in>0) then
          ! Probably failed trying to read beyond the last extension.
          ! See if we can do the next file.
          next_in=0
          if (inter_in) then
            ! Try for another file
            goto 100
          else
            ! In batch mode, let's return. 
            inpark_2d=-5
          end if
        else if (ifail > -1) then
          itypef=3
          inpark_2d=3
          lext_in =next_in
          next_out=next_in
          !next_in=next_in+1
        else                    
          inpark_2d=ifail
        end if
      else 
        ! An ARK or IUE file.
        naxis(2)=1
        if (ArkTyp .eq. 'ARK') Then
          ! ARK file
          call arkark(lstfil, naxis(1), data_1D, axdata_1D)
          inpark_2d = 1
          itypef=1
        else 
          ! IUE File     
          call arkiue(lstfil, naxis(1), data_1D, axdata_1D)
          inpark_2d = 2
          itypef=2                
        end if
        ! Now sort out putting a 1D array into a 2D one.  
        if (allocated(data)) deallocate(data)
        allocate(data(size(data_1D),1))
        data(:,1)=data_1D
        deallocate(data_1D)
        if (allocated(axdata)) deallocate(axdata)
        allocate(axdata(size(axdata_1D),1))
        axdata(:,1)=axdata_1D
        deallocate(axdata_1D)
      end if
                    
900   inter_in=.true.

    end function inpark_2d                               

        subroutine arkfit(data, naxis, axdata, ifail, inter, lstfil)
                                                 
!       ifail is returned as 3 for success.
                                           
!       Passed variables.
        integer, dimension(2) :: naxis
        real, dimension(:,:), allocatable :: data, axdata
        integer ifail
        logical inter
        character(len=*) :: lstfil
                     
!       Locals.
        integer*2 inblk(1440)
        integer*2 :: i2work
        integer(kind=k4), dimension(2880/4) :: relblk
        character, dimension(2880) :: chrblk
        double precision bscale, bzero, crval1, crval2, cdelt1, cdelt2
        double precision :: crpix1, crpix2
        logical scale
        integer i, iblk, icount, max1, max2, j, nbit, iunit
        logical :: bswap=.true.
        integer(kind=k4) :: r4work
        integer :: numaxis
        character(len=10) :: ark_fits_bswap
        logical :: gsm_test

        character :: simple
                                 
!       Functions called.
        logical, external :: arkgsm
                                                                
        iunit=0

        i=ext_skip(lstfil, inter, iunit, next_in)

        call fithed(lstfil, inter, iunit, ifail)
        if (ifail == -1) then
          if (debug) print*, '@ Probably read beyond the last extension.'
          ifail=-5
          goto 900
        end if

        ifail=3

        i=get_header_i('NAXIS', numaxis)
        if (next_in==0 .and. numaxis==0) then
          naxis=0
          nbit=0
          if (allocated(data)) deallocate(data)
          allocate(data(0,0))
          if (allocated(axdata)) deallocate(axdata)
          allocate(axdata(0,2))
          goto 890
        end if

        inquire(iunit, nextrec=iblk)

        i=get_header_i('BITPIX', nbit)
        if (abs(nbit)/=32 .and. nbit/=16 .and. nbit/=8) then
          if (inter) then
            print*, '* Warning BITPIX =', nbit
          else
            ifail=-30
            goto 900
          end if
        end if
        if (get_header_i('NAXIS1', naxis(1)) < 1) then
          if (inter) then
            print*, '* Failed to read naxis(1) for FITS header.'
            print*, '> Please give naxis(1) for this file.'
            read(*,*) naxis(1)
          else
            ifail=-3
            goto 900
          end if            
        end if
        if (numaxis == 1) then
          naxis(2)=1
        else
          if (get_header_i('NAXIS2', naxis(2)) < 1) then
            if (inter) then
              print*, '* Failed to read naxis(2) for FITS header.'
              print*, '> Please give naxis(2) for this file.'
              read(*,*) naxis(2)
            else
              ifail=-3
              goto 900
            end if
          end if
        end if
        if (debug) print*, '@ Array is ', naxis(1), 'x', naxis(2)
        scale=.false.
        if (get_header_d('BSCALE', bscale) .gt. 0) then
          if (debug) print*, '@ bscale is ', bscale
          scale=.true.
        else
          bscale=1.0d0
        end if
        if (get_header_d('BZERO', bzero) .gt. 0) then
          if (debug) print*, '@ bzero is ', bzero
          scale=.true.
        else
          bzero=0.0d0
        end if
              
        if (allocated(data)) deallocate(data)
        allocate(data(naxis(1),naxis(2)))
        if (allocated(axdata)) deallocate(axdata)
        allocate(axdata(maxval(naxis),2))

!       Check that reasonable naxis(1) and naxis(2) values have been found.
        if (naxis(1).gt.size(data,1) .or. naxis(2).gt.size(data,2)) then
          if (inter) then
            print*,'* Possible error in data array dimensions.'
            print*,'* Program data array size is ', size(data,1), &
            'x', size(data,2)
            print*,'* Data file header gives size as ', &
            naxis(1),'x',naxis(2)
          else
            ifail=-99
            goto 900
          end if
        end if
        if (size(axdata,1) .lt. max(naxis(1), naxis(2))) then
          if (inter) then
            print*, '* Possible error in axdata array dimensions.'
            print*, '* Program size is ', size(axdata,1)
            print*, '* Data file header gives longest axis as ', &
            max(naxis(1), naxis(2))
          else
            ifail=-97
            goto 900
          end if
        end if

        ! Do we need to byte swap?
        i=get_header_c('SIMPLE', simple)
        if (simple == 'A') then 
          ! Old style ark files.  Who knows if we need to byte swap or
          ! not (the byte order was the natural one for the system on
          ! which they were written)?  Lets assume they were written
          ! on the currenet OS.
          bswap=.false.
        else
          ! These are FITS files.  We know the order, but the question
          ! is which order does the operating system expect?
          gsm_test=arkgsm('ARK_FITS_BSWAP', ark_fits_bswap)
          if (trim(ark_fits_bswap) == 'FALSE') then
            bswap=.false.
          else
            bswap=.true.
          end if
        end if
        if (debug) print*, '@ BSWAP is ', bswap

        ! Obtain the axis information.
        if (get_header_d('CRVAL1', crval1) .lt. 1) crval1=1.0d+00
        if (get_header_d('CDELT1', cdelt1) .lt. 1) then
          if (get_header_d('CD1_1', cdelt1) .lt. 1) cdelt1=1.0d+00
        end if
        if (get_header_d('CRPIX1', crpix1) .lt. 1) crpix1=1.0d+00
        if (get_header_d('CRVAL2', crval2) .lt. 1) then
          if (get_header_d('CD2_2', cdelt2) .lt. 1) cdelt2=1.0d+00
        end if
        if (get_header_d('CDELT2', cdelt2) .lt. 1) cdelt2=1.0d+00
        if (get_header_d('CRPIX2', crpix2) .lt. 1) crpix2=1.0d+00
        do 610 i=1, naxis(1)
          axdata(i,1)=real(crval1 + (dble(i)-crpix1)*cdelt1)
610     continue
        do 620 i=1, naxis(2)
          axdata(i,2)=real(crval2 + (dble(i)-crpix2)*cdelt2)
620     continue

!       Read the data.
        max1=naxis(1)
        max2=naxis(2)
        if (abs(nbit) == 32) then
          icount=2880/4
          do j=1, max2
            do i=1, max1
              if (icount .eq. 2880/4) then
                if (debug) print*, '@ About to read block ', iblk
                read(unit=iunit, rec=iblk) relblk
                iblk=iblk+1
                icount=0
              end if
              icount=icount+1
              if (bswap) then
                r4work=relblk(icount)
                call mvbits(r4work,  0, 8, relblk(icount), 24)
                call mvbits(r4work,  8, 8, relblk(icount), 16)
                call mvbits(r4work, 16, 8, relblk(icount),  8)
                call mvbits(r4work, 24, 8, relblk(icount),  0)
              end if
              if (nbit > 0) then
                data(i,j)=real(relblk(icount))
              else
                data(i,j)=transfer(relblk(icount),0.0)
              end if
            end do
          end do
        else if (nbit == 16) then
          icount=2880/2
          do j=1, max2
            do i=1, max1
              if (icount .eq. 2880/2) then
                if (debug) print*, '@ About to read block ', iblk
                read(unit=iunit, rec=iblk) inblk
                iblk=iblk+1
                icount=0
              end if
              icount=icount+1
              if (bswap) then
                i2work=inblk(icount)
                call mvbits(i2work, 0, 8, inblk(icount), 8)
                call mvbits(i2work, 8, 8, inblk(icount), 0)
              end if
              data(i,j)=inblk(icount)
            end do
          end do
        else if (nbit == 8) then
          icount=2880
          do j=1, max2
            do i=1, max1
              if (icount .eq. 2880) then
                if (debug) print*, '@ About to read block ', iblk
                read(unit=iunit, rec=iblk) chrblk
                iblk=iblk+1
                icount=0
              end if
              icount=icount+1       
              data(i,j)=ichar(chrblk(icount))
            end do
          end do
        end if                

        if (scale) then
          if (debug) print*, '@ Applying scale factors...'
          do 470 j=1, naxis(2)
            do 460 i=1, naxis(1)
              data(i,j)=sngl(dble(data(i,j))*bscale + bzero)
460         continue
470       continue
        end if
              
        if (debug) then
          print*, '@ Test data point (1,1) = ', data(1,1)
        end if

890     if (get_header_s('ARK-FLAG', nxt_pix_file) < 1) nxt_pix_file=' '
900     close(iunit)
        end subroutine arkfit
                                      

        subroutine fithed(lstfil, inter, iunit, ifail)

        character(len=*) :: lstfil
        integer iunit, ifail
        ! On input the first block of header to read, on output the 
        ! first block of data after the header. 
        logical :: inter
        logical :: opened

        character(len=80) :: form

!       Locals.
        integer i, ndrec, ndrs36
        character expkey*8
        integer :: iblk, iostat
                   
        ifail=0

!       Blank out the header.
        dross=' '

        if (iunit /= 0) inquire(iunit, opened=opened)
        if (.not.opened .or. iunit==0) then
          call arkopn(iunit, lstfil, filex, 'OLD', 'APPEND', &
          'UNFORMATTED', 'DIRECT', 2880)
        end if
        inquire(iunit, nextrec=iblk)
        if (debug) print*, 'Fithed thinks header begins at block ', iblk

        do 220 ndrec=iblk, iblk+100
          ndrs36=(ndrec-iblk+1)*36
          if (debug) print*, '@ About to read header block ', ndrec
          inquire(unit=iunit, form=form)
          if (ndrs36 .gt. 180) then
            if (inter) then               
              print*, '* Warning, some of the header is lost'
              print*, '* because there are more than 180 lines.'
            end if
            read (unit=iunit, rec=ndrec, iostat=iostat) (dross(i), i=180-35,  180)
          else
            read (unit=iunit, rec=ndrec, iostat=iostat) (dross(i), i=ndrs36-35,  ndrs36)
          end if
          if (iostat /= 0) then
            ! O.K., we've read a block that's not there.  Read the previous 
            ! block to that so that inquire works fine.
            read(unit=iunit, rec=ndrec-1)
            ifail=-1
            goto 900
          end if 
          if (debug) print*, '@ Read header block ', ndrec
!         See if we have an end statement yet.
          i=matkey('END', expkey)
          if (i .gt. 0) then
            if (debug) print*,'@ "END" statement found at line ', i
            goto 400
          end if
220     continue
!       If you get to here then no end statement has been found.
        if (inter) then
          print*,'* Failed to find FITS file header "END" statement.'
          ifail=-8
          goto 900
        end if
400     if (debug) print*,'@ There are ', ndrs36, ' lines of header.'
        if (debug) then
          do i=1, ndrs36
            !print*, dross(i)(1:60)
          end do
        end if
        iblk=ndrs36/36 + 1

900     end subroutine fithed


        subroutine inpprm(caller, filext, nxtfil)

        ! Returns the name of the next file to be read, prompting
        ! if needs be.

        ! Inputs.
        ! The name of the calling routine.
        character(len=*), intent(in) :: caller
        ! The current requested file name (may include wild cards).
        !character(len=*), intent(inout) :: file
        ! Is this in batch or interactive mode?
        !logical, intent(in) :: inter
        ! The current default file extension.
        character(len=3), intent(inout) :: filext
        ! The name of the next file to be read.
        character(len=*), intent(out) :: nxtfil

        ! Locals
        character(len=80) :: input
        character(len=filnam_len), save :: fildef
        character(len=3), save :: extdef
        character(len=78) :: outstr
        character (len=8) :: arktyp
        integer, save :: lunit=5
        logical, save :: lastf=.true.
        logical :: there
        integer :: iostat
        character(len=2), save :: imext_def
        integer :: ifirst_blank, iend_string

80      if (lastf) then
          ! The last file read was the last one which matched the
          ! wild card.
          get_name: do
            ! Running in interactive mode, so prompt for new file,
            ! first checking to see if there is a default file extension.
            ! Don't print a prompt if reading from a file.
            if (lunit == 5) then
              if (filext(1:1).ne.' ' .and. filext(1:1).ne.char(0)) then
                outstr='Give input file '// &
                '(".'//filext//'" is assumed, "?" gives help)>'
                call writen(outstr(1:52))
              else
                outstr='Give input file ("?" gives help)>'
                call writen(outstr(1:33))
              end if
            end if
            read (lunit, '(a)', end=800) input
            ! Now, this string may have just a file name, or a file name
            ! and an extension number.
            ! Find index of first blank.
            ifirst_blank = index(input,' ')
            ! Find length of input.
            iend_string = len_trim(input)
            ! Filename is input up to first blank.
            fildef=input(1:ifirst_blank)
            imext_def=input(ifirst_blank+1:iend_string)
            ! If imext_def is composed entirely of blanks, len_trim returns 0.
            if (len_trim(imext_def) == 0) then
              imext_def = '--'
            else
              ! Otherwise, move leading blanks to trailing blanks, so
              ! imext_def starts with the input that came after any blanks.
              imext_def=adjustl(imext_def)
            end if
            if (fildef(1:1) .eq. '#') then
              call arkcom(fildef(2:50))
            else if (fildef(1:1) .eq. '?') then
              print*, 'You are currently in '//caller
              print*, 'You can either;'
              print*, '    1) Give an input file name (wild cards are'
              print*, '       allowed) and optionally an extension number.'
              print*, '    2) Type "end" or EoF to exit without reading'
              print*, '       a file.'
              print*, '    3) Access the operating system by typing "#"'
              print*, '       followed by a command.'
              print*, '    4) Redisplay this help by typing "?".'
              print*, '    5) Give a new default file name extension by'
              print*, '       typing "EXT".'
              print*, '    6) Give a file with a list of file names in'
              print*, '       by typing "@filename".'
              if (filext(1:1).ne.' ' .and. filext(1:1).ne.char(0)) then
                print*, 'The default file name extansion is ', filext, '.'
              end if
            else if (fildef.eq.'ext' .or. fildef.eq.'EXT') then
110           call writen('Give new file name extension (<4 letters)>')
              read (*,'(a)',err=110, end=110) filext
            else if (fildef(1:1) .eq. '@') then
              call arkinq(fildef(2:100), 'lis', there, arktyp)
              if (there) then
                call arkopn(lunit, fildef(2:100), 'lis', 'OLD', &
                'READONLY', 'FORMATTED', ' ', 0)
                 ! Now stop wildf finding a file.
                 fildef=' '
              else
                print*, 'Cannot file file of file names ', trim(fildef)
              end if
            else
              exit get_name
            end if       
          end do get_name
          ! Finally we can update the defination of the file extension.
          extdef=filext
        end if

        ! Now (at last) get the name of the file, allowing for wild cards.
        iostat=wildf_ext(fildef, extdef, imext_def, lastf, nxtfil, next_in)
        if (iostat == -1) then
          print*, 'The requested file is a FITS file with extensions.'
          print*, 'Please give the file name AND extension number.'
          goto 80
        end if
        goto 900

800     if (lunit .eq. 5) then
          nxtfil='END'
        else
          lunit=5
          goto 80
        end if
                                  
900     end subroutine inpprm


        integer function makark_1d(naxis, data, axdata)
                                                                       
!       Inputs.
!       The actual lengths of each axis for the data.
        integer :: naxis 
!       The data.    
        real, dimension (:) :: data
!       The axis scales. 
        real, dimension (:) :: axdata
                      
!       Locals.
        integer :: iunit, i, j

!       For writing ARK files.
        real, dimension(naxis) :: axis
        real :: rms
        double precision, dimension(10) :: coefs
        integer iorder
!       For the header
        character(len=8) :: key
        character(len=20) :: nodnam = 'XXXXXXXXXXXXXXXXXXXX'
        logical :: arknod
                                             
!       Functions called.
        logical, external :: arkgsm
        character(len=filnam_len), external :: addon

        if (inter_out) call pmtout(.true.)
        if (file_out.eq.'end' .or. file_out.eq.'END') then
          print*, 'WARNING:: NO output file written.'
          makark_1d=-1
          return
        end if
                                     
!       Add the ARK node to the header.
        if (nodnam .eq. 'XXXXXXXXXXXXXXXXXXXX') &
        arknod = arkgsm( 'ARK_NODE', nodnam)
        if (.not. arknod) then
          call rem_header('ARK_NODE')
        else          
          call put_header_s('ARK-NODE', nodnam, &
          'COMPUTER FILE CREATED ON',1)
        end if

!       Does the user want us to write errors?
        if (allocated(yerr_out)) itypef = 2
              
!       Clear out any misleading header items.
        call rem_header('NAXIS2')
        if (itypef == 2) then
          call arkopn(iunit, file_out, filex, 'NEW', 'OVERWRITE', &
          'FORMATTED', 'SEQUENTIAL', 0)
!         Now write the header
          j = 0
          do i=1, 180
            key = dross(i)(1:8)
            If ( Key .ne. 'SIMPLE  ' .and. Key .ne. 'REALTYPE' &
              .and. Key .ne. 'NAXIS   ' .and. Key .ne. 'NAXIS1  ' &
              .and. Key .ne. 'ARK-NODE' .and. Key .ne. 'END' ) Then
              j=j+1
              write(iunit, '(a65)') dross(i)(1:65)
            end if
            if (j .ge. 3) exit
          end do
!         And the data.
          if (allocated(yerr_out)) then
            do j=1, naxis
              write(iunit,*) axdata(j), data(j), yerr_out(j)
            end do
            deallocate(yerr_out)
          else
            do j=1, naxis
              write(iunit,*) axdata(j), data(j)
            end do
          end if
          close(iunit)
        else
          call arkopn(iunit, file_out, filex, 'NEW', 'OVERWRITE', &
          'UNFORMATTED', 'SEQUENTIAL', 0)
!         Let the user add comments.
          if (inter_out) call makcom(36)                  
!         Construct the header.
          call put_header_c('SIMPLE', 'T', 'ARK FILE', 1)
          call put_header_s('REALTYPE', 'IEEE', 'IEEE REALS', 1)
          call put_header_i('NAXIS', 1, 'ONE DIMENSIONAL', 1)
          call put_header_i('NAXIS1', naxis, 'NO OF DATA POINTS', 1)
!         Calculate the X-axis polynomial.
          rms = 0.01*(axdata(naxis)-axdata(1))/naxis
          do i=1, naxis
            axis(i)=axdata(i)
          end do
          iorder=9
          call ltcheb(axis, naxis, coefs, iorder, RMS)
          write(iunit) naxis, (dross(i), i=1, 36)
          write(iunit) (data(i), i=1, naxis)
          write(iunit) coefs
          close(iunit)
          itypef=1
        end if

        makark_1d=itypef
                
!       Reset inter.
        inter_out=.true.
        print*, 'Written file ', trim(file_out)

999     end function makark_1d


        integer function makark_2d(naxis, data, axdata)
                                                                       
!       Inputs.
!       The actual lengths of each axis for the data.
        integer, dimension(2) :: naxis
!       The data.
        real, dimension (:,:) :: data
!       The axis scales. 
        real, dimension (:,:) :: axdata
                      
!       Locals.
        integer :: iunit, i, j

!       For writing ARK files.
        real, dimension(naxis(1)) :: axis
        real :: rms
        double precision, dimension(10) :: coefs
        integer iorder
        character(len=8) :: key
        character(len=20) :: nodnam = 'XXXXXXXXXXXXXXXXXXXX'
        logical :: arknod
        logical :: oneD
        character(len=filnam_len) :: flgnam

!       Functions called.
        logical, external :: arkgsm
        character(len=filnam_len), external :: addon

        if (naxis(2)>1 .or. naxis(1)*naxis(2)==0) then
          oneD=.false.
        else
          oneD=.true.
        end if
        ! if (.not. ext_write) next_out=0
        if (inter_out .and. next_out==0) call pmtout(oneD)
        if (file_out.eq.'end' .or. file_out.eq.'END') then
          print*, 'WARNING:: NO output file written.'
          makark_2d=-1
          return
        end if

!       Add the ARK node to the header.
        if (nodnam .eq. 'XXXXXXXXXXXXXXXXXXXX') &
        arknod = arkgsm( 'ARK_NODE', nodnam)
        if (.not. arknod) then
          call rem_header('ARK_NODE')
        else          
          call put_header_s('ARK-NODE', nodnam, &
          'COMPUTER FILE CREATED ON',1)
        end if

        if (oneD) then
!         Clear out any misleading header items.
          call rem_header('NAXIS2')
          if (itypef .eq. 2) then
            call arkopn(iunit, file_out, filex, 'NEW', 'OVERWRITE', &
            'FORMATTED', 'SEQUENTIAL', 0)
!           Now write the header
            j = 0
            do i=1, 180
              key = dross(i)(1:8)
              If ( Key .ne. 'SIMPLE  ' .and. Key .ne. 'REALTYPE' &
                .and. Key .ne. 'NAXIS   ' .and. Key .ne. 'NAXIS1  ' &
                .and. Key .ne. 'ARK-NODE' .and. Key .ne. 'END' ) Then
                j=j+1
                write(iunit, '(a65)') dross(i)(1:65)
              end if
              if (j .ge. 3) exit
            end do
!           And the data.
            do j=1, naxis(1)
              write(iunit,*) axdata(j,1), data(j,1)
            end do
          else
            call arkopn(iunit, file_out, filex, 'NEW', 'OVERWRITE', &
            'UNFORMATTED', 'SEQUENTIAL', 0)
!           Let the user add comments.
            if (inter_out) call makcom(36)                  
!           Construct the header.
            call put_header_c('SIMPLE', 'T', 'ARK FILE', 1)
            call put_header_s('REALTYPE', 'IEEE', 'IEEE REALS', 1)
            call put_header_i('NAXIS', 1, 'ONE DIMENSIONAL', 1)
            call put_header_i('NAXIS1', naxis(1), 'NO OF DATA POINTS', 1)
!           Calculate the X-axis polynomial.
            rms = 0.01*(axdata(naxis(1),1)-axdata(1,1))/naxis(1)
            do i=1, naxis(1)
              axis(i)=axdata(i,1)
            end do
            iorder=9
            call ltcheb(axis, naxis(1), coefs, iorder, RMS)
            write(iunit) naxis(1), (dross(i), i=1, 36)
            write(iunit) (data(i,1), i=1, naxis(1))
            write(iunit) coefs
            close(iunit)
            itypef=1
          end if
        else
          if (next_out > 0) then         
            call arkopn(iunit, file_out, filex, 'OLD', 'OVERWRITE', &
            'UNFORMATTED', 'DIRECT', 2880)
          else
            call arkopn(iunit, file_out, filex, 'REPLACE', 'OVERWRITE', &
            'UNFORMATTED', 'DIRECT', 2880)
          end if
          if (inter_out .and. next_out==0) call makcom(180)
          if (allocated(pix_flg_out)) then
            flgnam=file_out
            i=index(flgnam, '.', .true.)
            if (i /= 0) flgnam(i:len(flgnam))=' '
            flgnam=trim(flgnam)//'.flg'
            call put_header_s('ARK-FLAG', flgnam, 'ASSOCIATED FLAG FILE', 1)
          end if
          call putfit(iunit, data, axdata, naxis)
          itypef=3
          if (allocated(pix_flg_out)) call makflg2(flgnam)                
        end if
        makark_2d=itypef

!       Reset inter.
        inter_out=.true.
        if (next_out > 0) then
          print*, 'Written file '//trim(file_out)//' extension ', next_out
        else
          print*, 'Written file '//trim(file_out)
        end if

999     end function makark_2d

                                               

        integer function makark_3d(naxis, data, axdata)
                                                                       
!       Inputs.
!       The actual lengths of each axis for the data.
        integer, dimension(3) :: naxis
!       The data.
        real, dimension (:,:,:) :: data
!       The axis scales. 
        real, dimension (:,:) :: axdata
                      
!       Locals.
        integer :: iunit, i, j
        logical oneD       

!       For writing ARK files.
        real, dimension(max(naxis(1),naxis(2),naxis(3))) :: axis
        real :: rms
        double precision, dimension(10) :: coefs
        integer iorder
        character(len=8) :: key
        character(len=20) :: nodnam = 'XXXXXXXXXXXXXXXXXXXX'
        logical :: arknod

!       Functions called.
        logical, external :: arkgsm
        character(len=filnam_len), external :: addon

        if (debug) then
          print*, '@ Entering makark_3d, with;'
          print*, '@    naxis being ', naxis(1), naxis(2), naxis(3)
          print*, '@    the shape of data being ', &
          size(data,1), size(data,2), size(data,3)
          print*, '@    and axdata being ', &
          size(axdata,1), size(axdata,2)
        end if
       

        if (naxis(2) .gt. 1) then
          oneD=.false.
        else
          oneD=.true.
        end if
        if (inter_out) call pmtout(oneD)
        if (file_out.eq.'end' .or. file_out.eq.'END') then
          print*, 'WARNING:: NO output file written.'
          makark_3d=-1
          return
        end if

!       Add the ARK node to the header.
        if (nodnam .eq. 'XXXXXXXXXXXXXXXXXXXX') &
        arknod = arkgsm( 'ARK_NODE', nodnam)
        if (.not. arknod) then
          call rem_header('ARK_NODE')
        else          
          call put_header_s('ARK-NODE', nodnam, &
          'COMPUTER FILE CREATED ON',1)
        end if
                           
        if (oneD) then
!         Clear out any misleading header items.
          call rem_header('NAXIS2')
          call rem_header('NAXIS3')
          if (itypef .eq. 2) then
            call arkopn(iunit, file_out, filex, 'NEW', 'OVERWRITE', &
            'FORMATTED', 'SEQUENTIAL', 0)
!           Now write the header
            j = 0
            do i=1, 180
              key = dross(i)(1:8)
              If ( Key .ne. 'SIMPLE  ' .and. Key .ne. 'REALTYPE' &
                .and. Key .ne. 'NAXIS   ' .and. Key .ne. 'NAXIS1  ' &
                .and. Key .ne. 'ARK-NODE' .and. Key .ne. 'END' ) Then
                j=j+1
                write(iunit, '(a65)') dross(i)(1:65)
              end if
              if (j .ge. 3) exit
            end do
!           And the data.
            do j=1, naxis(1)
              write(iunit,*) axdata(j,1), data(j,1,1)
            end do
          else
            call arkopn(iunit, file_out, filex, 'NEW', 'OVERWRITE', &
            'UNFORMATTED', 'SEQUENTIAL', 0)
!           Let the user add comments.
            if (inter_out) call makcom(36)                  
!           Construct the header.
            call put_header_c('SIMPLE', 'T', 'ARK FILE', 1)
            call put_header_s('REALTYPE', 'IEEE', 'IEEE REALS', 1)
            call put_header_i('NAXIS', 1, 'ONE DIMENSIONAL', 1)
            call put_header_i('NAXIS1', naxis(1), 'NO OF DATA POINTS', 1)
!           Calculate the X-axis polynomial.
            rms = 0.01*(axdata(naxis(1),1)-axdata(1,1))/naxis(1)
            do i=1, naxis(1)
              axis(i)=axdata(i,1)
            end do
            iorder=9
            call ltcheb(axis, naxis(1), coefs, iorder, RMS)
            write(iunit) naxis(1), (dross(i), i=1, 36)
            write(iunit) (data(i,1,1), i=1, naxis(1))
            write(iunit) coefs
            close(iunit)
            itypef=1
          end if
        else         
          call arkopn(iunit, file_out, filex, 'NEW', 'OVERWRITE', &
          'UNFORMATTED', 'DIRECT', 2880)
          if (inter_out) call makcom(180)
          call putfit_3d(iunit, data, axdata, naxis)
          itypef=3
        end if
        makark_3d=itypef
                
!       Reset inter.
        inter_out=.true.
        print*, 'Written file ', trim(file_out)

999     end function makark_3d


        subroutine putfit(iunit, data, axdata, naxis)
                                                             
        integer, dimension(2), intent(in) :: naxis(2)
        integer :: iunit
        real, intent(in), dimension(:,:) :: data, axdata
                                
!       Locals
        integer(kind=k4), dimension(2880/4) :: intblk
        real(kind=k4), dimension(2880/4) :: relblk
        character*50 wrkstr
        character(len=7) :: ark_fits_bswap
        logical, external :: arkgsm
        integer i, j, iblk, jblk, icount
!       For the axis information.
        double precision coefs(10)
        real :: rms, target_rms
        integer iorder
                                      
!       The header information.
        character(len=80), dimension(180) :: safe_dross

        real, dimension(max(naxis(1),naxis(2))) :: axis

!       Get the operating system name.
        if (.not. arkgsm('ARK_FITS_BSWAP', ark_fits_bswap)) ark_fits_bswap=' '

!       First few manditory key words.
        call put_header_c('SIMPLE', 'T', 'AN ARK_FITS FILE',1)
        call put_header_i('BITPIX', -32, '32 BIT REAL NUMBERS',1)
        call rem_header('REALTYPE')
        if (sum(naxis) > 0) then
          if (product(naxis) > 0) then
            call put_header_i('NAXIS', 2, 'NUMBER OF AXES',1)
          else
            call put_header_i('NAXIS', 1, 'NUMBER OF AXES',1)
          end if
        else
          call put_header_i('NAXIS', 0, 'NUMBER OF AXES',1)
        end if
                                                         
!       Write in the data size.
        if (naxis(1) > 0) then
          call put_header_i('NAXIS1', naxis(1), &
          'NUMBER OF PIXELS ALONG AXIS 1', 1)
        else
          if (naxis(2) > 0) then
            call put_header_i('NAXIS1', naxis(2), &
            'NUMBER OF PIXELS ALONG AXIS 1', 1)
          else
            call rem_header('NAXIS1')
          end if
        end if
        if (product(naxis) > 0) then
          call put_header_i('NAXIS2', naxis(2), &
          'NUMBER OF PIXELS ALONG AXIS 2', 1)
        else
          call rem_header('NAXIS2')
        end if

!       Check BSCALE and BZERO havn't crept in.
        call rem_header('BSCALE')
        call rem_header('BZERO')
        if (ext_write) then
          if (sum(naxis) == 0) then
            call put_header_c('EXTEND', 'T', 'File contains extensions.',1)
          else
            dross(1)="XTENSION= 'IMAGE   '           /"
          end if
        end if

        if (next_out > 0) dross(1)="XTENSION= 'IMAGE   '           /"
                                           
!       Now add an axis array.
        if (naxis(1) > 0) then
          iorder=1
          target_rms=abs(0.01*(axdata(naxis(1),1)-axdata(1,1))/naxis(1))
          rms=target_rms
          call ltcheb(axdata(1:naxis(1),1), naxis(1), coefs, iorder, RMS )
          if (rms > target_rms) &
          print*, 'Warning, fit to AXIS1 scale has RMS of ', RMS
          if (abs(coefs(2)) < tiny(coefs(2))) coefs(2)=1.0
          call put_header_d('CRVAL1', coefs(1)+coefs(2), '  ', 1)
          call put_header_d('CDELT1', coefs(2), '  ', 1)
          call put_header_r('CRPIX1', 1.0, ' ', 1)
        end if
        if (naxis(2) > 0) then
          iorder=1
          target_rms = abs(0.01*(axdata(naxis(2),2)-axdata(1,2))/naxis(2))
          rms=target_rms
          call ltcheb(axdata(1:naxis(2),2), naxis(2), coefs, iorder, RMS )
          if (rms > target_rms) &
          print*, 'Warning, fit to AXIS2 scale has RMS of ', RMS
          if (abs(coefs(2)) < tiny(coefs(2))) coefs(2)=1.0
          if (naxis(1) > 0) then
            call put_header_d('CRVAL2', coefs(1)+coefs(2), '  ', 1)
            call put_header_d('CDELT2', coefs(2), '  ', 1)
            call put_header_r('CRPIX2', 1.0, ' ', 1)
          else
            call put_header_d('CRVAL1', coefs(1)+coefs(2), '  ', 1)
            call put_header_d('CDELT1', coefs(2), '  ', 1)
            call put_header_r('CRPIX1', 1.0, ' ', 1)
          end if
        end if
      
        ! Now, if we are writing an extension, lets get to the end
        ! of the file.
        if (next_out > 0) then
          safe_dross=dross
          i=ext_skip(file_out, inter_out, iunit, next_out)
          inquire(iunit, nextrec=iblk)
          dross=safe_dross
        else
          iblk=1
        end if

        jblk=lndrss()
        if (mod(jblk,36) .eq. 0) then
          jblk=jblk/36
        else
          jblk=jblk/36 + 1    
        end if
        do i=iblk, iblk+jblk-1
          write (iunit,rec=i) (dross(j),j=(i-iblk+1)*36-35,(i-iblk+1)*36)
          if (debug) print*,'@ Written header block ', i
        end do

        if (naxis(1)>0 .or. naxis(2)>0) then
          icount=0
          inquire(iunit, nextrec=iblk)
          if (trim(ark_fits_bswap) == 'FALSE') then
            ! This is a system which does not need a byte swap.
            do j=1, max(naxis(2),2)
              do i=1, max(naxis(1),1)
                if (icount .eq. 2880/4) then
                  write (iunit, rec=iblk) relblk
                  if (debug) print*, '@ Written data block ', iblk
                  icount=0
                  iblk=iblk+1
                end if
                icount=icount+1
                relblk(icount)=data(i,j)
              end do
            end do
            write (iunit, rec=iblk) relblk
          else
            ! Have to byte swap (how tiresome).
            do j=1, max(naxis(2),1)
              do i=1, max(naxis(1),1)
                if (icount .eq. 2880/4) then
                  write (iunit, rec=iblk) intblk
                  if (debug) print*, '@ Written data block ', iblk
                  icount=0
                  iblk=iblk+1
                end if
                icount=icount+1
                call mvbits(transfer(data(i,j), 0_k4),  0, 8, intblk(icount), 24)
                call mvbits(transfer(data(i,j), 0_k4),  8, 8, intblk(icount), 16)
                call mvbits(transfer(data(i,j), 0_k4), 16, 8, intblk(icount),  8)
                call mvbits(transfer(data(i,j), 0_k4), 24, 8, intblk(icount),  0)
              end do
            end do
            write (iunit, rec=iblk) intblk
          end if
          if (debug) print*, '@ written last data block ', iblk
          if (debug) print*, '@ Test data point (1,1) = ', data(1,1)
        end if
              

!       Tidy up and exit.
900     close(iunit)
        end subroutine putfit


        subroutine putfit_3d(iunit, data, axdata, naxis)
                                                             
        integer naxis(3), iunit
        real, dimension(:,:) :: axdata
        real, dimension(:,:,:) :: data
                                
!       Locals     
        real(kind=k4), dimension(2880/4) :: relblk
        character*50 wrkstr
        character(len=7) :: ark_fits_bswap
        logical, external ::  arkgsm
        integer i, j, k, iblk, icount
!       For the axis information.
        double precision coefs(10)
        real rms
        integer iorder
                                      
        real, dimension(max(naxis(1),naxis(2),naxis(3))) :: axis

        if (debug) print*, '@ Entering putfit_3d.'
                            
!       Get the operating system name.
        if (.not. arkgsm('ARK_FITS_BSWAP', ark_fits_bswap)) ark_fits_bswap=' '
                                                  
!       First few manditory key words.
        call put_header_c('SIMPLE', 'T', 'AN ARK_FITS FILE',1)
        call put_header_i('BITPIX', -32, 'BIT REAL NUMBERS', 1)
        call rem_header('REALTYPE')
        call put_header_i('NAXIS', 3, 'NUMBER OF AXES',1)
                                                         
!       Check BSCALE and BZERO havn't crept in.
        call rem_header('BSCALE')
        call rem_header('BZERO')

!       Write in the data size.
        call put_header_i('NAXIS1', naxis(1), &
        'NUMBER OF PIXELS ALONG AXIS 1', 1)
        call put_header_i('NAXIS2', naxis(2), &
        'NUMBER OF PIXELS ALONG AXIS 2', 1)
        call put_header_i('NAXIS3', naxis(3), &
        'NUMBER OF PIXELS ALONG AXIS 3', 1)
                                           
        if (debug) print*, '@ Creating axis data.'

!       Now add an axis array.
        do j=1, 3
          do i=1, naxis(j)
            axis(i)=axdata(i,j)
          end do
          if (debug) print*, '@ Calling ltcheb.'
          iorder=1
          call ltcheb(axis, naxis(j), coefs, iorder, RMS )
          if (rms > 0.01*(axdata(naxis(j),1)-axdata(1,j))/naxis(j)) &
          print*, 'Warning, fit to AXIS', j, 'scale has RMS of ', RMS
          if (debug) print*, '@ Done with ltcheb.'
          if (j .eq. 1) then
            call put_header_d('CRVAL1', coefs(1)+coefs(2), '  ', 1)
            call put_header_d('CDELT1', coefs(2), '  ', 1)
            call put_header_r('CRPIX1', 1.0, ' ', 1)
          else if (j .eq. 2) then
            call put_header_d('CRVAL2', coefs(1)+coefs(2), '  ', 1)
            call put_header_d('CDELT2', coefs(2), '  ', 1)
            call put_header_r('CRPIX2', 1.0, ' ', 1)
         else if (j .eq. 3) then
            call put_header_d('CRVAL3', coefs(1)+coefs(2), '  ', 1)
            call put_header_d('CDELT3', coefs(2), '  ', 1)
            call put_header_r('CRPIX3', 1.0, ' ', 1)
          end if
        end do

        if (debug) print*, '@ About to write header.'

        iblk=lndrss()
        if (mod(iblk,36) .eq. 0) then
          iblk=iblk/36
        else
          iblk=iblk/36 + 1    
        end if
        do 110 i=1, iblk
          write (iunit,rec=i) (dross(j),j=i*36-35,i*36)
          if (debug) print*,'@ Written header block ', i
110     continue
        icount=0
        iblk=iblk+1
        do k=1, naxis(3)
          do j=1, naxis(2)
            do i=1, naxis(1)
              if (icount .eq. 2880/4) then
                write (iunit, rec=iblk) relblk
                if (debug) print*, '@ Written data block ', iblk
                icount=0
                iblk=iblk+1
              end if
              icount=icount+1
              relblk(icount)=data(i,j,k)
            end do
          end do
        end do
        write (iunit, rec=iblk) relblk
        if (debug) print*, '@ written last data block ', iblk
                                                             
        if (debug) then
          print*, '@ Test data point (1,1,1) = ', data(1,1,1)
        end if
              
!       Tidy up and exit.
900     close(iunit)
                    
        end subroutine putfit_3d



        subroutine makcom(lines)
                                
!       Allows the user to add comments.
                                        
        integer lines
                     
        character*79 outstr
        integer linmax, i
                      
        linmax=lndrss()
        if (linmax .ge. lines) goto 900
        linmax=lines-linmax
                           
        outstr='Enter comments below, up to     lines'// &
        ' (<68 letters/line) ...<CR> when finished.'
        write(outstr(29:31), '(i3)') linmax
140     write(*,*) outstr
        do 310 i=1, linmax
          outstr=' '
          Read( *, '(A79)', End = 900 ) outstr
          if (outstr .eq. ' ' ) goto 900
          call put_header_s('COMMENT', outstr, ' ', 0)
310     continue
                
900     end subroutine makcom

  subroutine pmtout(oneD)

! Passed variable.
  logical :: oneD

! Locals.
  character(len=78) :: outstr

! First read in the file name.
100  if (filex(1:1).ne.' ' .and. filex(1:1).ne.char(0)) then
    outstr='Give output file '// &
    '(".'//filex//'" is assumed, "?" gives help)>'
    call writen(outstr(1:53))
  else
    outstr='Give output file '//'("?" gives help)>'
    call writen(outstr(1:34))
  end if
  read (*,'(a)',end=980) file_out
  if (file_out(1:1) .eq. '#') then
    call arkcom(file_out(2:50))
    goto 100
  else if (file_out(1:1) .eq. '?') then
    print*, 'You are currently in MARARK Version 2.0.'
    print*, 'You can either;'
    print*, '    1) Give an output file name.'
    print*, '    2) Type "end" or EoF to exit without writing'
    print*, '       a file.'
    print*, '    3) Access the operating system by typing "#"'
    print*, '       followed by a command.'
    print*, '    4) Redisplay this help by typing "?".'
    print*, '    5) Give a new default file name extension by'
    print*, '       typing "EXT".'
    if (oneD) then
      print*, '    6) Force the next file written to be an'
      print*, '       ASCII file by typing "ASCII".'
      print*, '    7) Force the next file written to be an'
      print*, '       ARK file by typing "ARK".'
      if (itypef .eq. 2) then
        print*, 'The next file will be written in ASCII.'
      else
        print*, 'The next file will be written in ARK format.'
      end if
    else
      print*,'The next file will be written in ARK_FITS format.'
    end if
    if (filex(1:1).ne.' ' .and. filex(1:1).ne.char(0)) then
      print*, 'The default file name extansion is ', filex, '.'
    end if
    goto 100
  else if (file_out.eq.'ark' .or. file_out.eq.'ARK') then
    itypef=1
    goto 100
  else if (file_out.eq.'ascii' .or. file_out.eq.'ASCII') then
    itypef=2
    goto 100
  else if (file_out.eq.'ext' .or. file_out.eq.'EXT') then
110 call writen('Give new file name extension (<4 letters)>')
    read (*,'(a)',err=110, end=110) filex
    goto 100
  end if       

970 goto 990                      
                      
980 file_out='END'

990  end subroutine pmtout
                      
      
      integer function makflg(naxis, pix_flg)

        character, dimension(:,:) :: pix_flg
        integer, dimension(2) :: naxis

        naxis_pix_flg=naxis
        allocate(pix_flg_out(naxis(1),naxis(2)))
        pix_flg_out=pix_flg(1:naxis(1),1:naxis(2))

        makflg=0

      end function makflg


      subroutine makflg2(filnam)
      
        character, dimension(2880) :: relblk
        character(len=filnam_len) :: filnam
        integer :: iunit, i, iaxis1, iaxis2, icount, iblk
        character(len=80), dimension(36) :: header

        header=' '
        if (sum(naxis_pix_flg) > 0) then        
          header(1)='SIMPLE  =                    T /AN ARK_FITS FILE'
          header(2)='BITPIX  =                    8 /1 BYTE INTEGERS'
          header(3)='NAXIS   =                    2 /NUMBER OF AXES'
          header(4)=&
          'NAXIS1  =                  307 /NUMBER OF PIXELS ALONG AXIS 1'
          header(5)=&
          'NAXIS2  =                  356 /NUMBER OF PIXELS ALONG AXIS 2'
          header(6)='END'
          write(header(4)(25:30),'(i6.6)') naxis_pix_flg(1)
          write(header(5)(25:30),'(i6.6)') naxis_pix_flg(2)
        else
          header(1)='SIMPLE  =                    T /AN ARK_FITS FILE'
          header(2)='BITPIX  =                    8 /1 BYTE INTEGERS'
          header(3)='NAXIS   =                    0 /NUMBER OF AXES'
          header(4)=&
          'EXTEND  =                    T /File contains extensions'
          header(5)='END'
        end if
        
        if (next_out == 0) then
          call arkopn(iunit, filnam, ' ', 'replace', 'overwrite', &
          'unformatted', 'direct', 2880)
        else
          call arkopn(iunit, filnam, ' ', 'old', 'overwrite', &
          'unformatted', 'direct', 2880)
        end if

        if (next_out > 0) then
          header(1)="XTENSION= 'IMAGE   '           /"
          i=ext_skip(filnam, inter_out, iunit, next_out)
          inquire(iunit, nextrec=iblk)
        else
          iblk=1
        end if

        !if (debug) print*, 'Starting flag extension at block ', iblk
        write (iunit,rec=iblk) header
        icount=0
        iblk=iblk+1
        if (naxis_pix_flg(1)*naxis_pix_flg(2) > 0) then
          do iaxis2=1, naxis_pix_flg(2)
            do iaxis1=1, naxis_pix_flg(1)
              if (icount == 2880) then
                write(iunit, rec=iblk) relblk
                icount=0
                iblk=iblk+1
              end if
              icount=icount+1
              relblk(icount)=pix_flg_out(iaxis1,iaxis2)
            end do
          end do
          write (iunit, rec=iblk) relblk
        end if

        deallocate(pix_flg_out)

        close(iunit)
        
      end subroutine makflg2
      
      
      integer function inpflg(naxis, pix_flg, force_file)
      
        character, dimension(:,:), allocatable :: pix_flg
        integer, dimension(2) :: naxis
        character(len=*), optional :: force_file
        
        character, dimension(2880) :: relblk
        integer :: iunit, iaxis1, iaxis2, icount, iblk, i
        character(len=80), dimension(36) :: header
        character(len=8) :: arktyp
        logical :: there
        
        if (allocated(pix_flg)) deallocate(pix_flg)
        allocate(pix_flg(naxis(1),naxis(2)))

        if (present(force_file)) nxt_pix_file=force_file
        
        if (nxt_pix_file /= ' ') then
          call arkinq(nxt_pix_file, ' ', there, arktyp)
          if (there) then
            if (lext_in == 0) then
              print*, 'Reading pixel flag file ', trim(nxt_pix_file)
            else
              print*, 'Reading pixel flag file ', trim(nxt_pix_file), ' extension ', lext_in
            end if
            call arkopn(iunit, nxt_pix_file, ' ', 'old', 'readonly', &
            'unformatted', 'direct', 2880)
            i=ext_skip(nxt_pix_file, .false., iunit, lext_in)
            inquire(iunit, nextrec=iblk)
            read(iunit,rec=iblk) header
            icount=2880
            iblk=iblk+1
            do iaxis2=1, naxis(2)
              do iaxis1=1, naxis(1)
                if (icount == 2880) then
                  read(iunit, rec=iblk) relblk
                  icount=0
                  iblk=iblk+1
                end if
                icount=icount+1
                pix_flg(iaxis1,iaxis2)=relblk(icount)
              end do
            end do
            close(iunit)
            inpflg=1
          else
            pix_flg='O'
            inpflg=0
            print*, 'Warning, failed to find flag file ', trim(nxt_pix_file)
          end if
        else
          print*, 'Warning, no associated pixel flag file.'
          pix_flg='O'
          inpflg=0
        end if
        
        
      end function inpflg

       real function integer2(bytes)
 
        character, intent(in), dimension(2) :: bytes
 
        integer ndata
 
        ndata = ichar(bytes(2)) + 256*ichar(bytes(1))
        if (ndata > 32767) ndata=ndata-65536
        integer2=real(ndata)
 
     end function integer2

     integer function ext_skip(file, inter, iunit, skip_to)

       ! Skips to the beginning of extension skip_to.
       character(len=*), intent(in) :: file
       logical, intent(in) :: inter
       ! If the file is not open set the unit number to zero (otherwise 
       ! when fithed inquires iunit may be NaN.
       integer, intent(inout) :: iunit
       integer, intent(in) :: skip_to

       integer :: i, j, jblk, iblk, nbit, ifail, nax
       integer, dimension(2) :: naxis
       logical :: open

       character(len=80), dimension(180) :: safe_dross
       

       ext_skip=0

       if (skip_to > 0) then

          if (debug) print*, '@ Skipping to extension ', skip_to
          safe_dross=dross
          do j=0, skip_to-1
            if (debug) print*, '@    Extension ', j
            call fithed(file, inter, iunit, ifail)
            inquire(iunit, nextrec=iblk)
            if (debug) print*, '@    First data block ', iblk
            ! How many blocks of data?
            i=get_header_i('NAXIS', nax)
            if (nax == 0) then
              jblk=0
            else
              i=get_header_i('BITPIX', nbit)
              if (i <= 0) nbit=0
              i=get_header_i('NAXIS1', naxis(1))
              if (i <= 0) naxis(1)=0
              if (nax > 1) then
                i=get_header_i('NAXIS2', naxis(2))
                if (i <= 0) naxis(2)=0
              else
                naxis(2)=1
              end if
              nbit=naxis(1)*naxis(2)*(abs(nbit)/8)
              jblk=nbit/2880
              if (jblk*2880 /= nbit) jblk=jblk+1
              if (debug) print*, '@    Data ', nbit, ' bits and ', naxis(1), 'x', naxis(2)
            end if
            if (debug) print*, '@    Number of data blocks ', jblk
            ! Now read that block just to kick the inquire statement.
            if (debug) print*, '@ Which starts at block ', jblk+iblk
            read(iunit, rec=jblk+iblk-1)
          end do
          dross=safe_dross
        end if
         
      end function ext_skip

      integer function wildf_ext(fildef, extdef, imext_def, last_f_e, &
        lastfil, last_iext)

        ! Does the same job as wildf, but deals with extensions.

        character(len=*) :: fildef, lastfil
        character(len=2), intent(in) :: imext_def
        character(len=3) :: extdef
        logical :: last_f_e
        integer :: last_iext

        logical :: exist
        logical, save :: last_f
        character(len=8) :: arktyp
        integer :: ifail, iostat, iblk, iunit
        integer, save :: max_ext=0, jext
        character, dimension(2880) :: test
        character(len=filnam_len), save :: lastfil_safe


        wildf_ext=0

        if (max_ext == 0) then
          call wildf(fildef, extdef, last_f, lastfil_safe)
          ! Now lets find out how many extensions this new file has.
          ! Begin by assuming none.
          max_ext=0
          ! And that the next extension to be read is zero
          jext=0
          ! Find out if the file is a FITS file.
          call arkinq(lastfil_safe, extdef, exist, arktyp)
          if (arktyp == 'ARK_FITS') then
            if (imext_def == '--') then
              ! O.K., so does it have extensions?  Find this out by trying to
              ! read extension 1.  The file has not yet been opened so iunit is set to zero.
              iunit=0
              ifail=ext_skip(lastfil_safe, .false., iunit, 1)
              inquire(iunit, nextrec=iblk)
              read(iunit, rec=iblk, iostat=iostat) test
              close(iunit)
              if (iostat == 0) then
                ! O.K., the file has extensions, but non have been specified.
                wildf_ext=-1
              end if
            else if (trim(imext_def) == '*') then
              ! How many extensions are there?
              counting: do
                ifail=ext_skip(lastfil_safe, .false., iunit, max_ext+1)
                inquire(iunit, nextrec=iblk) 
                read(iunit, rec=iblk, iostat=iostat) test
                if (iostat /= 0) exit counting
                max_ext=max_ext+1
              end do counting
              close(iunit)
            else
              read(imext_def,*,iostat=iostat) max_ext
              ! And the next extension to read is this one.
              jext=max_ext
            end if
          end if
        end if

        ! The next extension to read is jext.
        last_iext=jext
        ! The next file to read is squirelled away in lastfil_safe
        lastfil=lastfil_safe
        ! Is this the last file and extension?  Start be assuming not.
        last_f_e=.false.
        ! But is this the last extension to be read?
        if (jext == max_ext) then
          ! Make sure we know next time to ask for a new file name.
          max_ext=0
          ! But will there be a next time?
          if (last_f) last_f_e=.true.
        end if
        jext=jext+1

      end function wildf_ext

end module ark_file_io
            
block data init_dross

  character(len=80), dimension(180) :: dross
  common /pasdrs/ dross
  data dross /'END', 179*' '/

end block data init_dross

      Subroutine LTCHEB( Y, Pix, Coef, Order, RMS )
      
       ! New version of ltcheb, where order on input is the maximum
       ! order to be fitted.

       Integer, Parameter :: maxM=9

       Integer, intent(in) :: Pix
       Real, intent(in), dimension(pix) :: y
       Double Precision, intent(out), dimension( 0: maxM ) :: Coef
       integer, intent(inout) :: order
       real, intent(out) :: RMS       
       
       Double Precision Add, Div, Mul
       Double Precision Gamma( 0: maxM ), Bj( 0: maxM )
       Double Precision Ssq1( 0: maxM ), E( 0: 1 )
       Double Precision Xi, Sx, Pw, BetaJ, Sum, Diff
       Double Precision Alpha( 0: maxM, 0: maxM ), Temp
       Real Test, ftRat( maxM )
       Integer Limit, I, J, J1, J2, K, Skip
C
       Double Precision LPPOLY
C
       Double Precision C( 0: maxM, -1: maxM )
c       ...C( I, J ) is the factor of X**I in Jth Tchebyceff polynomial
       Common / cheb / C
C
       Real Ftest( 9 )
       Data Ftest / 161.0, 18.5, 10.1, 7.71, 6.61,
     1                                          5.99, 5.59, 5.32, 5.12 /
C
       Limit = Min( maxM, Pix - 2, order)
       If( Limit .le. 0 ) Then
         Write( *, '('' Number of pixels is too small: '',I5)' ) Pix
         Return
       End If
       E( 1 ) = 1.0
       C( 0, -1 ) = 0.0
       C( 0, 0 ) = 1.0
       Mul = Real( Pix ) - 1.0
       If( Mul .eq. 0.0 ) Mul = 1.0
       Div = 1.0 / Mul
       Add = Mul - 1.0
       Skip = Pix / 100
       If( Skip .le. 0 ) Skip = 1
C
c       Section 1.  Calculate the polynomials for this data
c
       Do J = 0, Limit
         Gamma( J ) = 0.0
         Sx = 0.0
         Do I = 1, Pix, Skip
           Xi = ( I + Add ) * Div
           Pw = LPPOLY( J, Xi ) ** 2
           Gamma( J ) = Gamma( J ) + Pw
           Sx = Sx + Pw * Xi
         End Do
         If( J .le. 0 ) Then
           BetaJ = 0.0
         Else
           BetaJ = Gamma( J ) / Gamma( J - 1 )
         End If
         E( 0 ) = -Sx / Gamma( J )
         J1 = J - 1
         J2 = J + 1
         If( J2 .le. maxM ) Then
           Call LPRDCT( C( 0, J ), J, E, 1, C( 0, J2 ) )
           Do K = 0, J1
             C( K, J2 ) = C( K, J2 ) - C( K, J1 ) * BetaJ
           End Do
         End If
       End Do
c
c       Section 2.  Calculate the coefficients Bj
c
       Do J = 0, Limit
         Sum = 0.0
         Do I = 1, Pix, Skip
           Xi = ( I + Add ) * Div
           Sum = Sum + Y( I ) * LPPOLY( J, Xi )
         End Do
         Bj( J ) = Sum / Gamma( J )
       End Do
c
c       Section 3.  Calculate residuals and test for best order fit
c
       Do J = 0, Limit
         Ssq1( J ) = 0.0
       End Do
       Do I = 1, Pix, Skip
         Xi = ( I + Add ) * Div
         Sum = 0.0
         Do J = 0, Limit
           Sum = Sum + Bj( J ) * LPPOLY( J, Xi )
           Diff = Y( I ) - Sum
           Ssq1( J ) = Ssq1( J ) + Diff * Diff
         End Do
       End Do
       RMS = RMS * RMS
       Do J = 0, Limit
         K = Pix / Skip - J - 1
         Ssq1( J ) = Ssq1( J ) / K
         If( Ssq1( J ) .le. RMS ) Then
           Order = J
           Goto 350
         End If
         If( J .ge. 1 ) Then
           Test = ( Ssq1( J - 1 ) - Ssq1( J ) ) / Ssq1( J ) * K
           If( K .ge. 10 ) Then
             ftRat( J ) = Test / 5.0
           Else
             ftRat( J ) = Test / Ftest( K )
           End If
         End If
       End Do
       Do J = 1, Limit
         If( ftRat( J ) .ge. 1.0 ) Order = J
       End Do
       If( Order .ne. Limit ) Then
         Write( *, 337 ) Order
337       Format
     1    ( ' @ The fit does not improve with orders higher than ', I1 )
       Else
         Write( *, '('' * Failed to find a good fit !!!'')' )
       End If
350     Continue
       RMS = Sqrt( RMS )
c
c       Section 5. Calculate coefficients Coeff and associated errors
c
       Do J = 0, Order
         Coef( J ) = 0.0
         Do K = J, Order
           Coef( J ) = Coef( J ) + Bj( K ) * C( J, K )
         End Do
       End Do
       Do J = Order + 1, Limit
         Coef( J ) = 0.0
       End Do
C
C       convert back to the real data set
C
       Call LCNVRT( Alpha, maxM, -Add, Mul )
       Do J = 0, Order
         Temp = 0.0
         Do K = J, Order
           Temp = Temp + Alpha( K, J ) * Coef( K )
         End Do
         Coef( J ) = Temp
       End Do
C
C     END
C
       End
C
C
C
       Subroutine LPRDCT( A, M, B, N, P )
c
c       Makes the product of two polynomials
c       A( J ) * X ** J ( J = 0, M ) and B( K ) * X ** K ( K = 0, N )
c       and returns the result P( L ) * X ** L ( L = 0, M + N )
c                                       Koji, 10.1.84
C
       Integer M, N
       Double Precision A( 0:M ), B( 0:N ), P( 0:M+N )
C
       Integer J, K, L
       Integer MinA, MaxA
C
       Do L = 0, M + N
         P( L ) = 0.0
         MinA = Max( 0, L - N )
         MaxA = Min( L, M )
         Do J = MinA, MaxA
           K = L - J
           P( L ) = P( L ) + A( J ) * B( K )
         End Do
       End Do
C
       End
C
C
C
       Double Precision Function LPPOLY( J, X )
c
c       Tchebycheff polynomials with coefficient C
C
       Integer MaxM
       Parameter( MaxM = 9 )
C
       Integer J
       Double Precision X
C
       Integer K
       Double Precision Dummy
C
       Double Precision C( 0: maxM, -1: maxM )
       Common / cheb / C
C
       If( J .le. -1 ) Then
         LPPOLY = 0.0
       Else If( J .eq. 0 ) Then
         LPPOLY = 1.0
       Else
         If( X .eq. 0.0 ) Then
           LPPOLY = C( 0, J )
         Else
           Dummy = 0.0
           Do K = J, 0, -1
             Dummy = Dummy * X + C( K, J )
           End Do
           LPPOLY = Dummy
         End If
       End If
C
       End
C
C
C
       Subroutine LCNVRT( Alpha, Order, A0, A1 )
C
       Integer Order
       Double Precision Alpha( 0:Order, 0:Order )
       Double Precision A0, A1
c
       Double Precision B0, B1
       Integer I, J
C
       Do I = 0, Order
         Do J = 0, Order
           Alpha( I, J ) = 0.0
         End Do
       End Do
       B1 = 1.0 / A1
       B0 = -A0 * B1
       Alpha( 0, 0 ) = 1.0
       Do I = 1, Order
         Do J = 0, I - 1
           Alpha( I, J ) = Alpha( I, J ) + B0 * Alpha( I - 1, J )
           Alpha( I, J + 1 ) = Alpha( I, J + 1 )
     1                                          + B1 * Alpha( I - 1, J )
         End Do
       End Do
C
       End

       blockdata blknam
                 
        character file*100, filex*3, lstfil*100
        logical inter
        integer lastf
                     
        common /arknmc/ file, filex, lstfil
        common /arknmn/ inter, lastf
                                                 
c       Initialise file name and extension.
        data file /'          '/
        data filex /'   '/
                          
c       Interactive mode is to be used by default.
        data inter /.true./
                           
c       The default file type to be written is ARK.
        data lastf /1/
                      
        end

       Integer Function IDTYPE( )
C
C       Looks for an ARK header line `DATATYPE' and returns an integer
C              -1 if zero-dimensional
C              0 if DATATYPE line does not exist or Unknown type is used
C              1 for Counts file, 2 for error of counts
C              3 for F-lambda file, 4 for error of F-lambda
C              5 for F-nu file, 6 for error of F-nu
C
       Integer K
       Character Code
C
       Character*80 a_Header( 180 )
       Common / pasDrs / a_Header
C
       Do K = 1, 36
         If( a_Header( K )( 1: 8 ) .eq. 'DATATYPE' ) Then
           Code = a_Header( K )( 30: 30 )
           If( Code .eq. 'Z' ) Then
             IDTYPE = -1
           Else If( Code .eq. 'C' ) Then
             IDTYPE = 1
           Else If( Code .eq. 'E' ) Then
             IDTYPE = 2
           Else If( Code .eq. 'L' ) Then
             IDTYPE = 3
           Else If( Code .eq. 'F' ) Then
             IDTYPE = 4
           Else If( Code .eq. 'N' ) Then
             IDTYPE = 5
           Else If( Code .eq. 'G' ) Then
             IDTYPE = 6
           Else
             IDTYPE = 0
           End If
           Return
         End If
       End Do
       IDTYPE = 0
C
       End

real function rnd_gauss(mean, sigma)

  ! This replaces Koji's old Gaussian routine.  It produces much
  ! less structure.

  implicit none

  real, intent(in) :: mean, sigma
  real :: x
  real, save :: y
  logical, save :: odd=.true.

  if (odd) then
    call grnf(x,y)
    rnd_gauss=mean+sigma*x
    odd=.false.
  else
    rnd_gauss=mean+sigma*y
    odd=.true.
  end if


end function rnd_gauss

SUBROUTINE GRNF (X,Y)

  ! Two Gaussian random numbers generated from two uniform random
  ! numbers. Copyright (c) Tao Pang 1997.
  ! Minor change by Timn to use random_number

  IMPLICIT NONE
  REAL, INTENT (OUT) :: X,Y
  REAL :: PI,R1,R2,harvest

  PI = 4.0*ATAN(1.0)
  call random_number(harvest)
  R1 = -ALOG(1.0-harvest)
  call random_number(harvest)
  R2 = 2.0*PI*harvest
  R1 = SQRT(2.0*R1)
  X  = R1*COS(R2)
  Y  = R1*SIN(R2)

END SUBROUTINE GRNF

        subroutine arkinq(file, filex, exist, arktyp)

        implicit none
                                                     
!       Test to see if a file is there.  This is a SUN version.
                                                                    
!       Input values.
!       The file name, and the default extension to be used.
        character(len=*) :: file, filex
                                 
!       Returned values.
!       Logical for existance of file.
        logical :: exist
!       If possible, find out if the file is ARK, ASCII or ARK_FITS.
        character(len=*) :: arktyp
                            
        integer :: itest, iunit, iflag
        character(len=80) :: addon, work
!       The debugger.
        logical debug
        common /bug/ debug
                          
        arktyp=' '
        call unix_extend(file, work, iflag)
        if (debug) print*, '@ S/R ARKINQ thinks ', addon(work, filex)
        inquire(file=addon(work, filex), exist=exist)
!       Trap out what seems to be a bug in DEC FORTRAN inquires.
        if (addon(work, filex) .eq. ' ') exist=.false.
        if (exist) then
          call find_free(iunit)
          open(iunit, file=addon(work, filex), action='read', &
          form='unformatted', access='direct', recl=4, status='old')
!         Not using ARKOPN 'coz this is in system.a
          Read(iunit, rec=1, err=120) itest
!         An error means the file is formatted as opposed to unformatted.
!         ARK header is 2884 byte unformatted, sequential
!         UNIX appends a 4-byte number containing the record length.
          if (itest .eq. 2884) arktyp='ARK'
!         For DEC OSF/1
          if (itest .eq. 1347242323) arktyp='ARK_FITS'
!         For Solaris.
          if (itest .eq. 1397312848) arktyp='ARK_FITS'
120       if (debug) print*, '@ is of type ', arktyp
          if (debug) print*, '@ itest in s/r ARKOPN is ', itest
          close (iunit)
        else
          if (debug) print*, '@ Doesn''t exist.'
        end if
              
        end subroutine arkinq

       Subroutine RDAI_ERROR( Flag )
C
       Integer Flag
C
       If( Flag .eq. -1 ) Then
         Write( *, 101 )
101         Format( ' @ User request NOT to read a file' )
       Else If( Flag .eq. -2 ) Then
         Write( *, 102 )
102         Format( ' ERROR:: Input file not found in batch mode' )
       Else If( Flag .eq. -11 ) Then
         Write( *, 111 )
111         Format( ' ERROR:: Not an ARK file' )
       Else If( Flag .eq. -12 ) Then
         Write( *, 112 )
112         Format( ' ERROR:: Not a VAX (byte order) ARK file' )
       Else If( Flag .eq. -13 ) Then
         Write( *, 113 )
113         Format( ' ERROR:: Input FITS files is not one-dimensional' )
       Else If( Flag .eq. -14 ) Then
         Write( *, 114 )
114         Format
     &    (' ERROR:: Conflict in multiple definition of the data size')
       Else If( Flag .eq. -21 ) Then
         Write( *, 121 )
121         Format( ' ERROR:: Size of axis2 is not defined' )
       Else If( Flag .eq. -22 ) Then
         Write( *, 122 )
122         Format( ' ERROR:: Not a 1 dimensional file' )
       Else If( Flag .eq. -98 ) Then
         Write( *, 198 )
198         Format( ' ERROR:: This ASCII file too big' )
       Else If( Flag .eq. -99 ) Then
         Write( *, 199 )
199         Format( ' ERROR:: This ARK file is too big' )
       End If
C
       End

        logical function arkssm(symbol, value)
                                              
c       Sets a DCL global symbol.  Which is not possible in ULTRIX.
                                                                   
        character symbol*(*), value*(*)
                                       
       arkssm=.false.
               
        end

       Real Function RIPOLY( Argmnt, Coeff, Order )
C
       Integer Argmnt, Order
       Double Precision Coeff( 0: Order )
       Double Precision Dummy, Arg
       Integer I
C
       Arg = Argmnt
       Dummy = 0.0
       Do 100 I = Order, 0, -1
         Dummy = Dummy * Arg +  Coeff( I )
100     Continue
C
       RIPOLY = Dummy

       End

       subroutine ARK_USER( usrnam )
C
C       Tries to guess user's login name from his/her home directory
C
       character*( * ) usrnam
C
       character*64 hname
       integer l, slash, last
C
       call GETENV( 'HOME', hname )
       slash = 0
       last = 0
       do l = 1, 64
         if( hname( l: l ) .gt. ' ' ) then
           last = l
           if( hname( l: l ) .eq. '/' ) then
             slash = l
           end if
         end if
       end do
       if( slash .eq. 0 ) then
         usrnam = hname( 1: last )
       else
         usrnam = hname( slash + 1: last )
       end if
C
       end

        program subset

!       Outputs a subset of the input file.
!       Timn, January 1992.
!       Became almost trivial in Fortran 90, February 1998.

        use ark_file_io

        implicit none
 
        integer, dimension(2) :: naxis, ibeg, iend
        integer :: ndim
        real, allocatable, dimension(:,:) :: data, axdata
        character :: axch
        integer :: i, j, ifail, iostat, isafe
        real :: beg, end

        call setbug()
 
        print*, '* Enter "end" to exit program.'
        endless: do

          ifail=inpark(naxis, data, axdata)
          if (ifail == -1) exit endless
          if (naxis(2) == 1) then
            ndim=1
          else
            ndim=2
          end if

          iend(2)=1
          ibeg(2)=1
          prompt: do j=1, ndim
            axch='X'
            if (j .eq. 2) axch='Y'
            reader: do
              print*, '* The range of '//axch//' values is ', &
              axdata(1,j), ' to ', axdata(naxis(j),j)
              print*,'> Give the range of '//axch//' values required.'
              read (*,*,iostat=iostat) beg, end
              if (iostat == 0) exit reader
            end do reader
            ibeg(j)=minloc(abs(beg-axdata(1:naxis(j),j)),1)
            iend(j)=minloc(abs(end-axdata(1:naxis(j),j)),1)
            if (ibeg(j) > iend(j)) then
              isafe=iend(j)
              iend(j)=ibeg(j)
              ibeg(j)=isafe
            end if
          end do prompt

          print*, '* Will subset the ', &
          (iend(1)-ibeg(1)+1)*(iend(2)-ibeg(2)+1), ' points, with'
          explain: do j=1, ndim
            axch='X'
            if (j .eq. 2) axch='Y'
            print*, '* '//axch//' values ', axdata(ibeg(j),j), ' to ', &
            axdata(iend(j),j)
            print*, '* Pixels ', ibeg(j), ' to ', iend(j)
          end do explain

!         Correct the axis arrays.
          do i=1, 2
            do j=1, iend(i)-ibeg(i)+1
              axdata(j,i)=axdata(j+ibeg(i)-1,i)
            end do
          end do

!         A little array operation.
          naxis=iend-ibeg+1

          print*, 'Here'

          ifail=makark(naxis, data(ibeg(1):iend(1),ibeg(2):iend(2)), axdata)

          deallocate(data)
          deallocate(axdata)

        end do endless

        end program subset

       Subroutine SAVAI(X, Y, min, Pix, C, Order, Unit, of_Name, Flag)
C
C      Unit is ignored unless it is supplied as opened.
C
       use get_header

       implicit none

C      IUE is a logical which controls if IUE or ASCII files are 
c      written.
       Logical IUE
       Parameter ( IUE = .True. )
C
       Integer min, Pix, Order, Unit, Flag
       Real X( Pix ), Y( Pix )
       Double Precision C( 0: 9 )
       Character*50 of_Name
C
       Real RMS
       Integer n_Dross, length, I, J, K, in_Flag, iUnit
       Logical There
       Character Answer
C
       Character*80 Dross( 180 )
       Logical add_Comments
       Common / pasDrs / Dross
       Common / addCom / add_Comments
C
       Real RIPOLY
C
C      Is the Flag OK?
       If ( Flag.ne.1 .and. Flag.ne.2 ) Then
         print*, 'ERROR:: SAVAI was called with illegal flag ', Flag
         Flag = -1
          Return
        End if
              
       If( Unit .eq. 0 ) Unit = 98
       Inquire( Unit, Opened = There )
       If( There ) Then              ! Batch mode...simple
         If( Flag .eq. 1 ) Then       ! ARK file
           Call SAVE_AI_ARK( X, Y, min, Pix, C, Order, Unit )
           Return
         Else If( Flag .eq. 2 ) Then       ! ASCII/IUE file
           If (IUE) Call WRITE_IUE_HEADER( Unit, min, Pix )
           Do J = min, Pix
             Write( Unit, * ) X( J ), Y( J )
           End Do
           Close( Unit )
           Return
         End If
       End If
C
c       User can change his/her mind about the format.
       in_Flag = Flag
c       The default is ARK.
       If( in_Flag .ne. 1 .and. in_Flag .ne. 2 ) in_Flag = 1
       Do While( .True. )
         If( in_Flag .eq. 1 ) Then
c         ARK (provisional).
            If (IUE) then
             Call WRITEN
     1       ('Output ARK file name (or IUE or END or $ DCL_command) >')
            Else
             Call WRITEN
     1 ('Output ARK file name (or ASCII or END or $ DCL_command) >')
            End If
           Read( *, '(A50)' ) of_Name
           If( of_Name .eq. 'END' .or. of_Name .eq. 'end' ) Then
c             Abort.
             Write( *, '('' WARNING:: No output file written'')' )
             Flag = -1
             Return
            Else If( of_Name( 1: 1 ) .eq. '$' ) Then
C             Operating system command.
             Call arkcom( of_Name( 2: 50 ))
           Else If( (of_Name .eq. 'iue' .or. of_Name .eq. 'IUE')
     1        .and. IUE) Then
             If( Flag .eq. 1 ) Then
              Write( *, '('' Changing to IUE format'')' )
             Else
              Write( *, '('' Returning to IUE format'')' )
             End If
             in_Flag = 2
               Else If( (of_Name .eq. 'ascii' .or. of_Name .eq. 'ASCII')
     1        .and. .not. IUE) Then
             If( Flag .eq. 1 ) Then
              Write( *, '('' Changing to ASCII format'')' )
             Else
              Write( *, '('' Returning to ASCII format'')' )
             End If
             in_Flag = 2
           Else
             n_Dross = LNDRSS( )
             If( add_Comments ) Then
C               Add comments if flag is set.
                If( n_Dross .ne. 0 ) Then
                If(Dross( n_Dross ) .eq. 'END') n_Dross = n_Dross - 1
                End If
              If( n_Dross .le. 34 ) Then
                 Write( *, 140 ) 35 - n_Dross
140              Format(' * Enter comment below, up to ', I2, ' lines',
     1                    ' (<68 letters/line) ...<CR> when finished.' )
                I = n_Dross + 1
                Do While( I .lt. 36 )
                  Read( *, '(A70)', End = 150 ) Dross( I )( 12: 79 )
                  If( Dross( I )( 12: 79 ) .eq. ' ' ) Goto 150
                  Dross( I )( 1: 11 ) = 'COMMENT = '''
                  Do K = 80, 12, -1
                    If( Dross( I )( K: K ) .ne. ' ' .and.
     1                    Dross( I )( K: K ) .ne. Char( 0 ) ) Goto 145
                  End Do
145                  Continue
                  K = K + 1
                  Dross( I )( K: K ) = ''''
                  I = I + 1
                End Do
150                Continue
                Dross( I ) = 'END'
              Else If( n_Dross .eq. 35 ) Then
                Dross( 36 ) = 'END'
              End If
             End If
              call arkopn(iUnit, of_Name, ' ', 'new', 'overwrite',
     &             'unformatted', 'sequential', 0)
             Call SAVE_AI_ARK( X, Y, min, Pix, C, Order, iUnit )
             If( add_Comments ) Then
C               Clear the comments added to DROSS during SAVAI.
              Dross( n_Dross + 1 ) = 'END'
              Do I = n_Dross + 2, 36
                Dross( I ) = ' '
              End Do
             End If
             Return
           End If
         Else If( in_Flag .eq. 2 ) Then
C           ASCII/IUE (provisional).
            If (IUE) Then
             Call WRITEN
     1       ('Output IUE file name (or ARK or END or $ DCL_command) >')
            Else
             Call WRITEN
     1  ('Output ASCII file name (or ARK or END or $ DCL_command) >')
            End if
           Read( *, '(A50)' ) of_Name
           If( of_Name .eq. 'END' .or. of_Name .eq. 'end' ) Then
C             Abort.
             Write( *, '('' WARNING:: No output file written'')' )
             Flag = -1
             Return
            Else If( of_Name( 1: 1 ) .eq. '$' ) Then       ! DCL command
             Call arkcom( of_Name( 2: 50 ))
           Else If( of_Name .eq. 'ark' .or. of_Name .eq. 'ARK' ) Then
             If( Flag .eq. 2 ) Then
              Write( *, '('' Changing to ARK format'')' )
             Else
              Write( *, '('' Returning to ARK format'')' )
             End If
             in_Flag = 1
           Else
              call arkopn(iUnit, of_Name, ' ', 'new', 'overwrite',
     &             'formatted', ' ', 0)
             If (IUE) Call WRITE_IUE_HEADER( iUnit, min, Pix )
             Do J = min, Pix
              Write( iUnit, * ) X( J ), Y( J )
             End Do
             Close( iUnit )
             Return
           End If
         End If
       End Do
C
       End
C
C
C
       Subroutine WRITE_IUE_HEADER( Unit, min, Pix )
C
C       ARK/IUE version only
C
        use get_header

        implicit none

       Integer Unit, min, Pix
C
       Character*8 Key
       Integer K, L, Length

C
       Character*80 Dross( 180 )
       Common / pasDrs / Dross
C
       L = 0
       Length = LNDRSS( )
       Do K = 1, Length
         Key = Dross( K )( 1: 8 )
         If( Key .ne. 'SIMPLE  ' .and. Key .ne. 'REALTYPE'
     1       .and. Key .ne. 'NAXIS   ' .and. Key .ne. 'NAXIS1  '
     2       .and. Key .ne. 'ARK-NODE' .and. Key .ne. 'END' ) Then
           L = L + 1
           Write( Unit, 100 ) Dross( K )( 1: 65 )
100           Format( ' ! ', A65 )
C           Shouldn't need ' ', if opend c-ctrl=list.
         End If
         If( L .eq. 3 ) Goto 200
       End Do
c       If you get to here L is zero or 1.  Add some blank lines.
        If ( L .lt. 3 ) Write( Unit, * ) '!'
        If ( L .lt. 2 ) Write( Unit, * ) '!'
        If ( L .lt. 1 ) Write( Unit, * ) '!'
200       Continue
C
       End
C
C
C                      
       Subroutine SAVE_AI_ARK( X, Y, min, Pix, C, Order, Unit )
C
        use get_header

        implicit none

       Integer min, Pix, Order, Unit
       Real X( Pix ), Y( Pix )
       Double Precision C( 0: 9 )
C
       Character*80 out_Header( 36 )
       Character*8 Key, a_Node
       Integer length, J, K, L, N, IO_test, anode_Length
       Real RMS
       Double Precision Alpha( 0: 9, 0: 9 )
       Double Precision Add, Mul, Temp
C
       Character*80 Dross( 180 )
       Common / pasDrs / Dross

        integer, external :: arkgsm
C
       length = Pix - min + 1
C              Construct output header; first, compulsory header
       out_Header( 1 ) = 
     &  'SIMPLE  =                    A /ARK FILE'
       out_Header( 2 ) = 
     &  'REALTYPE=                    V /VAX REAL NUMBER'
       out_Header( 3 ) = 
     &  'NAXIS   =                    1 /ONE DIMENSIONAL'
       out_Header( 4 ) = 
     &  'NAXIS1  =                      /NO OF DATA POINTS'
       Write( out_Header( 4 )( 21: 30 ), '(I10)' ) length
       L = 4
       IO_Test = arkgsm( 'ARK_NODE', a_Node, anode_Length )
       If( IO_Test .eq. 1 ) Then
C         DCL symbol ARK_NODE defined.
          do j=1, 8
            if (a_Node(j:j).ne.' ' .and. a_Node(j:j).ne.char(0))
     &      anode_Length=j
          end do
         out_Header( 5 ) = 
     &    'ARK-NODE= ''                    /FILE CREATED AT'
         out_Header( 5 )( 12: anode_Length + 11 ) = 
     &    a_Node( 1: anode_Length )
         out_Header( 5 )( anode_Length + 12: anode_Length + 12 ) = ''''
         L = 5
       End If
       N = LNDRSS( )
C       Now, copy DROSS into out_Header.
       Do K = 1, N
         Key = Dross( K )( 1: 8 )
         If( Key .ne. 'SIMPLE  ' .and. Key .ne. 'REALTYPE'
     1              .and. Key .ne. 'NAXIS   ' .and. Key .ne. 'NAXIS1  '
     2              .and. Key .ne. 'BITPIX  ' .and. Key .ne. 'ARK-NODE'
     3          .and. Key .ne. 'END     ') Then
           L = L + 1
           If( L .le. 36 ) Then
             If( Dross( K )( 9: 9 ) .eq. '=' ) Then
              out_Header( L ) = Dross( K )
              Else If( Dross( K ) .eq. 'END' ) Then
                out_Header( L ) = Dross( K )
             Else
              out_Header( L ) = 
     &          'COMMENT = ''' // Dross( K )( 1: 68 ) // ''''
             End If
           Else
             L = L - 1
           End If
         End If
       End Do
       If( L .le. 35 .and. out_Header( L ) .ne. 'END' ) Then
         L = L + 1
         out_Header( L ) = 'END'
       End If
       Do K = L + 1, 36
         out_Header( K ) = ' '
       End Do
C              Now calculate C if necessary
       If( Order .eq. 0 ) Then              ! C unknown
         RMS = ( X( Pix ) - X( min ) ) / length * 0.01
         iorder=9
         Call LTCHEB( X( min ), length, C, Order, RMS )
       Else
         If( min .ne. 1 ) Then              ! starting pixel shifted
           Add = 1 - min
           Mul = 1.0
           Call LCNVRT( Alpha, 9, Add, Mul )
           Do J = 0, Order
             Temp = 0.0
             Do K = J, Order
              Temp = Temp + Alpha( K, J ) * C( K )
             End Do
             C( J ) = Temp
           End Do
         End If
       End If
       Write( Unit ) length, out_Header
       Write( Unit ) ( Y( J ), J = min, Pix )
       Write( Unit ) C
       Close( Unit )
C
       End
C
C
C
       Subroutine ARKIO_ADDCOM( Flag )

        implicit none

C
       Integer Flag       ! Add comments if Flag = 1, not if flag=0
C
       Logical add_Comments
       Common / addCom / add_Comments
C
       If( Flag .eq. 1 ) Then
         add_Comments = .True.
       Else
         add_Comments = .False.
       End If
C
       End

       block data

       Logical add_Comments
       Common / addCom / add_Comments
       Data add_Comments / .True. /

       end

        subroutine arkcom(string)

!       Spawns an operating system command.

!       This statement is needed for the NAG f95 compiler.
!       use f90_unix_proc
                                 
        character(len=*) :: string
                            
        call system(string)
                              
        end subroutine arkcom

        character*(*) function addon(ifname, ext)
                                                 
        character*(*) ifname, ext
                                 
                                 
       Integer Last, Dot, K, Len_1, Len_2, One
                                        
       Len_1 = Len( ifname )
       Len_2 = Len( Ext )
       Last = 0
       Dot = 0
c       Semi = 0
       Do K = 1, Len_1
         One = Ichar( ifname( K: K ) )
         If( One .eq. 47 ) Then
c                                   ! '/' End of Dir specification
           Dot = 0
         Else If( One .eq. 46 ) Then
c                                   ! '.' Extension if not Dir
           Dot = K
         Else If( One .gt. 32 ) Then
c                                   ! .not. ( ' ' End of file name )
           Last = K
         End If
       End Do
C
        addon=ifname
       if (Dot.eq.0 .and. ext(1:1).ne.' ' .and. ext(1:1).ne.char(0))
     &  addon = ifname( 1: Last ) // '.' // Ext
                                               
        end

       Subroutine FIND_FREE( f_Unit )
C
C       Subroutine to find a free unit number
C
       Integer f_Unit
C
       Logical There
C
       f_Unit = 11
       Inquire( Unit = f_Unit, Opened = There )
       Do While( There )
         f_Unit = f_Unit + 1
         Inquire( Unit = f_Unit, Opened = There )
       End Do
C
       End

#csh

setenv CMDDIR ~/CMDfit
setenv CMDOBJ  ${CMDDIR}/Obj
setenv CMDMOD  ${CMDDIR}/Mod
setenv CMDEXE  ${CMDDIR}/bin
setenv CMDDATA ${CMDDIR}/Data

# Use -i4 and -r4 on 64 bit machines.
# The if statement protects a startup of the ark from being overwritten for FC and FCC.
if ($?FC == 0) setenv FC  "/usr/local/bin/gfortran -fno-second-underscore -O2 -I$CMDMOD"
if ($?FCC == 0) setenv FCC "/usr/local/bin/gfortran -ggdb -fcheck=all -fno-second-underscore -fbounds-check -fbacktrace -I$CMDMOD"
setenv G95_ENDIAN LITTLE
setenv ARK_FITS_BSWAP TRUE

alias binup     $CMDEXE/binup  
alias subset    $CMDEXE/subset  
alias uncer     $CMDEXE/uncer
alias for_gaia  $CMDEXE/for_gaia  
alias grid      $CMDEXE/grid  
alias monte     $CMDEXE/monte  
alias tau2      $CMDEXE/tau2
alias sim       $CMDEXE/sim
alias iso       $CMDEXE/iso

#!csh

setenv FC "g95 -fno-second-underscore -O2 -I$CMDMOD"

rm $CMDOBJ/*.a $CMDOBJ/*.o $CMDMOD/*.mod $CMDEXE/*

cd Random
make -f random.make

cd ../System/Unix
make -f system.make
cd ..
make -f system.make

cd ../Cluster
make -f define_star.make

cd ../Code
make -f monte.make
make -f grid.make
make -f for_gaia.make
make -f tau2.make
make -f sim.make
make -f uncer.make
make -f iso.make

cd ../Images
make -f binup.make
make -f subset.make

cd ..
